/** $Id: EmdeonInitialClaimStatus.java,v 1.2 2012/03/26 22:58:27 vhahacpennet Exp $ */
package gov.va.med.hac.edi.extract.feeclaimstatus.feeFinal;


import gov.va.med.hac.edi.utils.jpa.JPAUtil;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.GnuParser;
import org.apache.commons.cli.HelpFormatter;
import org.apache.commons.cli.MissingOptionException;
import org.apache.commons.cli.Option;
import org.apache.commons.cli.OptionBuilder;
import org.apache.commons.cli.Options;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.File;

import java.text.SimpleDateFormat;

/**
 * import gov.va.med.domain.erepos.Claim;
import gov.va.med.domain.erepos.EntityAdtlId;
import javax.persistence.Query;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
**/

import javax.naming.ConfigurationException;

import javax.persistence.EntityManager;



/**
 * Performs the required Final Fee generation edits
 *
 * HAPE POR VA DO# 118-11-D-1009, TO#118-1009-0001; HARRIS
 *
 *
 */
public class Fee277FlatFileGeneration {
	// added 9/24/2013 to define whether load is full or incremental
	private static final String LOAD_OPT ="l";
	private static final String LOOK_BACK_START_DAY ="b";
	private static final String LOOK_BACK_END_DAY = "e";

    private static final String HELP_OPT = "h";
    private static final String CONFIG_OPT = "f";
    private static final String OUTPUT_OPT = "o";
    private static final String SENDER_ID_OPT = "s";
    /**
    private static final String QUARTERLY_OPT = "q";
    private static final String BEGIN_DATE = "b";
    private static final String END_DATE = "e";
    **/


    /** the class logger. */
    static final Logger LOGGER = LoggerFactory.getLogger(Fee277FlatFileGeneration.class);

    /** private constructor to prevent unneeded instance creation. */
    private  Fee277FlatFileGeneration() {
    }

    /**
     * Entry point for the Fee 277 Flat File Generation process. The JPA connection
     * configuration file name can be passed into this method which will override
     * the normal persistence.xml file found in the META-INF directory of the jar
     * file. <br>
     * <br>
     * <code>usage: FeeFinal -f &lt;file&gt; [-h] -o
     * &lt;outputdir&gt; [-q] -s &lt;senderid&gt;</code>
     *
     * @param args
     *           set of options where &lt;file&gt; is the full path name of the
     *           JPA configuration file.
     * @param iLookBackEndDays
     */
    @SuppressWarnings({ "unchecked", "unused" })
	public static void main(String[] args) {
        LOGGER.info("\n\n");
        LOGGER.info(
            "<<<<<<<<<<<<< Beginning Claim Status Creation <<<<<<<<<<<<<<");

        final int quarterYear = 90;
        EntityManager em = null;
        Options opts = getCliOptions();
        SimpleDateFormat datefmtr = null;

        try {
            CommandLineParser parser = new GnuParser();
            CommandLine line = parser.parse(opts, args);

            if (line.hasOption(HELP_OPT)) {
                printUsage(opts);
                System.exit(1);
            }

            File configfile = null;



            // -f option in command line args
            if (line.hasOption(CONFIG_OPT)) {
                configfile = JPAUtil.getJpaConfigFile(line.getOptionValue(
                            CONFIG_OPT));

// System.out.println("configFile is: " + configfile);


            }

            if (configfile != null) {

                em = JPAUtil.getEntityManager(configfile);

                if (em == null) {
                    throw new ConfigurationException(
                        "Unable to configure Entity Manager.");
                }
            }

            String outputDir = null;

            if (line.hasOption(OUTPUT_OPT)) {
                outputDir = line.getOptionValue(OUTPUT_OPT);
            }


            String senderId = null;


            if (line.hasOption(SENDER_ID_OPT)) {
                senderId = line.getOptionValue(SENDER_ID_OPT);
            }

            // LOAD_OPT
            // -l opt  either 'i' or 'f'
            String loadType = null;
            if (line.hasOption(LOAD_OPT)) {
               loadType = line.getOptionValue(LOAD_OPT);

               // check for entry and output error if not 'i' or 'f'.....
               // System.out.println("main() - loadType is: " + loadType);

               if((loadType.equalsIgnoreCase("i") || (loadType.equalsIgnoreCase("f")) )) {
            	   // System.out.println("GOOD LOAD TYPE: " + loadType);
               } else {
            	   // System.out.println("BAD LOAD TYPE: " + loadType);
             	   printUsage(opts);
               	   System.exit(1);
               }
            } else {	// no entry for load option
               	printUsage(opts);
            	System.exit(1);
            }

            // LOOK_BACK_DAYS
            // -b options  - must be numeric and greater than zero
            int iLookBackDays = 0;

            if(line.hasOption(LOOK_BACK_START_DAY)) {
            	String sTemp = "";


            	try {
            		sTemp = line.getOptionValue(LOOK_BACK_START_DAY);
            		Integer i = new Integer(sTemp);

            		if(i.intValue() < 0) {
            			printUsage(opts);
            			System.exit(1);
            		} else {
            			iLookBackDays = i.intValue();
            		}
            	}catch(Exception e) {
            		printUsage(opts);
            		System.exit(1);
            	}

             } else {	// no entry for load option
               	printUsage(opts);
            	System.exit(1);
            }

            int iLookBackEndDays = 0;
            if(line.hasOption(LOOK_BACK_END_DAY)) {
            	String sTemp = "";


            	try {
            		sTemp = line.getOptionValue(LOOK_BACK_END_DAY);


            		Integer i = new Integer(sTemp);

            		if(i.intValue() < 0) {
            			printUsage(opts);
            			System.exit(1);
            		} else {
            			iLookBackEndDays = i.intValue();
            		}
            	}catch(Exception e) {
            		printUsage(opts);
            		System.exit(1);
            	}

             } else {	// no entry for load option
               	printUsage(opts);
            	System.exit(1);
            }


            // int x = 0;

            ProcessFee277FlatFileGeneration pecs = new  ProcessFee277FlatFileGeneration();
            // what is the significance of senderId????

            // add load option load to args....
            // process   (loadType, clearinghouseId, filePath, entityManager, iLookBackDays, iLookBackEndDays)
            pecs.process(loadType,  senderId,        outputDir, em,           iLookBackDays, iLookBackEndDays);

        } catch (MissingOptionException moe) {
            printUsage(opts);
        } catch (IllegalArgumentException iae) {
//            System.out.println(iae.getMessage());
            printUsage(opts);
        } catch (Throwable t) {
// System.out.println("main() - error: " + t.getMessage());
			t.printStackTrace();
            LOGGER.error("main() - Unable to Create Fee Claim Status file.", t);
        } finally {
            if ((em != null) && em.isOpen()) {
                em.close();
            }

            LOGGER.info(
                "<<<<<<<<<<<<< Ending Claim Status Creation <<<<<<<<<<<<<<");
        }
    }

    static final void printUsage(Options opts) {
        final int helpwidth = 80;
        HelpFormatter fmtr = new HelpFormatter();
//        System.out.println();
        fmtr.printHelp(helpwidth, "Fee 277 Flat File Generation", "", opts, "", true);
    }

    /**
     * Helper method to populate command line options objects.
     *
     * @return the <code>Options</code> object containing the set of command line
     *         option.
     */
    @SuppressWarnings("static-access")
    static Options getCliOptions() {
        Options options = new Options();



        Option help = OptionBuilder.withLongOpt("help")
                .withDescription("Print this message.")
                .create(HELP_OPT);

        Option configfile = OptionBuilder.withArgName("file").isRequired()
                                         .hasArg().withLongOpt("configfile")
                                         .withDescription("The EntityManager Configuration file.")
                                         .create(CONFIG_OPT);

        Option outputdir = OptionBuilder.withArgName("outputdir").isRequired()
                                        .hasArg().withLongOpt("outputDir")
                                        .withDescription("The CSTAT Output directory.")
                                        .create(OUTPUT_OPT);

        Option senderId = OptionBuilder.withArgName("senderid").isRequired()
                                       .hasArg().withLongOpt("senderId")
                                       .withDescription("The Sender's Identification.")
                                       .create(SENDER_ID_OPT);

        Option loadType = OptionBuilder.withArgName("loadType").isRequired()
                .hasArg().withLongOpt("loadType")
                .withDescription("The EntityManager load type: must be 'i' for incremental load or 'f' for full load")
                .create(LOAD_OPT);

        Option lookBackStartDay = OptionBuilder.withArgName("lookBackStartDay").isRequired()
                .hasArg().withLongOpt("lookBackStartDay")
                .withDescription("The number of days to BEGIN looking back for records to be processed. Must be numeric with 0 equals today, 1 equals yesterday etc....")
                .create(LOOK_BACK_START_DAY);

        Option lookBackEndDay = OptionBuilder.withArgName("lookBackEndDay").isRequired()
                .hasArg().withLongOpt("lookBackEndDay")
                .withDescription("The number of days to look back for records to be processed added to lookback start day. Must be numeric with 0 equals today.")
                .create(LOOK_BACK_END_DAY);




        options.addOption(help);
        options.addOption(configfile);
        options.addOption(outputdir);
        options.addOption(senderId);
        options.addOption(loadType);
        options.addOption(lookBackStartDay);
        options.addOption(lookBackEndDay);

        return options;
    }




}
