package gov.va.med.hac.edi.extract.feeclaimstatus.feeFinal;


import gov.va.med.domain.fppsowner.Claim;
import gov.va.med.domain.erepos.DemographicInfo;
import gov.va.med.domain.erepos.EntityName;
import gov.va.med.domain.fppsowner.PersonInfo;
import gov.va.med.hac.edi.utils.StringUtils;

import org.hibernate.ScrollMode;
import org.hibernate.ScrollableResults;
import org.hibernate.Session;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;

import java.math.BigDecimal;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Timestamp;
// import java.sql.Wrapper;
import java.text.SimpleDateFormat;

import java.util.ArrayList;
// import java.util.Arrays;
import java.util.Calendar;
// import java.util.Collection;
import java.util.Date;
import java.util.GregorianCalendar;
// import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityTransaction;
// import javax.persistence.PersistenceException;
import javax.persistence.Query;

/**
 *
 * HAPE POR VA DO# 118-11-D-1009, TO#118-1009-0001; HARRIS
 *
 * @author Bill Blackmon
 * @version R1.0.0
 *
*/

class ProcessFee277FlatFileGeneration {

	boolean DEBUG = false;


    static final Logger LOGGER = LoggerFactory.getLogger( ProcessFee277FlatFileGeneration.class);

//TODO: RESET FOR PRODUCTION TO 1000
    static final int BATCH_SIZE = 1000;
    static final int MAX_RECORDS = 5000;		// USED FOR TESTING

    private static final String PAYER_ID = "VAFEE";			// was VA FEE before it was VAFEE before it was VA FEE.......
    private static final String TRADING_PARTNER_ID = "VAFNH";

    static final String DEFAULT_NULL = "";
    static final String DEFAULT_ZERO = "0.00"; 		// created 8/22 - per Jeff Neibauer change request
    static final String CRLF = "\r\n";
    static final String DELIMITER = "|";
    static final boolean REQUIRED = true;
    static final boolean OPTIONAL = false;

    java.sql.Timestamp runTimestamp;
    String hdrRunTime;

    EntityManager em;
    boolean dailyCstat;
    boolean bInClaim = true;
    String ereposClaimKey = "";
    String fileNbr = "";
    String st02CtlNbr = "";
    String billPrvdId = "";
    String sbcrId = "";
    String claimType = "";
    String statusCd="";
    String currentDate = "";
    String currentTime = "";
    
    String strFileTime = "";

    // B.B. - new variables for fpps claim class
    long claimKey;
    String ediClaimKey = "";
    String sClaimKey = "";
    String statusCode = "";
    String claimStatusCategoryCode="";					// holds F values for fee payment status


    int claimsRecordCount = 0;				// running total of claims in loop used in batch processing
    int cnt = 0;
    int rejCnt = 0;
    int accCnt = 0;
    int curFileNumber = 0;

    String sysdatetime = null;
    int writtenRecordCount = 0;


    int batchUpdateCount = 0;


    PaymentDataExtraction paymentDataExtraction = new PaymentDataExtraction();

    // multi-file global variables
    File csFile = null;
    String filePath = "";

    String loadType = null;

// TEST SIZES......
// 24 records = file size of 26404
/** FROM SPEC.
 * Maximum single file size should not exceed 500 MB. In other words
there can be multiple files in a file group where each file in the group is less than or equal to 500 MB,
but the combined size for the file group has no limitation.
 */

/**
 * Change - 11/15 per A.J. Magdub
 * Per AJ Magdub we would like to limit the CSTAT file size to Max Size: 150mg & Cut Off:  130 mg.
 * If you can have an update to me on Monday 11/19 COB, that will be fine.
 * It can be a separate install package.  Well install the regular install and then run the application.
 */
    // ORIGINAL VALUES
    
	static final long MAX_FILE_SIZE = 150000000;
	static final long CUT_OFF_FILE_SIZE = 130000000;
	
    // test values
	/**
	static final long MAX_FILE_SIZE = 15000;
	static final long CUT_OFF_FILE_SIZE = 13000;
	**/


	long fileSize=0;
    long headerSize=0;
    long trailerSize=0;
    long detailSize=0;
    long cumulativeDetailSize=0;
    PrintWriter vCsFile = null;

    // row count - incremented at each output line EXCEPT header and footer - added 6/14/2013 -
    int rowCount = 2;

    // File Group Count- Identifies the total number of files within the file group.
    int fileGroupCount=1;							// increment with new file
    // Identifies the position of the file within the file group. Numbers must be consecutive so that the max sequence number equals the file group count.
    int fileGroupSequenceNumber=0;					// increment with each new file

    // start days to look back from command line args
    int iLookBackDays = 1;
    // end lookback days from command line args
    int iLookBackEndDays;

    // File Group ID- Links multiple files of the same type together into one load. All files in the same load must have the same File Group ID.
    String fileGroupID="";

    // date-time for updateWrittenRecord()
    String updateDateTime = "";

    Connection conn;
	PreparedStatement pStatement;



	 /**
	  * @author Bill Blackmon
	  * @since 12/3/2013
	  * Writes leftover records that were left over from batch process
	  */
	 private void writeOrphanedRecords()  {


		 boolean DEBUG = false;

		 try {
			 pStatement.executeBatch() ;
			 conn.commit();
		}catch(Exception e) {
				if(DEBUG) {
					System.out.println("writeOrphanedRecords() - ERROR WRITING ORPHAN RECORDS: " + e.getMessage());
				}
				LOGGER.error("writeOrphanedRecords() - error writing orphaned records");
	  	        LOGGER.error(e.getMessage(), e);

  			}
	 }



	 /**
	  * Top level method to setup connection for reference throughout app......test
	  * @author Bill Blackmon
	  * @since 11/27
	  * @return boolean
	  */
	 @SuppressWarnings("deprecation")
	private void setupPreparedStatement() {

		String sqlInsert = "insert into FPPS_OWNER.STG_277(CLAIM_INDEX, CLAIM_STATUS_CD, CREATED_BY, DATE_CREATED, MODIFIED_BY, DATE_MODIFIED) values(?, ?, ?, ?, ?,?)";

		// set runtime Timestamp for insert statement
		this.runTimestamp = new java.sql.Timestamp(Calendar.getInstance().getTime().getTime());


	 	try {
	 		 Session session = (Session) em.getDelegate();
			 conn = session.connection();

			 pStatement = conn.prepareStatement(sqlInsert);

			 conn.setAutoCommit(false);
		 }catch (SQLException sqlEx) {
	    	  LOGGER.error("setupPreparedStatement() sqlException - ERROR: " + sqlEx.getMessage());
		 } catch(Exception e) {
			 LOGGER.error("setupPreparedStatement() Exception - ERROR: " + e.getMessage());
		 }
	 }

    /**
     * to do:
     * put header and footer on EACH file, numbering starts over on each output file
     *
     * Creates a new output file
     * @param filePath variable read from command line args
     * @return File
     */
    private File createNewOutputFile(String filePath) {

    	 File csFile = null;
    	 
    	 try {
    		 Calendar cal = new GregorianCalendar();
    		 String currentDate = "";
    		 String currentTime = "";
    		 // @SuppressWarnings("unused")
			 // java.util.Date date = cal.getTime();
    		 SimpleDateFormat transDate = new SimpleDateFormat("yyyyMMdd");
    		 SimpleDateFormat transTime = new SimpleDateFormat("HHmmss");

    		 currentDate = transDate.format(cal.getTime());
    		 currentTime=transTime.format(cal.getTime());
    		 
    		 // create class level variable for currentDate + currentTime to be used in writeHDR() for field 4 - called strFileTime
    		 this.strFileTime = currentDate + currentTime;
    		 
    		 // CHANGED TO UPPER-CASE 9/10/2013
    		 String fileName = currentDate + currentTime + "_" +  "VAFEE" + ".cstat";

    		 // increment output items.....
    		 this.fileGroupCount++;
    		 this.fileGroupSequenceNumber++;

    		 csFile = new File(filePath + fileName);

    		 curFileNumber++;

    	 }catch(Exception ex) {
	    	  LOGGER.error("Error on createNewOutputFile(), UNABLE TO CREATE NEW OUTPUT FILE - CURRENT fileGroupCount is: ",  this.fileGroupCount);
	          LOGGER.error(ex.getMessage(), ex);
    	 }

    	 return csFile;
    }	// end createNewOutputFile()




    /**
     * @author Bill Blackmon
     * @param sender Id	clearinghouseId
     * @param filePath	path of output file
     */
    @SuppressWarnings({ "unused", "unchecked" })
	final void processClaimStatus(String chId, String filePath) {


        boolean DEBUG = false;

        try {

        	this.filePath = filePath;

            this.cnt = 0;

            Calendar cal = new GregorianCalendar();
            java.util.Date date = cal.getTime();
            SimpleDateFormat transDate = new SimpleDateFormat("yyyyMMdd");
            SimpleDateFormat transTime = new SimpleDateFormat("HHmmss");


            SimpleDateFormat updateTransDate = new SimpleDateFormat("yyyy-MM-dd");
            SimpleDateFormat updateTransTime = new SimpleDateFormat("HH:mm");

            // use this variable to insert into updateWrittenRecord()..................
            String updateTime = "";

             // this is used in updateWrittenRecord() insert statement
            updateDateTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());	// must be :mm - not :mi

             // put single quotes around updateDateTime for Oracle
            final String SINGLE_QUOTE = "'";
            updateDateTime = SINGLE_QUOTE + updateDateTime + SINGLE_QUOTE;


            // setup the preparedStatement to be used in batch updating
            setupPreparedStatement();

            Session session = (Session) em.getDelegate();

            String qstr = "";

            ScrollableResults claims = null;




              	// get session handle
               	session = (Session) em.getDelegate();

			// NEW SQL - 12/5
				 String sqlSelectAll = " SELECT  /*+ INDEX (c edi_cliam_key_uk1) INDEX (e claim_idx3) */ c.*   FROM fpps_owner.claims c , e_repos.claim e  " +
              			" WHERE " +
               			" e.claim_key = c.edi_claim_key " +										// param b													// param e
              			" and c.claim_status_cd = 'COMPLETE' and (sysdate-c.date_modified) <= " + this.iLookBackDays + "  and (sysdate-c.date_modified) >= " + this.iLookBackEndDays + " " +
              			" and not exists (SELECT 1 FROM fpps_owner.stg_277 s WHERE s.claim_index = c.claim_index and s.claim_status_cd = 'SENT')";

				 
if(DEBUG)	{
	System.out.println("processClaimStatus() cmd args are b: " + this.iLookBackDays + ", e: " + this.iLookBackEndDays);
	System.out.println("processClaimStatus() - generated SQL is: " + sqlSelectAll);
	System.out.println("returned record count is: " + getAvailableRecords());
}
              	org.hibernate.Query claimQuery = session.createSQLQuery(sqlSelectAll).addEntity(Claim.class);
    			claims = claimQuery.scroll(ScrollMode.FORWARD_ONLY);

             // start loop for processing claims in the claims resultset
             if (claims != null) {

                this.csFile = createNewOutputFile(filePath);

                this.vCsFile = new PrintWriter(new FileOutputStream(csFile));
                
                createHdrRec(this.vCsFile);
                
                createPrimaryDetailRec(claims, session, this.vCsFile);

                createTrlRec(this.vCsFile);

// clean up and close references
                this.vCsFile.flush();
                this.vCsFile.close();

// clear statement and close connection
                pStatement.close();
                conn.close();


                LOGGER.info("Claim Status File is Successfully Created!!!");


// END OF PROCESS
if(DEBUG) {
	 getNow();
}


            }	// end if
        } catch (Exception ex) {
			System.out.println("processClaimStatus()() - ERROR: " + ex.getMessage());
			ex.printStackTrace();
			LOGGER.error("processClaimStatus() - Unable to create CSTAT, errored on Claim Key: {}",  this.claimKey);
			LOGGER.error(ex.getMessage(), ex);
			System.exit(1);
      }

}	// end processClaimStatus() END OF APP

    /**
     *
     * @return java.sql.Timestamp for use in JDBC
     * @author Bill Blackmon
     * @since 11/27/2013
     */
    /**
    private static java.sql.Timestamp getCurrentTimeStamp() {
        java.util.Date today = new java.util.Date();
        return new java.sql.Timestamp(today.getTime());
    }
    **/

    /**
     * Called to update written record after it has been written
     * using non-Hibernate JDBC
     * @author DNS   BLACKW
     * @param Claim indexid
     * @sinced 11/27/2013
     */
     @SuppressWarnings("deprecation")
	private void updateWrittenRecordJDBC(String claimIndexId) {



    	 boolean DEBUG = false;

    	// TEST BATCH INSERT FIRST......
    	 try {


 				// fill in parameters
				pStatement.setLong(1, new Long(claimIndexId).longValue());				// CLAIM_INDEX what is the Oracle value here?
				pStatement.setString(2,"SENT");											// CLAIM_STATUS_CD
				pStatement.setString(3, "FinalFee277FlatFile");							// CREATED_BY
				pStatement.setTimestamp(4, this.runTimestamp);							// DATE_MODIFIED
				pStatement.setString(5, "FinalFee277FlatFile");							// MODIFIED_BY
				pStatement.setTimestamp(6,getCurrentTimeStamp());						// DATE_CREATED - MUST BE CONSTANT FROM TOP OF RUN.....

				pStatement.addBatch();
				
	            if (this.cnt % this.BATCH_SIZE == 0) {
					pStatement.executeBatch();
	                conn.commit();

// TEST - CHECK DATA VIA TOAD TO BE SURE IT'S VISIBLE AFTER COMMIT.....
	                batchUpdateCount++;


	                if(DEBUG)
	                {
	                	// LOGGER.info("updateWrittenRecordJDBC() - batch UPDATE END at: " + getNow());
	                }
	            }	// end if

	     	 } catch (OutOfMemoryError e) {
	     		 LOGGER.error("updateWrittenRecordJDBC() Out Of Memory Error !!!!!", e);
    	      try {
    	    	  conn.rollback();
    	      }catch(Exception rback) {
    	    	  if(DEBUG) {
     	    	  }
   	  			  LOGGER.error(e.getMessage(), e);
   	  	          LOGGER.error("updateWrittenRecordJDBC() - FAILED transaction rolled back");
    	      }
    	 }catch(SQLException exSQL) {
    		 try {
    			 conn.rollback();
    			 if(DEBUG) {
    			 }
				LOGGER.error(exSQL.getMessage(), exSQL);
				LOGGER.error("App 1 - updateWrittenRecordJDBC() - FAILED transaction rolled back");

    		 } catch(Exception e) {
    			if(DEBUG) {
    		 	}
 	  	        LOGGER.error(e.getMessage(), e);
 	  	        LOGGER.error("App 1 - updateWrittenRecordJDBC() - FAILED transaction rolled back");
    		 }


    	 } catch(Exception ex) {
    		 	if(DEBUG) {
     		 	}
	  	  	  	LOGGER.error("updateWrittenRecordJDBC(), errored on Claim Key: {}",  claimIndexId);
	  	        LOGGER.error(ex.getMessage(), ex);
	  	        LOGGER.error("updateWrittenRecordJDBC() - transaction rolled back for claim: " + claimIndexId);
    	 }

     }	// end updateWrittenRecordJDBC()



    /**
     * Called to update written record after it has been written
     * @author DNS   BLACKW
     * @param Claim indexid
     */
    @SuppressWarnings("unused")
	private void updateErroredClaim(long claimIndexId) {

// declare transaction
    	EntityTransaction txUpdateDatabase = em.getTransaction();

    	String SINGLE_QUOTE = "'";

        Query q;
        List<?> l;
        Iterator<?> it;
        String tmp = "";

        // this is used in updateWrittenRecord() insert statement
        String updateNow = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());	// must be :mm - not :mi

         // put single quotes around updateDateTime for Oracle
         updateNow= SINGLE_QUOTE + updateNow + SINGLE_QUOTE;

         /**
          * This.UpdateTime should be the time of the run = date_created

updateNow should  be date_modified

          */
        String sqlInsert =
       		 " insert into FPPS_OWNER.STG_277 (claim_index, claim_status_cd, created_by, date_modified, modified_by, date_created) " +
       		 " values (" + claimIndexId + ", 'ERROR', 'FinalFee277FlatFile', " +
       		 " to_date(" + updateNow + ",'yyyy-mm-dd hh24:mi:ss'), 'FinalFee277FlatFile',  to_date(" + this.updateDateTime + ",'yyyy-mm-dd hh24:mi:ss'))";

               try {

// begin transaction
txUpdateDatabase.begin();


// TODO - ENABLE executeUpdate()
this.em.createNativeQuery(sqlInsert).executeUpdate();

// run transaction

txUpdateDatabase.commit();


                    } catch(Exception ex) {
							// rollback transaction
						  txUpdateDatabase.rollback();
                          LOGGER.error("updateErroredClaim(), errored on Claim Key: {}",  claimIndexId);
                          LOGGER.error(ex.getMessage(), ex);
                          LOGGER.error("updateErroredClaim() - transaction rolled back for claim: " + claimIndexId);
                    }

       }	// end of updateErroredClaim







    /**
    * Called during  Fee 277 Flat File Generation
    * Set EntityManager
    * Set senderId/clearinghouseId
    * Set output file path
    * @author Bill Blackmon
    * @param clearinghouseId id of clearinghouse
    * @param filePath	path of output file
    * @param entityManager EntityManager to configure database access
     * @param iLookBackDays
    * @
    */

    // pecs.process(loadType, senderId, outputDir, em, iLookBackDays, iLookBackEndDays);
    final void process(String loadType, String clearinghouseId, String filePath, EntityManager entityManager, int iLookBackDays, int iLookBackEndDays) {

    	if(loadType != null) {
    		this.loadType = loadType;
    	}

    	this.iLookBackDays = iLookBackDays;
    	this.iLookBackEndDays = iLookBackEndDays;

    	this.hdrRunTime = setHdrRunTime();


        // LOGGER.debug("processing with clearinghouseId: {}  filePath: {} ", clearinghouseId, filePath);  Calendar cal = new GregorianCalendar();

        // 'yyyy-mm-dd hh colon mi'

        SimpleDateFormat fmt = new SimpleDateFormat("yyyy-MM-dd hh:mm");

        try {
        	java.util.Date today = new java.util.Date();

        	long t = today.getTime();
        	java.sql.Date dt = new java.sql.Date(t);


        	String datestr001 = (new java.sql.Date(today.getTime())).toString();

        	String todayStr = fmt.format(today);
//       	System.out.println("todayStr value: " +todayStr);

		 	this.sysdatetime = todayStr;

//       System.out.println("process() - current Date and Time is: " + sysdatetime.getTime());
        } catch(Exception ex) {
        	System.out.println("process() error: " + ex.getMessage());

        }


        this.dailyCstat = false;				// no date range
        this.em = entityManager;

        paymentDataExtraction.setEntityManager(entityManager);

        processClaimStatus(clearinghouseId, filePath);
    }



    private void setFinalizedCodes() {

    	int availableDetails = 0;
    	int paidDetails = 0;

    	// clear these values upon entry and reset in code
    	this.claimStatusCategoryCode="F0";
    	this.statusCode="1";



// 6/26/2013 - SAME - unchanged 7/11/2013
    	String sLinesAvailable =
    	    	"select count(*) from fpps_owner.claim_procedure cp where  cp.claim_index = " + this.sClaimKey;

    	// 7/17
    	String sLinesPaid = "select count (distinct claim_proc_id) from claim_proc_recon where claim_index = " + this.sClaimKey + " and paid_amount > 0";


			try {
				Query qLinesAvailable = em.createNativeQuery(sLinesAvailable);
				// fails with 87String sLinesPaid = "307869
				BigDecimal x = (BigDecimal) qLinesAvailable.getSingleResult();
				if(x != null) {
					availableDetails = x.intValue();
				} else {
// System.out.println("setFinalizedCodes(): - availableDetails is NULL....");
				}
//				System.out.println("setFinalizedCodes(): - Count of AVAILABLE detail lines: " + availableDetails);
			} catch(Exception ex) {
				System.out.println("setFinalizedCodes() ERROR: " + ex.getMessage());
				ex.printStackTrace();
		  	  	LOGGER.error("Error on setFinalizedCodes(), errored on Claim Key: {}",  this.claimKey);
		        LOGGER.error(ex.getMessage(), ex);
			}



// System.out.println("setFinalizedCodes() - sLinesPaid is: " + sLinesPaid);
			try {
				Query qLinesPaid = em.createNativeQuery(sLinesPaid);
				BigDecimal y = (BigDecimal) qLinesPaid.getSingleResult();

				if(y != null) {
					paidDetails = y.intValue();
				} else {
// System.out.println("setFinalizedCodes(): -paidDetails is NULL....");
				}
// 	System.out.println("setFinalizedCodes() - count of PAID detail lines: " + paidDetails);
			} catch(Exception ex2) {
				ex2.printStackTrace();
		  	  	LOGGER.error("Error on setFinalizedCodes(), errored on Claim Key: {}",  this.claimKey);
		        LOGGER.error(ex2.getMessage(), ex2);
			}


/**
 * F0 Finalized/Payment-The claim/line has been paid. - Paid lines count == available lines count
 * I think the highest priority would be to get a new 277FeeFlatFile that addresses Anne Debackers concern below.
 * The value of 1 should be used only if NOT paid, so only for F0 or F2.
 *
 * 65 is only used for a paid (F1).
 * Also improved mapping file that states the oracle table, column, value used to drive the 277FeeFlatFile piece.

F0 - MIXED - 1 STATUS CODE FOR NOW
F1 - ALL PAID - STATUS CODE = 65
F2 - NONE PAID - 1 STATUS CODE FOR NOW
**/


/**
 * 6/17/2013
 * 'defect' issue from Jeffrey Neinhaus:
 * 'TC POR2-1, Run 1, All CLM/STC pairs have status code of F1 regardless of
 * whether the claim was rejected or not. Expected to see Status Category Code of F2 for all rejected claims in the
 * batch and F0 for all claims with rejected lines.
 *

 **/

/**
 * New notes from John S., 6/26
 * For the CLM level, if all lines are F1, then CLM level is F1 / 65 For CLM level, if all lines are F2,
 * then CLM level is F2 / 1 If there are a combination of F1 and F2 lines, then the CLM level is F0 / 1
 */


	// none paid
	if( (availableDetails > 0) && (paidDetails == 0) ) {
		// System.out.println("setFinalizedCodes() - NO BILLS PAID for: " + this.sClaimKey);
		this.claimStatusCategoryCode="F2";
		this.statusCode="1";
	}

	// all paid
	if(availableDetails == paidDetails) {
// System.out.println("setFinalizedCodes() - ALL BILLS PAID for: " + this.sClaimKey);
		this.claimStatusCategoryCode="F1";
		this.statusCode="65";

	}

	// some paid - mixed
	if( ( (availableDetails > 0) && (paidDetails > 0) ) && (availableDetails > paidDetails) ) {
		this.claimStatusCategoryCode="F0";
		this.statusCode="1";
	}


	if(this.claimStatusCategoryCode.equalsIgnoreCase(""))  {

		// System.out.println("setFinalizedCodes() - claimStatusCategoryCode IS NULL");
	}

}	// end setFinalizedCodes()







	private StringBuffer append(StringBuffer sb, String value) {
        sb.append(value);
        sb.append(DELIMITER);

        return sb;

    }

	/***
	 * @author Bill Blackmon
	 * @since 7/23/2013
	 * @return String curFileNumber
	 */
	String getGetCurFileNumber() {

		return String.format("%02d",curFileNumber);
	}


	public String setHdrRunTime() {
		 Calendar cal = new GregorianCalendar();
		 // @SuppressWarnings("unused")
		// java.util.Date date = cal.getTime();
		 SimpleDateFormat transDate = new SimpleDateFormat("yyyyMMdd");
		 SimpleDateFormat transTime = new SimpleDateFormat("HHmmss");

		 String strDate = transDate.format(cal.getTime());
		 String strTime = transTime.format(cal.getTime());

		 String strDateTime = strDate+strTime;

		 return strDateTime;
	}

	/**
	 * Write header row - no data access required
	 * Size=126 bytes
	  Date formats changed 5/20/2013
	  
	 Compromise solution: 12/9/2013:
	  A proposed solution is to send each file as a single file, not part of a file group.  
	  The staff at Emdeon believes they will be able to process these files effectively.
	  This would mean that in the HDR record for each file created, the File Group ID would be unique, CCYYMMDDHHMMSS, 
	  when the file is created.

	  Also, field 3 File Group Sequence Number, would be set to 1, 
	  and field 4 File Group Count would be set to 1 for all files generated by any given run of the Fee Final Status file process.

      The physical files are all named uniquely as, CCYYMMDDHHMMSS_FEE Final Status.cstat, where CCYYMMDDHHMMSS is defined when the file is initially created.


	 * @param vCsFile
	 */
    final void createHdrRec(PrintWriter vCsFile) {

		 Calendar cal = new GregorianCalendar();
		 // @SuppressWarnings("unused")
		// java.util.Date date = cal.getTime();
		 SimpleDateFormat transDate = new SimpleDateFormat("yyyyMMdd");
		 SimpleDateFormat transTime = new SimpleDateFormat("HHmmss");

		 String strDate = transDate.format(cal.getTime());
		 String strTime = transTime.format(cal.getTime());

		 String strDateTime = strDate+strTime;

        StringBuffer sbHdrRec = new StringBuffer();

// 1    Record ID
        sbHdrRec.append("HDR"); //Record ID  - TWP: Changed to 3 char for 5010
        delimit(sbHdrRec);

// 2	File Group ID
        // this.runTimestamp
        // yyyymmddhhmmss
         // changed to global date - will be same for each header..........if there's more than one.

        // 12/9 - make same as file name.......
        // set to same value as time value on file name.....
        
        sbHdrRec.append(this.strFileTime);
        delimit(sbHdrRec);

// 3    File Group Sequence Number  CURRENT FILE (1 of...)
         // sbHdrRec.append(getGetCurFileNumber());
        // changed on recommendation of A.J. Magdub 12/5
        sbHdrRec.append("1");	// final - 12/9
        delimit(sbHdrRec);

// 4 	File Group Count - total number of output files - UNKNOWN AT RUN TIME.....
        // changed to "1" from "01" on recommendation of A.J. Magdub....12/5
        // changed back to 01 as passed by IV/V 12/6
        sbHdrRec.append("1"); //File Group Count - looks like we are not using the whole file group concept
        delimit(sbHdrRec);

// 5	Creation Date
        sbHdrRec.append(strDate); //Creation Date 8 chars yyyyMMdd
        delimit(sbHdrRec);
        //sbHdrRec.append(this.currentTime); //Creation Time 6 chars HHmmss

// 6	Creation Time
        sbHdrRec.append(strTime); //Creation Time 6 chars HHmmss
        delimit(sbHdrRec);

// 7	Trading Partner Id
        sbHdrRec.append(TRADING_PARTNER_ID);
        delimit(sbHdrRec);

// 8	Submitter name
        sbHdrRec.append("VA FEE BASIS Program"); //Submitter Name  - TWP: is this correct? NO....VA FEE BASIS
        delimit(sbHdrRec);


//    Move Contact Local VAMC to position 9, position 10 will be null
// 9	Payer Contact Name
        sbHdrRec.append("Contact Local VAMC"); //  - TWP: is this correct? NO....VA FEE BASIS
        delimit(sbHdrRec);

// Contact Local VAMC  Move Contact Local VAMC to position 9, position 10 will be null

        // swap next 2 - look at pending for conf.
// 10   Payer Support Telephone Number
        sbHdrRec.append("");
        delimit(sbHdrRec);

        // sbHdrRec.append("Contact Local VAMC"); //Payer Support Telephone Number

// 11	Payer Support Email Address
        // delimit(sbHdrRec);
        sbHdrRec.append(""); //PayerSupport Email
        delimit(sbHdrRec);

// 12   Load Type - value should be "I", 7/1, Anne DeBacker


/**
 * 1)      FEE Final Status  add an ability to create a FULL file (LOAD TYPE field in HDR record and 30 in Maintenance Type Code field in CLM records).  Bill Blackmon is working on this now.
 */
        if (this.loadType.equalsIgnoreCase("i")) { //Load type - full or incremental
            sbHdrRec.append("I");
         } else {
            sbHdrRec.append("F");
         }

        delimit(sbHdrRec);

// System.out.println("createHdrRec() - loadType out is: " + sbHdrRec.toString());



// 13   Payer Unique File Identifier
        sbHdrRec.append(StringUtils.rPadSpaces(strDateTime + "_VAFEE", 20)); //Payer Unique File Identifier
        delimit(sbHdrRec);

// 14   File Type
        sbHdrRec.append("CStat"); //File Type - TWP updated for 5010 but spec does not make sense max len = 4 but value must = Cstat which is 5 long?
        delimit(sbHdrRec);

// 15   Version Code
        sbHdrRec.append("03"); //Version Code TWP updated from 02 to 03
        delimit(sbHdrRec);

// 16   Release Code
        sbHdrRec.append("00"); //Release Code
        sbHdrRec.append(CRLF); //Record Teminator new for 5010


// System.out.println("HEADER - FINAL LINE IS: " + sbHdrRec.toString());


        this.headerSize=sbHdrRec.length();

        vCsFile.print(sbHdrRec); //TWP Changed to print rather than println since I am explicitly adding CRLF

        vCsFile.flush();


        sbHdrRec = null;
    }


    /**
     *
     * This method validates a claim index id against a corresponding EREPOS schema edi claim index id
     * Rough draft, 6/27/2013
     *
     * @author Bill Blackmon
     * @since 6/27/2013
     * @param claimIndexId
     * @param ediClaimIndexId
     * @return boolean
     */
    private boolean validateEreposClaim(long claimIndexId) {
    	boolean DEBUG = false;

    	boolean bRetVal = true;
    	EntityTransaction txUpdateDatabase = em.getTransaction();
    	Query q;
	    List<?> l;
	    Iterator<?> it;
	    int count = 0;

	    String sqlGetEdiClaims = "select count(*) from fpps_owner.claims c, e_repos.claim cc where c.edi_claim_key = cc.claim_key and c.claim_index = " + claimIndexId;

// System.out.println("validateEreposClaim() - sql is: " + sqlGetEdiClaims);


       	try {

if(DEBUG) {
	System.out.println("\nvalidateEreposClaim() TOP time is....");
	getNow();
}

       					      q = this.em.createNativeQuery(sqlGetEdiClaims);
       					      l = q.getResultList();
       					      it = l.iterator();


       					      Object row = (BigDecimal) it.next();

		  				      if(row != null) {

		  				        	String tmp = row.toString();
		  				        	count = new Integer(tmp).intValue();

// System.out.println("validateEreposClaim() - EDI claims count is: " + count);

		  				      }

       					      if(count == 0) {
// System.out.println("validateEreposClaim() - NO CORRESPONDING EREPOS RECORD for claimIndexId: " + claimIndexId);
								bRetVal = false;
       					      }
       			    	} catch(Exception ex) {
       			    		bRetVal = false;
       			    		System.out.println("validateEreposClaim() ERROR: " + ex.getMessage());
       			  			ex.printStackTrace();
       			  	  	  	LOGGER.error("validateEreposClaim(), errored on Claim Key: {}",  claimIndexId);
       			  	        LOGGER.error(ex.getMessage(), ex);
       			    	}

if(DEBUG) {
	System.out.println("\nvalidateEreposClaim() END time is....");
	getNow();
}

       	return bRetVal;
       }	// end of validateEreposClaim()



	/**
     * Loop through claims results and write out detail record
     * @author Bill Blackmon
     * @param claims
     * @param session
     * @param vCsFile
     */

    @SuppressWarnings({ "unused", "unchecked", "rawtypes" })
	final void createPrimaryDetailRec(ScrollableResults claims, Session session, PrintWriter vCsFile) {

    	boolean DEBUG = false;


        int count = 0;
       
        String seqNumber = "";
        boolean bContinueLoop = true;

        StringBuffer sbDtlRec = new StringBuffer();		// set length value to 0 NOT null at end of method

        String sStartDate="";
		String sEndDate="";

        /**
           Fields that can be set to null (empty String) according to Mary S. email 3/20/2013
            Field 6  Billing Provider Payer Assigned Numbercan set to null
			Field 13  Service Provider Payer Assigned Numbercan set to null
			Field 19  Employer Identification Numbercan set to null
			Field 20  Employer Namecan set to null
			Field 43 - Voucher Identifiercan set to null
			Field 45  Group Numbercan set to null.

         */
        	ArrayList erroredKeys = new ArrayList();

// MAIN RECORDS LOOP
while (claims.next()) {
        				// clear previous entries in PaymentDataExtraction...
        			   this.paymentDataExtraction.clearAll();


				       Claim claim = (Claim) claims.get(0);
				       long l  = claim.getClaimIndex();
					   Long L = new Long(l);
					   this.sClaimKey = L.toString();
					   this.claimKey = l;

// DO NOT EDIT THIS STATEMENT
					   this.ediClaimKey = claim.getEdiClaimKey();

					   this.cnt++;
					   this.bInClaim = true;


						String reposStr = "Select e from eClaim e where e.claimKey = :ediClaimKey";


						gov.va.med.domain.erepos.Claim reposClaim = null;

try {

							if(DEBUG) {
								System.out.println("\nCreatePrimaryDetailRec() - calling getting eReposClaimInfo  at....");
								getNow();
							}
								Query qErepos = em.createQuery(reposStr);



								qErepos.setParameter("ediClaimKey", this.ediClaimKey);

								// use this claim to handle information from e_repos schema
								reposClaim = (gov.va.med.domain.erepos.Claim) qErepos.getSingleResult();


									// if above is successful, get properties below......
									if(reposClaim != null ) {


// THESE VALUES ARE NECESSARY FOR INHERITED CODE TO FUNCTION CORRECTLY - DO NOT DELETE AT THIS POINT, B.B. - 6/27 - Demographic, Person Info uses these values,
//  #41 - Patient Account Number uses info,
										this.ereposClaimKey = reposClaim.getClaimKey();

										this.fileNbr = reposClaim.getFileNumber();

										this.st02CtlNbr = reposClaim.getSt02txnCtlNbr();

										this.billPrvdId = reposClaim.getNm109billPrvdId();

										this.sbcrId = reposClaim.getSubscriberId();

										this.claimType = reposClaim.getClaimType();

										this.statusCd = reposClaim.getStatusCode();

									}

setFinalizedCodes();


//TODO insert this method for testing
// paymentDataExtraction.setProviderInfo(this.sClaimKey);	// NOT USED AS OF 12/4 - leave in here until code is finalized.
paymentDataExtraction.setBillingProviderInfo(this.sClaimKey);
paymentDataExtraction.setServiceProviderInfo(this.sClaimKey);
paymentDataExtraction.setEmdeonClaimNumber(this.sClaimKey);
paymentDataExtraction.setClaimChargePaymentAmounts(this.sClaimKey);
paymentDataExtraction.setClaimAdjudicationPaymentDate(this.sClaimKey);
paymentDataExtraction.setCheckDateAndNumber(this.sClaimKey);
paymentDataExtraction.setPharmacyPrescriptionNumber(this.sClaimKey);
//moved from paymentDataExtraction.getDetailRecords()......11/25
paymentDataExtraction.setServiceTypeCode(this.sClaimKey);
//moved from paymentDataExtraction.getDetailRecords()......12/2
paymentDataExtraction.setServiceQualifierID(this.sClaimKey);



/********************************************** START OF OUTPUT SECTION ********************************************************************/

// START CLAIM SECTION HERE
// #1 - Record ID
					// StringBuffer sbDtlRec = new StringBuffer();
					sbDtlRec.append("CLM"); //Record ID - 3 long in 5010
					delimit(sbDtlRec);



// #2 - row count - B.B. - changed 6/14/2013

					sbDtlRec.append(formatOutputString(Integer.toString(this.rowCount),  REQUIRED, 1, 10, StringFormat.LPADZERO)); // rowCount
					this.rowCount++;

// #3 - Payer Id
					sbDtlRec.append(PAYER_ID);
					delimit(sbDtlRec);


// #4 - Maintenance Type Code
// HERE - CHANGE BASED ON COMMAND LINE ARG 'loadType'.............
// from spec: For Full Loads the Maintenance Type Code value will always be 030 for all records.
//

					if (this.loadType.equalsIgnoreCase("i")) {
						sbDtlRec.append("021");
					} else {
						sbDtlRec.append("030");
					}

					delimit(sbDtlRec);

				//  #5 Billing Provider Federal Tax ID
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getBillingProviderFederalTaxID(), OPTIONAL, 1, 60, null));


				// #6 Billing Provider Assigned Payer Number
				sbDtlRec.append(DEFAULT_NULL);
				delimit(sbDtlRec);




				// #7 Billing Provider National Provider ID : changed to length 60 from 35
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getBillingProviderNationalProviderID(), OPTIONAL, 1, 60, null));


				// #8 Billing Provider Last Name
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getBillingProviderLastName(), OPTIONAL, 1, 60, null));


				// #9 Billing Provider First Name TWP: changed to length 35 from 25 - field = nm104fst_nm
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getBillingProviderFirstName(), OPTIONAL, 1, 60, null));


				// #10 Billing Provider Middle Name TWP: added this element
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getBillingProviderMiddleName(), OPTIONAL, 1, 60, null));


				// #11 Billing Provider Name Suffix
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getBillingProviderNameSuffix(), OPTIONAL, 1, 25, StringFormat.RPADSPACES));

// END OF BILLING PROVIDER NAME INFORMATION


// Start of Service Provider Information.


//#12 Service Provider Federal Tax ID
// Expect SP Fed Tax ID (field 12) to be blank if the same as the Billing Provider Tax ID field 5
// String sID = paymentDataExtraction.getServiceProviderFederalTaxID();

				sbDtlRec.append(formatOutputString(paymentDataExtraction.getServiceProviderFederalTaxID(), false, 1, 50, StringFormat.RPADSPACES));



//#13 Service Provider Payer Assigned Number - default to "" in code
// Request - 8/22 - default to 0.....
				sbDtlRec.append(DEFAULT_NULL);
				delimit(sbDtlRec);



				//#14 Service Provider National Provider ID
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getServiceProviderNationalProviderID(), false, 1, 20, StringFormat.RPADSPACES));


				// #15 Service Provider Last Name (or Org Name)
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getServiceProviderLastName(), false, 1, 60, StringFormat.RPADSPACES));

				// #16 Service Provider First Name
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getServiceProviderFirstName(), false, 1, 35, StringFormat.RPADSPACES));


				// #17 Service Provider Middle Name
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getServiceProviderMiddleName(), OPTIONAL, 1, 25, StringFormat.RPADSPACES));


				// #18 Service Provider Name suffix
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getServiceProviderNameSuffix(), OPTIONAL, 1, 10, StringFormat.RPADSPACES));

// END OF SERVICE PROVIDER SECTION



				// #19 Employer Identification Number
				sbDtlRec.append(DEFAULT_NULL);
				delimit(sbDtlRec);



				// #20 Employer Name
				sbDtlRec.append(DEFAULT_NULL);
				delimit(sbDtlRec);



// START OF PERSON INFO
	            PersonInfo person = getPersonName(this.sbcrId);

	            //TWP Seems Like the old code made the assumption that the subscriber and patient were the same
	            //am I interpreting this correctly?
	            if (person != null) {


// CHECK MAX FIELD LENGTH FOR EACH OF THESE FIELDS
// #21 Subscriber Id
	                sbDtlRec.append(formatOutputString(person.getPersonId(),  OPTIONAL, 2, 80, StringFormat.RPADSPACES));


// #22 Subscriber Last Name
	                sbDtlRec.append(formatOutputString(person.getLastName(),  OPTIONAL, 1, 60, StringFormat.RPADSPACES));


// #23 Subscriber First Name
	                sbDtlRec.append(formatOutputString(person.getFirstName(),  OPTIONAL, 1, 35, StringFormat.RPADSPACES));


// #24 Subscriber Middle Name
	                sbDtlRec.append(formatOutputString(person.getMiddleName(), OPTIONAL, 1, 25, StringFormat.RPADSPACES));


// #25 Subscriber Name Suffix
	                sbDtlRec.append(formatOutputString(person.getNameSuffix(), OPTIONAL, 1, 10, StringFormat.RPADSPACES));


// END SUBSCRIBER INFO.

					// #26 Patient ID - TWP looks like we did not send this in the past
					sbDtlRec.append(DEFAULT_NULL);
					delimit(sbDtlRec);



// #27 Patient Last Name
	                sbDtlRec.append(formatOutputString(person.getLastName(), OPTIONAL, 1, 60, StringFormat.RPADSPACES));


// #28 Patient First Name
	                sbDtlRec.append(formatOutputString(person.getFirstName(), OPTIONAL, 1, 35, StringFormat.RPADSPACES));


// #29 Patient Middle Name
	                sbDtlRec.append(formatOutputString(person.getMiddleName(), OPTIONAL, 1, 25, StringFormat.RPADSPACES));



// #30 Patient Name Suffix
	                sbDtlRec.append(formatOutputString(person.getNameSuffix(), OPTIONAL, 1, 10, StringFormat.RPADSPACES));



		            } else {
		                //IL Selects the insured or subscriber - MI selects the Member identification number
		                String vQl = "AND NM101ENTY_ID_CD = 'IL' AND NM108ID_CD_QUAL = 'MI' ";
		                EntityName entityNameS = getEntityName("2010BA", vQl);
		                sbDtlRec.append(formatOutputString(entityNameS.getNm109idCd(),
		                        OPTIONAL, 2, 80, StringFormat.RPADSPACES)); //Subscriber Id
		                sbDtlRec.append(formatOutputString(
		                        entityNameS.getNm103lastNm(), OPTIONAL, 1, 60,
		                        StringFormat.RPADSPACES)); //Subscriber Last Name
		                sbDtlRec.append(formatOutputString(
		                        entityNameS.getNm104fstNm(), OPTIONAL, 1, 35,
		                        StringFormat.RPADSPACES)); //Subscriber First Name
		                sbDtlRec.append(formatOutputString("", OPTIONAL, 1, 25,
		                        StringFormat.RPADSPACES)); //Subscriber Middle Name
		                sbDtlRec.append(formatOutputString("", OPTIONAL, 1, 10,
		                        StringFormat.RPADSPACES)); //Subscriber Name Suffix
		                sbDtlRec.append(formatOutputString("", OPTIONAL, 2, 80,
		                        StringFormat.RPADSPACES)); //Patient ID - TWP looks like we did not send this in the past
		                sbDtlRec.append(formatOutputString(
		                        entityNameS.getNm103lastNm(), OPTIONAL, 1, 60,
		                        StringFormat.RPADSPACES)); //Patient Last Name
		                sbDtlRec.append(formatOutputString(
		                        entityNameS.getNm104fstNm(), OPTIONAL, 1, 35,
		                        StringFormat.RPADSPACES)); //Patient First Name
		                sbDtlRec.append(formatOutputString("", OPTIONAL, 1, 25,
		                        StringFormat.RPADSPACES)); //Patient Middle Name
		                sbDtlRec.append(formatOutputString("", OPTIONAL, 1, 10,
		                        StringFormat.RPADSPACES)); //Patient Name Suffix
		            }



// END PERSON INFO

// DEMOGRAPHIC INFO
		            DemographicInfo demographicInfo = getDemographicInfo();

		            if (demographicInfo != null) {


// #31 Patient Date of Birth
	                sbDtlRec.append(formatOutputString(demographicInfo.getDmg02brthDt(), REQUIRED, 8, 8, StringFormat.RPADSPACES));

// #32 Patient Gender - B.B. - why is this logic here? It is not in the spec.....if not null and is M or F, then write M or F else write empty string


		            if ((demographicInfo.getDmg03gndr() != null) && ("M".equalsIgnoreCase(demographicInfo.getDmg03gndr()) || "F".equalsIgnoreCase(demographicInfo.getDmg03gndr()))) {
		                    sbDtlRec.append(formatOutputString(demographicInfo.getDmg03gndr(), OPTIONAL, 1, 1, StringFormat.RPADSPACES));
		                } else {
		                    sbDtlRec.append(formatOutputString("", OPTIONAL, 1, 1, StringFormat.RPADSPACES)); //Patient Gender
		                }
		            } else {
		                sbDtlRec.append(formatOutputString("", REQUIRED, 8, 8, StringFormat.RPADSPACES)); //Patient Date of Birth
		                sbDtlRec.append(formatOutputString("", OPTIONAL, 1, 1,  StringFormat.RPADSPACES)); //Patient Gender
		            }


// END DEMOGRAPHIC INFO


				// 33  - Emdeon Claim Number
// paymentDataExtraction.setEmdeonClaimNumber(this.sClaimKey);
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getEmdeonClaimNumber(), OPTIONAL, 1, 50, StringFormat.RPADSPACES));


								// new method to calculate the Claim Charge Amount and Claim Payment Amount
// paymentDataExtraction.setClaimChargePaymentAmounts(this.sClaimKey);

				// #34 Claim Charge Amount - DONE
				sbDtlRec.append(paymentDataExtraction.getClaimChargeAmountFormatted() );
				delimit(sbDtlRec);



				//#35 Claim Payment Amount - DONE
				// sbDtlRec.append(formatOutputString(paymentDataExtraction.getClaimPaymentAmountFormatted(), REQUIRED, 0, 18, StringFormat.RPADSPACES));
				sbDtlRec.append(paymentDataExtraction.getClaimPaymentAmountFormatted() );
				delimit(sbDtlRec);


				// 36 - Payment date DONE
// paymentDataExtraction.setClaimAdjudicationPaymentDate(this.sClaimKey);
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getClaimAdjudicationPaymentDate(), OPTIONAL, 8, 8, StringFormat.RPADSPACES));


				// 37 -  Check EFT/Date - DONE
// paymentDataExtraction.setCheckDateAndNumber(this.sClaimKey);
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getCheckDate(), OPTIONAL, 8, 8, StringFormat.RPADSPACES));


				// 38 Check/EFT Number - DONE
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getCheckNumber(), OPTIONAL, 1, 16,  StringFormat.RPADSPACES));


				// NOTE: uses original code
				// 39 - Bill Type
				sbDtlRec.append(formatOutputString(claim.getBillTypeCd(), OPTIONAL, 1, 3, StringFormat.RPADSPACES));


// #40 - Payer Claim Identification Number - DONE
				sbDtlRec.append(this.sClaimKey);
				delimit(sbDtlRec);


// NOTE: uses original code
// #41 - Patient Account Number - DONE
				sbDtlRec.append(formatOutputString(reposClaim.getClm01ptAcctNbr(), REQUIRED, 1, 50, StringFormat.RPADSPACES));




				// #42 Pharmacy Prescription Number
// paymentDataExtraction.setPharmacyPrescriptionNumber(this.sClaimKey);
				sbDtlRec.append(formatOutputString(paymentDataExtraction.getPharmacyPrescriptionNumber(), OPTIONAL, 1, 50, StringFormat.RPADSPACES)); //Pharmacy Prescription Number



				// #43 Voucher Identifier
				sbDtlRec.append(DEFAULT_NULL);
				delimit(sbDtlRec);

				// #44 Application of Location System Identifier
				sbDtlRec.append(DEFAULT_NULL);
				delimit(sbDtlRec);

				// #45 Group Number
				sbDtlRec.append(DEFAULT_NULL);

				delimit(sbDtlRec);

				sStartDate = new SimpleDateFormat("yyyyMMdd").format(claim.getBeginServiceDate());
				sEndDate = new SimpleDateFormat("yyyyMMdd").format(claim.getEndServiceDate());


				sbDtlRec.append(sStartDate);
				delimit(sbDtlRec);

				sbDtlRec.append(sEndDate);

}catch(Exception e) {
	erroredKeys.add(this.claimKey);
	LOGGER.error("createPrimaryDetailRec() - Error getting claim info on Claim Key: {}",  this.sClaimKey);
    LOGGER.error(e.getMessage(), e);
    continue;
}

/******************************************************** END OF OUTPUT SECTION ****************************************************************************/
				cumulativeDetailSize+=sbDtlRec.length();

	            this.vCsFile.print(sbDtlRec);
	            this.vCsFile.print(CRLF);


				this.vCsFile.flush();

// clear previous values in StringBuffer - DO NOT EDIT THIS LINE.
				sbDtlRec.setLength(0);


            //Create claim status lines for this claim
	            writeStcClaimRec(claim, "A2", "20", "", this.vCsFile);

	            writeDTLRec(this.vCsFile);


//TODO UNCOMMENT TO UPDATE RECORDS.......

updateWrittenRecordJDBC(sClaimKey);

if(DEBUG) {
	 System.out.println("\nCreatePrimaryDetailRec() - updateWrittenRecordJDBC() done  - time is.....");
	 getNow();
}


								// output file handing....
						++count;


						fileSize = csFile.length();

						// if the file size is between max and cutoff, go to new file
						if( fileSize > CUT_OFF_FILE_SIZE && (fileSize < MAX_FILE_SIZE)  ) {

							// create new output file and continue
							try {

								// 7/1 write footer....
								createTrlRec(this.vCsFile);

								// 7/1 reset counter
								this.rowCount = 2;

								// flush it, close it, kill it....
								this.vCsFile.flush();
								this.vCsFile.close();
								this.vCsFile=null;

								// create new output file
								this.csFile = createNewOutputFile(filePath);
								// assign writer
								this.vCsFile = new PrintWriter(new FileOutputStream(csFile));

								// 7/1 write new header file
								createHdrRec(this.vCsFile);
							} catch (FileNotFoundException e) {
								System.out.println("createPrimaryDetailRec() - File Not Found Exception: " + e.getMessage());
								e.printStackTrace();
						    	LOGGER.error("createPrimaryDetailRec() - File Not Found Exception:()" + e.getMessage());
						        LOGGER.error(e.getMessage(), e);
							} catch(Exception x) {
								System.out.println("createPrimaryDetailRec() - General Exception: " + x.getMessage());
								x.printStackTrace();
						    	LOGGER.error("createPrimaryDetailRec() - General Exception()" + x.getMessage());
						        LOGGER.error(x.getMessage(), x);
							}	// end if

						}	// end try

						claimsRecordCount++;

// write any records that were left hanging after the batch update process...
writeOrphanedRecords();

        		if(erroredKeys.size() > 0 ) {

        			int y = erroredKeys.size();
        			for(int i = 0; i < y; i++) {
         				Long x =  (Long) erroredKeys.get(i);
         				updateErroredClaim(x.longValue());
        			}
         		}
}

/**
        		System.out.println("\n<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");
       			System.out.println("\ncreatePrimaryDetailRec() - Claims processed: " + count);
         		System.out.println("createPrimaryDetailRec() - Errored claims count " + erroredKeys.size());
**/
}	// END createPrimaryDetailRec()



    /**
      * Write trailer line - no data required
     * @param vCsFile
     */
    final void createTrlRec(PrintWriter vCsFile) {
        StringBuffer sbTrlRec = new StringBuffer();


        sbTrlRec.append("TRLR"); //Record ID
        delimit(sbTrlRec);


// this should be row.count-2 at end - insert other rowCounts in other lines and test this at the very end of code edits.
        sbTrlRec.append(StringUtils.lPadZeros(Integer.toString(this.rowCount-2), 10)); //Record Count  (Note format output will delimit the string)

        vCsFile.print(sbTrlRec);
        vCsFile.print(CRLF); //Record Terminator

        this.trailerSize=sbTrlRec.length();

        sbTrlRec = null;

    }

    //TWP: bug fix rejected status had ' not _
    boolean isRejectedClaim() {
        return this.statusCd.equalsIgnoreCase("REJECTED") ||
        this.statusCd.equalsIgnoreCase("277U_REJ_SENT");
    }

    boolean isAcceptedClaim() {
        return this.statusCd.equalsIgnoreCase("BUILT") ||
        this.statusCd.equalsIgnoreCase("277U_ACCPT_SENT");
    }

    @SuppressWarnings("unchecked")
    final EntityName getEntityName(String vLoopId, String vQual) {
        String qstr = "select e from eEntityName e " +
            "where e.txnSet.id.fileNumber = :file " +
            "  and e.txnSet.id.st02txnCtlNbr = :ctlnbr " +
            "  and e.loopId =  :loopid " + vQual;
        Query q = em.createQuery(qstr);
        q.setParameter("file", this.fileNbr);
        q.setParameter("ctlnbr", this.st02CtlNbr);
        q.setParameter("loopid", vLoopId);

        EntityName en = null;
        List<EntityName> entityNames = q.getResultList();

        if ((entityNames.size() > 0) && (entityNames.get(0) != null)) {
            en = entityNames.get(0);
        } else {
            LOGGER.warn("Error in getting EntityName for fileNumber: {}, st02txnCtlNbr: {}, loopId: {}, qal: {}",
                new Object[] { this.fileNbr, this.st02CtlNbr, vLoopId, vQual });
        }

        return en;
    }

    @SuppressWarnings("unchecked")
    final EntityName getEntityName(String vQual) {
        String qstr = "select e from eEntityName e " +
            "where e.txnSet.id.fileNumber = :file " +
            "  and e.txnSet.id.st02txnCtlNbr = :ctlnbr " + vQual;
        Query q = em.createQuery(qstr);
        q.setParameter("file", this.fileNbr);
        q.setParameter("ctlnbr", this.st02CtlNbr);

        EntityName en = null;
        List<EntityName> entityNames = q.getResultList();

        if ((entityNames.size() > 0) && (entityNames.get(0) != null)) {
            en = entityNames.get(0);
        } else {
            LOGGER.debug("Did not get EntityName for fileNumber: {}, st02txnCtlNbr: {}, loopId: {}, qal: {} note:it may not be required",
                new Object[] { this.fileNbr, this.st02CtlNbr, vQual });
        }

        return en;
    }


    @SuppressWarnings("unchecked")
    final PersonInfo getPersonName(String vSsn) {
        Query q = em.createQuery(
                "select p from foPersonInfo p where p.personId = :id ");
        q.setParameter("id", vSsn);

        PersonInfo pi = null;
        List<PersonInfo> pis = q.getResultList();

        if ((pis.size() > 0) && (pis.get(0) != null)) {
            pi = (PersonInfo) pis.get(0);
        } else {
            LOGGER.debug("Unable to get PersonInfo for person Id: {}", vSsn);
        }

        return pi;
    }

    @SuppressWarnings("unchecked")
    final DemographicInfo getDemographicInfo() {
        String qstr = "select d from eDemographicInfo d " +
            "where d.txnSet.id.fileNumber = :file " +
            "  and d.txnSet.id.st02txnCtlNbr = :ctlnbr " +
            "  and d.nm109sbsrId = :sbcrid " +
            "  and d.loopId in ('2010BA', '2010CA')";
        Query q = em.createQuery(qstr);
        q.setParameter("file", this.fileNbr);
        q.setParameter("ctlnbr", this.st02CtlNbr);
        q.setParameter("sbcrid", this.sbcrId);

        DemographicInfo di = null;
        List dis = q.getResultList();

        if ((dis.size() > 0) && (dis.get(0) != null)) {
            di = (DemographicInfo) dis.get(0);
// System.out.println("\ngetDemographicInfo() - FOUND Demographic Info for file: " +  this.fileNbr);
        } else {



            LOGGER.debug("Unable to get Demographic Info for file: {}, st02txnCtlNbr: {}, nm109sbsrId: {} ",
                new Object[] { this.fileNbr, this.st02CtlNbr, this.sbcrId });
        }

        return di;
    }



    final StringBuffer fillErrorCodes(StringBuffer sbDtlRec, String vErrCd) {
        if (!(vErrCd.equals(""))) {
            String[] tkns = vErrCd.split(":");

            if (tkns[0] != null) {
                sbDtlRec.append(formatOutputString(tkns[0], OPTIONAL, 2, 3,
                        StringFormat.RPADSPACES)); //Claim Status Category Code
            } else {
                sbDtlRec.append(formatOutputString("", OPTIONAL, 2, 3,
                        StringFormat.RPADSPACES)); //Claim Status Category Code
            }

            if (tkns[1] != null) {
                sbDtlRec.append(formatOutputString(tkns[1], OPTIONAL, 2, 3,
                        StringFormat.RPADSPACES)); //Claim Status Code
            } else {
                sbDtlRec.append(formatOutputString("", OPTIONAL, 2, 3,
                        StringFormat.RPADSPACES)); //Claim Status Code
            }

            if (tkns.length > 2) {
                if (tkns[2] != null) {
                    sbDtlRec.append(formatOutputString(tkns[2], OPTIONAL, 2, 3,
                            StringFormat.RPADSPACES)); //Entity Code X
                } else {
                    sbDtlRec.append(formatOutputString("", OPTIONAL, 2, 3,
                            StringFormat.RPADSPACES)); //Entity Code X
                }
            } else {
                sbDtlRec.append(formatOutputString("", OPTIONAL, 2, 3,
                        StringFormat.RPADSPACES)); //Entity Code X
            }
        }

        return sbDtlRec;
    }


    private void delimit(StringBuffer sb) {
        sb.append(DELIMITER);
    }



    public int getAvailableRecords() {

    	
    	
    	EntityTransaction txUpdateDatabase = em.getTransaction();
    	Query q;
	    List<?> l;
	    Iterator<?> it;
	    int count = 0;

	    String sqlGetStagingTableRecordCount = "SELECT count(*)   FROM fpps_owner.claims c , e_repos.claim e " +
              			" WHERE " +
               			" e.claim_key = c.edi_claim_key " +										// param b													// param e
              			" and c.claim_status_cd = 'COMPLETE' and (sysdate-c.date_modified) <= " + this.iLookBackDays + "  and (sysdate-c.date_modified) >= " + this.iLookBackEndDays + " " +
              			" and not exists (SELECT 1 FROM fpps_owner.stg_277 s WHERE s.claim_index = c.claim_index and s.claim_status_cd = 'SENT') ";

       					try {

       					      q = this.em.createNativeQuery(sqlGetStagingTableRecordCount);
       					      l = q.getResultList();
       					      it = l.iterator();


       					      Object row = (BigDecimal) it.next();

		  				      if(row != null) {

		  				        	String tmp = row.toString();
		  				        	count = new Integer(tmp).intValue();
		  				      }

         			    } catch(Exception ex) {
         			    		LOGGER.error("getAvailableRecords() ERROR: " + ex.getMessage());
       			    	}

       	return count;
    }



     @SuppressWarnings({ "rawtypes", "unchecked" })
    /** This method collects detail records for the current claim
     * @author Bill Blackmon
     * @return List
     */
  	private List getDetailRecords() {

    	List<DetailRecord> detailRecords = new ArrayList();


 		// new code follows - all of this needs to be refactored out to PaymentDataExtraction when finished.....
		detailRecords = paymentDataExtraction.getDetailRecords(this.sClaimKey);


    	return detailRecords;
    }

    /**
     * This method prints the detail record section of the output file
     * @author Bill Blackmon
     * @param claim
     * @param vCsFile
     */
   // @SuppressWarnings({ "rawtypes", "unchecked" })
//	private void writeDTLRec(Claim claim, PrintWriter vCsFile) {

		private void writeDTLRec(PrintWriter vCsFile) {
    	// list of detail records
    	@SuppressWarnings("unchecked")
		List<DetailRecord> detailsList = getDetailRecords();

    	for(DetailRecord dRec: detailsList)
    	{
// System.out.println("IN DETAIL SECTION - detail rec id is: " + dRec.toString());
				StringBuffer sbDTLRec = new StringBuffer();



// 1 Record ID
			        sbDTLRec.append("DTL");
			        delimit(sbDTLRec);

					// #2 record number - current record
					sbDTLRec.append(formatOutputString(Integer.toString(this.rowCount), REQUIRED, 1, 10, StringFormat.LPADZERO)); //rowCount
					this.rowCount++;


					// 3
					//Payer ID (Emdeon Assigned Number) - Required, String
					sbDTLRec.append(PAYER_ID);
					delimit(sbDTLRec);

					// spec. #4 Payer Claim Identification Number - Required, String
					sbDTLRec.append(this.sClaimKey);
					delimit(sbDTLRec);

					// #5 Line Item Control Number
					sbDTLRec.append(dRec.getLineItemControlNumber());
					delimit(sbDTLRec);


					// # Service Qualifier ID
					sbDTLRec.append(dRec.getServiceQualifier());
					delimit(sbDTLRec);

					// #7 Service Identification Code -

					sbDTLRec.append(dRec.getProcCode());
					delimit(sbDTLRec);
// System.out.println("detail 7 PROC CODE: = " + sbDTLRec.toString());


					// DONE
					// #8 Procedure Modifier 1
					sbDTLRec.append(dRec.getProcedureModifier1());
						 delimit(sbDTLRec);


						// DONE
						// #9 Procedure Modifier 2
						 sbDTLRec.append(dRec.getProcedureModifier2());
						 delimit(sbDTLRec);

						// DONE
						// #10	Procedure Modifier 3
						 sbDTLRec.append(dRec.getProcedureModifier3());
						 delimit(sbDTLRec);

						// DONE
						// #11	Procedure Modifier 4
						 sbDTLRec.append(dRec.getProcedureModifier4());
						 delimit(sbDTLRec);

						// END OF PROCEDURE/SERVICE MODIFIERS

						// DONE
						//	#12 Line Item Charge Amount
						sbDTLRec.append(formatOutputString(dRec.getBilledAmountFormatted(), OPTIONAL, 1, 18, StringFormat.LPADZERO));
// System.out.println("writeDTLRec() FIELD 12 billed amount claim # : " + this.sClaimKey + " " + sbDTLRec.toString());



// should be DEFAULT_ZERO if amount is empty or null
						// #13 Paid Amount
						sbDTLRec.append(formatOutputString(dRec.getPaidAmountFormatted(), OPTIONAL, 1, 18, StringFormat.LPADZERO));
// System.out.println("writeDTLRec() FIELD 13 paid amount claim # : " + this.sClaimKey + " " + sbDTLRec.toString());



						// DONE
						// 14 Revenue Code
						sbDTLRec.append(dRec.getRevenueCode());
						delimit(sbDTLRec);
// System.out.println("detail out 14 REVENUE CODE: " + sbDTLRec.toString());

						// DONE
						// 15 Quantity(Units of Service) Optional, Numeric, min-max = 1 15 DEFAULT VALUE IS 1
						sbDTLRec.append(dRec.getBilledUnits());
						delimit(sbDTLRec);
						// System.out.println("detail out: " + sbDTLRec.toString());

						// DONE
						// 16 EMDEON Claim Number OPTIONAL AN 1 50 Emdeon ID if an Emdeon Claim.
						sbDTLRec.append(formatOutputString(dRec.getEmdeonClaimNumber(), OPTIONAL, 1, 50, StringFormat.RPADSPACES));
						// System.out.println("detail out: " + sbDTLRec.toString());

						// DONE
						// 17 Date of Service Start Required Date
						 sbDTLRec.append(formatOutputString(dRec.getServiceFromDateFormatted(), OPTIONAL, 8, 8, StringFormat.RPADSPACES));
						 // System.out.println("detail out: " + sbDTLRec.toString());

						// DONE
						// 18 Service to Date
						 sbDTLRec.append(dRec.getServiceToDateFormatted());
// System.out.println("writeDTLRec - detail out: " + sbDTLRec.toString());



						// END OF THE LINE.......
						sbDTLRec.append(CRLF); //Record Teminator new for 5010
						// System.out.println("writeDTLRec() - final String is: " + sbDTLRec);

				        vCsFile.print(sbDTLRec); //TWP Changed to print rather than println since I am explicitly adding CRLF
				        vCsFile.flush();


				        sbDTLRec = null;
				        this.bInClaim=false;

				        writeStcDetailRec("A2", "20", "", vCsFile, dRec);

	}	// END OF DETAIL LOOP



 }	// end writeDTLRec()

		    /**
		     * This method is used to write the STC for a detail record.
		     * @author Bill Blackmon
		    * @param payerClaimId
		    * @param statusCategoryCode
		    * @param statusCode
		    * @param entityCode
		    * @param vCsFile
		    */

				private void writeStcDetailRec(String statusCategoryCode, String statusCode,
			    		String entityCode, PrintWriter vCsFile, DetailRecord dRec) {
// FIELD 1 - Record ID
		    	 	StringBuffer sbSTCRec = new StringBuffer();
			        sbSTCRec.append("STC"); //Record ID
			        delimit(sbSTCRec);


			        // sbSTCRec.append(formatOutputString(Integer.toString(this.cnt), REQUIRED, 1, 10, StringFormat.LPADZERO)); //Record Number - must be in sync with other records

// FIELD 2	- Row Count
			        sbSTCRec.append(formatOutputString(Integer.toString(this.rowCount), REQUIRED, 1, 10, StringFormat.LPADZERO)); // rowCount
			        this.rowCount++;


// FIELD 3 	- Payer ID
			        sbSTCRec.append(PAYER_ID);
			        delimit(sbSTCRec);

// FIELD 4 - Payer Claim Identification Number
			        sbSTCRec.append(formatOutputString(this.sClaimKey, REQUIRED, 1, 50, StringFormat.RPADSPACES));


// Field 5 - Line Item Control Number
					sbSTCRec.append(dRec.getLineItemControlNumber());
					delimit(sbSTCRec);
					// System.out.println("writeStcDetailRec() - after lineItemControlNumber: " + sbSTCRec);

// Field 6 - Status Information Effective Date - B.B. - inherited
			        Date today = Calendar.getInstance().getTime();
			        String dateFormat = "yyyyMMddHHmmss";
			        sbSTCRec.append(new SimpleDateFormat(dateFormat).format(today));
			        delimit(sbSTCRec);




// Field #7 - Claim Status Category Code
// f1 or f2 at this level, determines if there is a paid amt f1 else f2
// F1 = PAID, F2 = NO PAYMENTS, F0 MIXED (claim level ONLY) - paid and unpaid in detail records -
// NO MIXED IN DETAIL RECORDS
// amount of 69.3 fails for input string......


/**
 The value of 1 should be used only if NOT paid, so only for F0 or F2.  65 is only used for a paid (F1).

PAID AMT. IS NEGATIVE........
1.	DTL-FL12 (Line Item Charge Amount) = 20.00 and DTL-FL13 (Line Item Provider Payment Amount) = -10.00:
Currently report as F2/1, please change to F1/65
2.	DTL-FL12 (Line Item Charge Amount) = -20.00 and DTL-FL13 (Line Item Provider Payment Amount) = -10.00. use F1/65.
Currently report as F2/1, please change to F1/65

 */

/**
 * New logic from John S., 6/26....
Regarding the F0, F1, F2 issue.  I believe the following  should cover the conditions for when to use which value.
For the STC record associated with the DTL lines, if there is a payment and it is not equal to 0.00,
then the CLAIM STATUS CAT CODE = F1 and CLAIM STATUS CODE = 65 If payment is blank, or 0.00, the CAT CODE=F2 and STATUS CODE=1

 */
			BigDecimal iPaidAmt = dRec.getPaidAmount();

// Field 7 - Claim Status CATEGORY Code

// changed 7/3 to handle null paid amts.
// logic ok'ed by Anne 7/3
			if(iPaidAmt == null) {

// System.out.println("writeStcDetailRec() - NULL PAID AMT. for id: " + this.claimKey);
				sbSTCRec.append("F2");
				this.statusCode="1";

			} else {

				int x = iPaidAmt.intValue();

				if( (x > 0) || (x < 0) )
				{
					sbSTCRec.append("F1");
					this.statusCode="65";
				} else {	// x - 0 payment
					sbSTCRec.append("F2");
					this.statusCode="1";
				}
			}


delimit(sbSTCRec);


// System.out.println("writeStcDetailRec() - NEW STATUS CODE IS: " + this.statusCode);

// Field 8 - Claim Status Code
			 sbSTCRec.append(this.statusCode);
			 delimit(sbSTCRec);
// end CLAIM STATUS CATEGORY CODE

// Field 9 - Entity Code - OPTIONAL - no set to any value in existing code....
		    sbSTCRec.append(entityCode);
		    delimit(sbSTCRec);



// Field #10 - Data In Error ('for future use') - set to empty string
			sbSTCRec.append(DEFAULT_NULL); //Data In Error - we do not have this from what I can tell so leave it blank - .B.B. THIS CAME WITH THE EXISTING CODE - leaving as is
			delimit(sbSTCRec);

// Field 11 - Emdeon Status Code
			sbSTCRec.append(DEFAULT_NULL); // Emdeon Status Code

	        sbSTCRec.append(CRLF); //Record Teminator new for 5010

	        vCsFile.print(sbSTCRec); //TWP Changed to print rather than println since I am explicitly adding CRLF

	        vCsFile.flush();
	        sbSTCRec = null;
    }	// end writeSTCDetailRec()





	/**
	 * NOTE - check to see where the args passed in are coming from and make sure that they are correct if they are being set at the Claim level.
	 *
     * This method was inherited from Initial Payment scheme........needs examination and refactoring for Fee purposes
     * @param claim
     * @param payerClaimId
     * @param statusCategoryCode
     * @param statusCode
     * @param entityCode
     * @param vCsFile
     */

    private void writeStcClaimRec(Claim claim, String statusCategoryCode, String statusCode,
    		String entityCode, PrintWriter vCsFile) {

// #1 Record ID
        StringBuffer sbSTCRec = new StringBuffer();
        sbSTCRec.append("STC"); //Record ID
        delimit(sbSTCRec);

// #2 Record Number
//        sbSTCRec.append(formatOutputString(Integer.toString(this.cnt),  REQUIRED, 1, 10, StringFormat.LPADZERO)); //Record Number - must be in sync with other records


// #2 Record Number
        sbSTCRec.append(formatOutputString(Integer.toString(this.rowCount),  REQUIRED, 1, 10, StringFormat.LPADZERO)); // rowCount
// System.out.println("writeStcClaimRec() - output is: " + sbSTCRec.toString());
        this.rowCount++;

// #3 Payer ID
        sbSTCRec.append(PAYER_ID);
        delimit(sbSTCRec);

// #4 Payer Claim Identification Number
        sbSTCRec.append(formatOutputString(this.sClaimKey, REQUIRED, 1, 50, StringFormat.RPADSPACES));

        //TWP What do we use for an identification number - we have not assigned it yet
        //for a claim that has only been accepted ???? we have a GUID
        //Should we really be running this file after the FPPS PL/SQL loading runs so we can assign it a claim index?


// field # 5 - Line Item Control Number
// always set to "" for Claim level record - according to Mary Simons 3/19/2013
        sbSTCRec.append("");
        delimit(sbSTCRec);

// field #6 - Status Information Effective Date - B.B. - inherited
        Date today = Calendar.getInstance().getTime();
        String dateFormat = "yyyyMMddHHmmss";
        sbSTCRec.append(new SimpleDateFormat(dateFormat).format(today));
        delimit(sbSTCRec);




// Field #7 - Claim Status Category Code
// F0 ('mixed') can only be on CLM's STC not DTL's STC.
//  if code is F0 and we are in the detail section, swap code to F1 until detail records are found and read
//  rec count of 3, 2nd  claim is the problem.....
//  System.out.println("writeStcClaimRec() - record count is: " + this.cnt);
/**
 * f1 in detail, f1 in claim
 * f2 in detail f2 in claim
 * f1 and f2 in detail, f0 in claim level

 */


// System.out.println("writeStcClaimRec() - claim status category code at top is: " + this.claimStatusCategoryCode);


if(this.claimStatusCategoryCode.equalsIgnoreCase(""))  {
//	System.out.println("writeStcClaimRec() - claimStatusCategoryCode IS NULL");
}


if ( (this.claimStatusCategoryCode.equalsIgnoreCase("F0")) && (this.bInClaim == false) ) {
  		this.claimStatusCategoryCode="F1";
// System.out.println("writeStcClaimRec() - STATUS CATEGORY CODE CHANGED to F1");
}


// Field #7 Claim Status Category Code
        sbSTCRec.append(this.claimStatusCategoryCode);

// System.out.println("writeStcClaimRec() - claimStatusCategoryCode is: " + this.claimStatusCategoryCode);

        delimit(sbSTCRec);

// Field #8 - Claim Status Code
        sbSTCRec.append(this.statusCode);
        delimit(sbSTCRec);
// System.out.println("STC OUT after Finalized Codes Setting is: " + sbSTCRec.toString());



// Field #9 - Entity Code - OPTIONAL - no set to any value in existing code....
        sbSTCRec.append(entityCode);
        delimit(sbSTCRec);



// Field #10 - Data In Error ('for future use') - set to empty string
        sbSTCRec.append(""); //Data In Error - we do not have this from what I can tell so leave it blank - .B.B. THIS CAME WITH THE EXISTING CODE - leaving as is
        delimit(sbSTCRec);

// Field #11 Emdeon Status Code - OPTIONAL - see if this exists elsewhere?
        sbSTCRec.append(""); //Emdeon Status Code -  THIS CAME WITH THE EXISTING CODE - leaving as is

// REMOVED per Chad Morrison 6/25
        // delimit(sbSTCRec);

        sbSTCRec.append(CRLF); //Record Teminator new for 5010

        vCsFile.print(sbSTCRec); //TWP Changed to print rather than println since I am explicitly adding CRLF
        vCsFile.flush();

        sbSTCRec = null;
    }

    private String formatOutputString(Object dataToFormat, boolean required, int minLength, int maxLength, StringFormat format) {
        return formatOutputString(dataToFormat, required, minLength, maxLength,
            format, true);
    }

    /**
     * This method should be called for each field which
     * will make the code above basically match the spec.
     * It will format the field to the specs given and delimit
     * each value returned.
     *
     * @param dataToFormat
     * @param minLenght
     * @param maxLength
     * @param format
     * @param delimit
     * @return
     */
    private String formatOutputString(Object dataToFormat, boolean required, int minLength, int maxLength, StringFormat format, boolean delimit) {
        //If we don't have data for a required field we just balk right now - what do you really want to happen?
        if ((required && (dataToFormat == null)) || (required && (dataToFormat instanceof String && (((String) dataToFormat).trim().length() < 1)))) {
            throw new RuntimeException(
                "formatOuputString() runtimeException.");
        }

        //We are assuming if we send a value it must meet the spec minLength and maxLength
        //But optional fields may be left blank - i.e. a blank field will appear in the output
        //For example see ;; in the following sample line ->
        //													;nonblankfield;;nonblankfield;
        String stringToReturn = "";

        if ((dataToFormat != null) &&
                !(dataToFormat instanceof String &&
                (((String) dataToFormat).trim().length() < 1))) {
            //If the data needs to be formatted a specific way format it
            if (format != null) {
                stringToReturn = this.formatString(dataToFormat, minLength,
                        maxLength, format);
            } else {
                stringToReturn = dataToFormat.toString();
            }

            //Check to see if the value complies with EMDEONS minimum length requirement
            int stringLength = stringToReturn.length();

            if (stringLength < minLength) {
                throw new RuntimeException(
                    "Please specify a formatter for this data so it can be formatted to meet the minimum lenght requirement." +
                    dataToFormat);
            }

            //Check to see if the value complies with EMDEONS max length requirement -
            //If it does not we make truncate it - this seems dangerous - TWP.
            if (stringLength > maxLength) {
                stringToReturn = truncate(stringToReturn, dataToFormat,
                        maxLength);
            }
        }

        if (delimit) {
            stringToReturn += DELIMITER;
        }

        return stringToReturn;
    }


    private String truncate(String formattedString, Object dataToFormat,
        int maxLength) {
        int beginIndex = formattedString.length() - maxLength;
        String stringToReturn = formattedString.substring(beginIndex);

        LOGGER.warn("Truncating data from " + formattedString + " to " +
            stringToReturn);

        return stringToReturn;
    }

    /**
     * Throws a runtime exception if it can not format the data to the specification given.
     * Will also throw an exception if null is passed in - it expects to format a string.
     *
     * @param stringToFormat string to be formatted
     * @param minLength			minimum length of stringToFormat
     * @param maxLength		maximum length of stringToFormat
     * @param format				format
     * @return String				formatted string
     */
    private String formatString(Object stringToFormat, int minLength,
        int maxLength, StringFormat format) {
        String stringToReturn = null;

        if ((stringToFormat != null) && stringToFormat instanceof BigDecimal) {
            stringToFormat = stringToFormat.toString();
        }

        if ((stringToFormat != null) &&
                (((String) stringToFormat).length() < minLength)) {
            if (StringFormat.RPADSPACES == format) {
                stringToReturn = StringUtils.padString((String) stringToFormat,
                        minLength, ' ', false);
            }

            if (StringFormat.LPADZERO == format) {
                stringToReturn = StringUtils.padString((String) stringToFormat,
                        minLength, '0', true);
            }
        } else {
            if ((stringToFormat != null) &&
                    (((String) stringToFormat).length() >= minLength)) {
                stringToReturn = (String) stringToFormat;
            }
        }

        if (StringFormat.LPADDECZERO2PLACES == format) {
            stringToReturn = StringUtils.lPadDecimalZeros2Places((String) stringToFormat,
                    maxLength);
        }

        if (stringToReturn == null) {
            throw new RuntimeException("Could not format the object - " +
                stringToFormat +
                " - conversion of this type of data is not yet supported.");
        }

        return stringToReturn;
    }


    /**
     *
     * @return java.sql.Timestamp for use in JDBC
     * @author Bill Blackmon
     * @since 11/27/2013
     */
    private static java.sql.Timestamp getCurrentTimeStamp() {
        java.util.Date today = new java.util.Date();
        return new java.sql.Timestamp(today.getTime());
    }



    /**
     * @author Bill Blackmon
     * @since 12/21/2013
     * @return java.sql.Timestamp
     */
    public Timestamp getRuntimeTimeStamp()
    {

    	 java.util.Date date= new java.util.Date();

    	 return new java.sql.Timestamp(date.getTime());

    }



    public void cleanStagingTable() {

    	EntityTransaction txUpdateDatabase = em.getTransaction();
    	Query q;
	    List<?> l;
	    Iterator<?> it;
	    int count = 0;

	    String sqlCleanStagingTable = "delete FROM fpps_owner.STG_277 where claim_status_cd = 'SENT' ";

// System.out.println("validateEreposClaim() - sql is: " + sqlGetEdiClaims);


       	try {

       					      q = this.em.createNativeQuery(sqlCleanStagingTable);
       					      l = q.getResultList();
       					      it = l.iterator();


       					      Object row = (BigDecimal) it.next();

		  				      if(row != null) {

		  				        	String tmp = row.toString();
		  				        	count = new Integer(tmp).intValue();

// System.out.println("validateEreposClaim() - EDI claims count is: " + count);

		  				      }

         			    	} catch(Exception ex) {

       			    		System.out.println("getStagingTableRecordCount() ERROR: " + ex.getMessage());
       			  			ex.printStackTrace();
       			  	  	  	LOGGER.error("getStagingTableRecordCount() ERROR: " + ex.getMessage());
       			    	}




    }



    /**
     * @author Bill Blackmon
     * @since 12/21/2013
     * @return java.sql.Date
     */
    public java.sql.Date getCurSqlDate()
    {
        final Calendar cal = Calendar.getInstance();
        final java.sql.Date vSqlDate = new java.sql.Date(cal.getTimeInMillis());

        return vSqlDate;
    }



    public String getNowMs() {

	      Date dNow = new Date( );
	      SimpleDateFormat ft =
	      new SimpleDateFormat ("yyyy:mm:dd:hh:mm:ss:ms");

	      String out = ft.format(dNow);
	      return out;

    }

	public String getNow() {

	      Date dNow = new Date( );
	      SimpleDateFormat ft =
	      new SimpleDateFormat ("hh:mm:ss:ms");

	      String out = ft.format(dNow);
	      return out;
	      // System.out.println(ft.format(dNow));
	}


    private enum StringFormat {RPADSPACES,
        LPADZERO,
        LPADDECZERO2PLACES;
    }


}
