package gov.va.med.hac.edi.extract.x214;

import gov.va.med.hac.edi.extract.feeclaimstatus.feeFinal.PaymentDataExtraction;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import org.hibernate.Session;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 
 * @author            
 *
 */
public class HCCA277GenerationHelper extends Build277CASegments {
	/** the class logger. */
	static final Logger LOGGER = LoggerFactory
			.getLogger(HCCA277GenerationHelper.class);
	static boolean DEBUG = false;
	int fileGroupCount = 1;
	int fileGroupSequenceNumber = 0;
	int curFileNumber = 0;
	PaymentDataExtraction paymentDataExtraction = null;
	int cnt = 0;
	ArrayList erroredKeys = null;
	String ereposClaimKey = "";
	String fileNbr = "";
	String st02CtlNbr = "";
	String billPrvdId = "";
	String sbcrId = "";
	String claimType = "";
	String statusCd = "";
	String currentDate = "";
	String currentTime = "";
	String strFileTime = "";

	/**
	 * 
	 * @param outputDir
	 * @param entityManager
	 */
	final void process(String outputDir, EntityManager entityManager) {
		filePath = outputDir;
		erroredKeys = new ArrayList();
		try {
			em = entityManager;
			oSession = (Session) entityManager.getDelegate();
			conn = oSession.connection();
			setEreposClaim();
			if (claims != null) {
				while (claims.next()) {
					reposClaim = (gov.va.med.domain.erepos.Claim) claims.get(0);
					if (null != reposClaim.getStatusCode()
							&& (reposClaim.getStatusCode().equalsIgnoreCase(
									ACCEPTED)
									|| reposClaim.getStatusCode()
											.equalsIgnoreCase(
													ACCEPTED_WITH_ERRORS) || reposClaim
									.getStatusCode().equalsIgnoreCase(REJECTED))) {
						ediClaimKey = reposClaim.getClaimKey();
						setFippsEntity();
						if (null != fppsClaim
								&& null != fppsClaim.getEdiClaimKey()) {
							long l = fppsClaim.getClaimIndex();
							Long L = new Long(l);
							this.sClaimKey = L.toString();
							setEntityInfo();
							if (null != this.senderInfo) {
								setEReposClaim(this.ediClaimKey);
								this.csFile = createNewOutputFile(
										this.sClaimKey, filePath);
								this.vCsFile = new PrintWriter(
										new FileOutputStream(csFile));
								createISAHeader();
								createGS();
								createST();
								createBHT();
								createHL1();
								createNM1_1();
								createTRN1();
								createDTP1();
								createDTP2();
								createHL2();
								createNM1_2();
								createTRN2();
								createSTC1();
								createQTY();
								createAMT();
								createHL3();
								createNM1_3();
								createTRN3();
								createHL4();
								createNM1_4();
								createTRN4();
								createSTC2();
								createREF();
								createDTP();
								createSE();
								createGE();
								createIEA();
								this.vCsFile.flush();
								this.vCsFile.close();
								persist277CA();
							}
						}
					}
				}
			}
		} catch (Exception ex) {
			LOGGER.error(
					"processClaimStatus() - Unable to create CSTAT, errored on Claim Key: {}",
					this.claimKey);
			LOGGER.error(ex.getMessage(), ex);
			System.exit(1);
		}
	}

	/**
	 * 
	 */
	private void setEReposClaim(String ediClaimKey) {
		String reposStr = "Select e from eClaim e where e.claimKey = :ediClaimKey";
		Query qErepos = null;
		try {
			if (DEBUG) {
				System.out
						.println("\nCreatePrimaryDetailRec() - calling getting eReposClaimInfo  at....");
				getNow();
			}
			qErepos = em.createQuery(reposStr);
			qErepos.setParameter("ediClaimKey", this.ediClaimKey);
			// use this claim to handle information from e_repos schema
			reposClaim = (gov.va.med.domain.erepos.Claim) qErepos
					.getSingleResult();
			// if above is successful, get properties below......
		} catch (Exception e) {
			erroredKeys.add(this.claimKey);
			LOGGER.error(
					"createPrimaryDetailRec() - Error getting claim info on Claim Key: {}",
					this.sClaimKey);
			LOGGER.error(e.getMessage(), e);
		} finally {
			qErepos = null;
		}
	}

	/**
	 * to do: put header and footer on EACH file, numbering starts over on each
	 * output file
	 *
	 * Creates a new output file
	 * 
	 * @param filePath
	 *            variable read from command line args
	 * @return File
	 */
	private File createNewOutputFile(String strClaimKey, String filePath) {
		File csFile = null;
		try {
			Calendar cal = new GregorianCalendar();
			String currentDate = "";
			String currentTime = "";
			SimpleDateFormat transDate = new SimpleDateFormat("yyyyMMdd");
			SimpleDateFormat transTime = new SimpleDateFormat("HHmmss");
			currentDate = transDate.format(cal.getTime());
			currentTime = transTime.format(cal.getTime());
			this.strFileTime = currentDate + currentTime;
			String fileName = "";
			if (null != strClaimKey && strClaimKey.length() > 0) {
				fileName = strClaimKey + currentDate + currentTime + "_"
						+ "277CA" + ".edi";
			} else {
				fileName = currentDate + currentTime + "_" + "277CA" + ".edi";
			}
			// increment output items.....
			this.fileGroupCount++;
			this.fileGroupSequenceNumber++;
			csFile = new File(filePath + fileName);
			curFileNumber++;

		} catch (Exception ex) {
			LOGGER.error(
					"Error on createNewOutputFile(), UNABLE TO CREATE NEW OUTPUT FILE - CURRENT fileGroupCount is: ",
					this.fileGroupCount);
			LOGGER.error(ex.getMessage(), ex);
		}

		return csFile;
	} // end createNewOutputFile()
}
