package gov.va.med.hac.edi.reposload.claimstatus.b2.jpa;

import gov.va.med.hac.edi.utils.*;
import gov.va.med.hac.edi.utils.jpa.DbTransactionEnderException;
import gov.va.med.hac.edi.utils.jpa.FileUtils;
import gov.va.med.hac.edi.utils.jpa.JPAUtil;

import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;
import java.util.Iterator;
import java.util.List;
import java.util.UUID;

import javax.naming.NamingException;
import javax.persistence.EntityManager;
import javax.persistence.Query;


import java.io.*;
import java.math.BigDecimal;
import java.sql.Date;
import java.util.Calendar;
import gov.va.med.domain.erepos.*;

public class ProcessRevStatusB2
{



  final private PrintWriter vLogFile;

//  // NCPDP Repository data source
//  private ApplicationModule amNcpdpRepos =
//    Configuration.createRootApplicationModule("gov.va.med.hac.edi.domain.NCPDPReposBC4J.NCPDPReposBC4JAppModule",
//                              "NCPDPReposBC4JAppModuleLocal"     );
//  private Transaction tranAmNcpdpRepos = amNcpdpRepos.getTransaction();
  private boolean exists = false;
  private String loadRec = "";
  //HR-PBM-PHASE 1-Begin
  // Declaring variable vClearinghouse
  private String vClearinghouse = "";
  //HR-PBM-PHASE 1-End

  // Constructor for this class
  public ProcessRevStatusB2(PrintWriter inLogFile)
  throws IOException, NamingException {
    // Store the log file in an instance variable
    vLogFile = inLogFile;
  }

  protected void processRevStLoad(String fPath, String fName)
  throws DbTransactionEnderException
  {
	EntityManager dbEM = null;
	try
    {
      
	  dbEM= JPAUtil.getEntityManager("dbhibernate.properties", "b2ReversalStatus");
      dbEM.getTransaction().begin();
	      
      String vFile = fPath + fName;
      
      Query ncpdpRb2ReversalStatusQuery = dbEM
		.createQuery("SELECT reversalStatus FROM gov.va.med.domain.erepos.NcpdpRb2ReversalStatus reversalStatus WHERE reversalStatus.fileNumber=?1");
      ncpdpRb2ReversalStatusQuery.setParameter(1, fName);

	  List ncpdpRb2ReversalStatuses = ncpdpRb2ReversalStatusQuery.getResultList();
	  Iterator ncpdpRb2ReversalStatusIterator = ncpdpRb2ReversalStatuses.iterator();


      if (ncpdpRb2ReversalStatusIterator.hasNext())
      {
        vLogFile.println("Found a Duplicate Ncpdp RB2 Reversal Status File with File Name : " + fName);
        vLogFile.flush();
      }
      else
      {
        int idx = fName.indexOf(".");
        String vFileName = fName.substring(0,idx) + ".RB2";
        //HR-PBM-PHASE 1-Begin
        // Looking for prefix SXC in the file name to set the value for Clearinghouse
        if (fName.substring(0,3).equalsIgnoreCase("SXC")) {
          vClearinghouse = "752578509";
        }
        else {
          vClearinghouse = "403400000";
        }
        //HR-PBM-PHASE 1-End
        loadReversalStatusRB2(FileUtils.readFile(vFile), vFileName, dbEM);
        loadRespProcess(vFileName, dbEM);
//        tranAmNcpdpRepos.setClearCacheOnCommit(true);
        vLogFile.println("Committing the database transaction");
        dbEM.getTransaction().commit();
        vLogFile.println("Commit successful");
        //HR-PBM-PHASE 1-Begin
        // Resetting the value for Clearinghouse.
        vClearinghouse = "";
        //HR-PBM-PHASE 1-End
        vLogFile.println("Reversal Status file : " + fName  + " has been Successfully loaded into eTrans Repository. ");
      }
      FileUtils.deleteFile(vFile);
      vLogFile.println("Reversal Status file : " + fName  + " has been Successfully Deleted. ");
    }
    catch(Exception e)
    {
//      e.printStackTrace();
//      e.printStackTrace(vLogFile);
//      tranAmNcpdpRepos.rollback();
  	  if(dbEM.getTransaction().isActive())
	  {
  		  e.printStackTrace();
		  vLogFile.println("Rolling back the database transaction");		  
		  dbEM.getTransaction().rollback();
		  vLogFile.println("Rollback successful");
	  }
      throw new DbTransactionEnderException("Rolled Back the Transaction", e);
    }
  }

//  private BufferedReader readFile(String clmIdFileName)
//  throws Exception
//  {
//    BufferedReader in = new BufferedReader( new FileReader(clmIdFileName) );
//    return in;
//  }
//
  private void loadReversalStatusRB2(BufferedReader in, String fName, EntityManager dbEM)
  throws IOException, SQLException
  {
    int iLineCnt = 0;
    String vBatchNumber = getBatchNum(fName, dbEM);
    while ( (loadRec = in.readLine()) != null )
    {
    	System.err.println(loadRec);
      if (loadRec.length() > 1 && !(loadRec.substring(0,18).equalsIgnoreCase("//////////////////")))
      {
        NcpdpRb2ReversalStatus crNcpdpRb2ReversalStatus = new NcpdpRb2ReversalStatus();
        crNcpdpRb2ReversalStatus.setB2RevStatusKey(UUID.randomUUID().toString().toUpperCase());
        crNcpdpRb2ReversalStatus.setBatchNumber(vBatchNumber);
        crNcpdpRb2ReversalStatus.setFileNumber(fName);
        crNcpdpRb2ReversalStatus.setDateSubmitted(loadRec.substring(0,8));
        crNcpdpRb2ReversalStatus.setDateOfService(loadRec.substring(8,16));
        crNcpdpRb2ReversalStatus.setRxNumber(loadRec.substring(16,23));
        crNcpdpRb2ReversalStatus.setNdcCode(loadRec.substring(23,37));
        crNcpdpRb2ReversalStatus.setQuantity(loadRec.substring(37,42));
        crNcpdpRb2ReversalStatus.setDaysSupply(loadRec.substring(42,46));
        crNcpdpRb2ReversalStatus.setAmtPaidVendor(loadRec.substring(46,54));
        crNcpdpRb2ReversalStatus.setBenePayment(loadRec.substring(54,62));
        crNcpdpRb2ReversalStatus.setPharmacyNumber(loadRec.substring(62,69));
        crNcpdpRb2ReversalStatus.setBeneSsn(loadRec.substring(69,78));
        crNcpdpRb2ReversalStatus.setBeneLastName(loadRec.substring(78,98));
        crNcpdpRb2ReversalStatus.setBeneFirstName(loadRec.substring(98,113));
        crNcpdpRb2ReversalStatus.setBeneDob(loadRec.substring(113,121));
        crNcpdpRb2ReversalStatus.setHacClaimNum(loadRec.substring(121,141));
        crNcpdpRb2ReversalStatus.setHacAmtPaidVendor(loadRec.substring(141,149));
        crNcpdpRb2ReversalStatus.setMmiRefNum(loadRec.substring(149,159));
        crNcpdpRb2ReversalStatus.setHacRetClaimNum(loadRec.substring(159,166));
        crNcpdpRb2ReversalStatus.setHacRetClmDatePaid(loadRec.substring(166,174));
        crNcpdpRb2ReversalStatus.setHacRetClmPaidAmt(loadRec.substring(174,182));
        //HR-PBM-PHASE 1-Begin
        // Replaced the hard coded value with variable 'vClearinghouse'
        //crNcpdpRb2ReversalStatus.setClearinghouse("403400000");
        crNcpdpRb2ReversalStatus.setClearinghouse(vClearinghouse);
        //HR-PBM-PHASE 1-End
        dbEM.persist(crNcpdpRb2ReversalStatus);
        //crNcpdpRb2ReversalStatus.setHacRetClmPaidCheckNum(loadRec.substring(182,192));
        //crNcpdpRb2ReversalStatus.setStatus("NEW");
        iLineCnt++;
      }
    }
    FileUtils.closeFile(in);
    insertProcessLog(iLineCnt, fName, dbEM);
  }

  private void loadRespProcess(String fName, EntityManager dbEM)
  //throws Exception
  {
	NcpdpResponseProcess crNcpdpResponseProcess = new NcpdpResponseProcess();
	NcpdpResponseProcessId id = new NcpdpResponseProcessId();
	id.setFileNumber(fName);
	id.setType("RB2");
	id.setStatus("NEW");
	id.setClearinghouse(vClearinghouse);
	crNcpdpResponseProcess.setId(id);
    dbEM.persist(crNcpdpResponseProcess);
  }

  private String getBatchNum(String fName, EntityManager dbEM)
  //throws Exception
  {
	  
    String vBatchNum = "";
    String vFileName = "RV" + fName.substring(2, fName.length());
    String strBatchNum = "SELECT BATCH_NUMBER FROM NCPDP_BATCH " + 
    					 "WHERE FILE_NUMBER = '" + vFileName + "' ";
	Query batchKeysQuery = dbEM.createNativeQuery(strBatchNum);
	List batchKeyList = batchKeysQuery.getResultList();	
	String nextBatchKey = "";
	Iterator batchKeyIterator = batchKeyList.iterator();
	if(batchKeyIterator.hasNext()) {
		return (String) batchKeyIterator.next();
	}
	else
	{
		//FOR PRODUCTION YOU MAY WANT TO UNCOMMENT THIS - TWP I have no idea what 
		//we need to do in this case
//		throw new RuntimeException("Could not find a batch number for a file." + vFileName);
		vLogFile.println("Could not find an ncpdp batch number in ncpdp_batch using : " + vFileName  + 
				" when looking up data for b2 reversal status ");
		return "???????";
	}
  }

  private void insertProcessLog(int iLineCnt, String fName, EntityManager dbEM)
  throws SQLException
  {    
    EdiProcessLog crEdiProcessLog = new EdiProcessLog();
    crEdiProcessLog.setEdiProcessId(UUID.randomUUID().toString().toUpperCase());
    crEdiProcessLog.setFileDate(new java.sql.Date(new GregorianCalendar().getTimeInMillis()));
    crEdiProcessLog.setProcessName("NCPDP RB2 REVERSAL STATUS LOAD TO EDI REPOSITORY");
    crEdiProcessLog.setMessage("NUM. OF NCPDP RB2 REVERSAL STATUS CLAIMS LOADED INTO EDI REPOSITORY FOR FILE : " + fName);
    crEdiProcessLog.setCounts(new Long(Integer.toString(iLineCnt)));
    crEdiProcessLog.setClaimType("NCPDP");
    crEdiProcessLog.setStatus("NEW");

    dbEM.persist(crEdiProcessLog);
  }



}