package gov.va.med.hac.edi.utils;

import java.io.*;

// This class collects utility methods used in EDI processes surrounding file
//   manipulations
public class FileUtils 
{
  // Treats the given string as a file to be read
  public static BufferedReader readFile(String clmIdFilePath)
  throws IOException
  {
    return new BufferedReader( new FileReader(clmIdFilePath)); 
  }

  // Close the given Reader
  public static void closeFile(Reader in)
  throws IOException
  {
    in.close();
  }    
    
  // Delete the file given as a parameter, without logging
  public static boolean deleteFile(String inFileName)
  {
    boolean success = false;
    if ((new File(inFileName)).exists())
    {
      success = (new File(inFileName)).delete();
    }
    
    return success;
  }
  
  // Delete the file given as the second parameter, logging to the first parameter
  public static void deleteFile(final PrintWriter vLogFile, final String inFileName) {
      // Call the other version of deleteFile to carry out the deletion
      final boolean success = deleteFile(inFileName);

      // Log the result
      if (success) {
        vLogFile.println("The file " + inFileName + " has been successfully deleted");
      } else {
        vLogFile.println("Unable to delete " + inFileName);
      }
  }
    
}