package gov.va.med.hac.edi.utils;

import java.io.*;
import java.sql.SQLException;
import java.util.GregorianCalendar;

// This class collects utility methods used in the main method of EDI processes,
//   such as dealing with log files
public class MainUtils 
{
  // 
  public static PrintWriter establishLogFile(String logDirName, String logFileName)
  throws FileNotFoundException {
    File logDir;
    File logFile;
    PrintWriter returnLogFile;
    
    // Make sure the directory is there
    logDir = new File(logDirName);
    if(!logDir.exists()) {
        logDir.mkdir();
    }
    
    // Establish the log file
    logFile = new File(logDirName + "/" + logFileName);
    returnLogFile = new PrintWriter(new FileOutputStream(logFile, true));
    
    return returnLogFile;  
  }

  public static void stampStartingTime(String heading, PrintWriter pLogFile) {
    // Stamp with the starting time
    pLogFile.println("========================================================") ;
    pLogFile.println(heading + ":"
        + DateUtil.getCurrentDateFormatted("MM/dd/yyyy") + " "
        + DateUtil.getCurrentTimeFormatted("HH:mm:ss:SSS"));
    pLogFile.println();
  }

  public static void stampEndingTime(String heading, PrintWriter pLogFile) {
    // Stamp with the ending time
    pLogFile.println() ;
    pLogFile.println(heading + ":"
        + DateUtil.getCurrentDateFormatted("MM/dd/yyyy") + " "
        + DateUtil.getCurrentTimeFormatted("HH:mm:ss:SSS"));
    pLogFile.println("========================================================") ;
    pLogFile.println();
  }

//  private void insertProcessLog(ApplicationModule inAppModule, int iLineCnt, String fName)
//  throws SQLException
//  {
//    ViewObject voEdiProcessLog = inAppModule.findViewObject("EdiProcessLogView1");
//    ViewRowImpl crEdiProcessLog = (ViewRowImpl) voEdiProcessLog.createRow();
//    crEdiProcessLog.setAttribute ("ediProcessId", ncpdpReposSupport.getGuid());
//    crEdiProcessLog.setFileDate(new java.sql.Date(new GregorianCalendar().getTimeInMillis()));
//    crEdiProcessLog.setProcessName("NCPDP RB1 CLAIM STATUS LOAD TO EDI REPOSITORY");
//    crEdiProcessLog.setMessage("NUM. OF NCPDP RB1 CLAIM STATUS LOADED INTO EDI REPOSITORY FOR FILE :" + fName);
//    crEdiProcessLog.setCounts(new BigDecimal(Integer.toString(iLineCnt)));
//    crEdiProcessLog.setClaimType("NCPDP");
//    crEdiProcessLog.setStatus("NEW");
//    
//    voEdiProcessLog.insertRow(crEdiProcessLog);
//  }  


}