package gov.va.med.hac.edi.utils.persistent;

import java.util.Date;

public class FeeClaimPayment {
	private long claimIndex;
	private int coveredDays = 0;
	private double diagnosisRelatedGroupWeight = 0.0;
	private double billedAmount = 0.0;
	private double paidAmount = 0.0;
	private double disbursedAmount = 0.0;
	private double interestAmount = 0.0;
	private double claimLevelAllowedAmount = 0.0;
	private String stationNumber = null;
	private String diagnosisRelatedGroupCode = null;
	private String routingNumber = null;
	private String accountNumber = null;
	private String feeInvoiceNumber = null;
	private String bankName = null;
	private String authorizationNumber = null;
	private String claimType = null;
	private Date periodStartDate = null;
	private Date periodEndDate = null;
	private Date feeInvoiceDate = null;
	
	/*
	 * Default Constructor
	 */
	public FeeClaimPayment() {
		super();
	}
	
	/**
	 * @param claimIndex
	 * @param coveredDays
	 * @param diagnosisRelatedGroupWeight
	 * @param billedAmount
	 * @param paidAmount
	 * @param disbursedAmount
	 * @param interestAmount
	 * @param claimLevelAllowedAmount
	 * @param stationNumber
	 * @param diagnosisRelatedGroupCode
	 * @param routingNumber
	 * @param accountNumber
	 * @param feeInvoiceNumber
	 * @param bankName
	 * @param authorizationNumber
	 * @param claimtype
	 * @param periodStartDate
	 * @param periodEndDate
	 * @param feeInvoiceDate
	 */
	public FeeClaimPayment(long claimIndex, int coveredDays,
			double diagnosisRelatedGroupWeight, double billedAmount,
			double paidAmount, double disbursedAmount,
			double interestAmount, double claimLevelAllowedAmount,
			String stationNumber, String diagnosisRelatedGroupCode,
			String routingNumber, String accountNumber,
			String feeInvoiceNumber, String bankName,
			String authorizationNumber, String claimType,
			Date periodStartDate, Date periodEndDate,
			Date feeInvoiceDate) {
		super();
		this.claimIndex = claimIndex;
		this.coveredDays = coveredDays;
		this.diagnosisRelatedGroupWeight = diagnosisRelatedGroupWeight;
		this.billedAmount = billedAmount;
		this.paidAmount = paidAmount;
		this.disbursedAmount = disbursedAmount;
		this.interestAmount = interestAmount;
		this.claimLevelAllowedAmount = claimLevelAllowedAmount;
		this.stationNumber = stationNumber;
		this.diagnosisRelatedGroupCode = diagnosisRelatedGroupCode;
		this.routingNumber = routingNumber;
		this.accountNumber = accountNumber;
		this.feeInvoiceNumber = feeInvoiceNumber;
		this.bankName = bankName;
		this.authorizationNumber = authorizationNumber;
		this.claimType = claimType;
		this.periodStartDate = periodStartDate;
		this.periodEndDate = periodEndDate;
		this.feeInvoiceDate = feeInvoiceDate;
	}
	
	/**
	 * @return the claimIndex
	 */
	public long getClaimIndex() {
		return claimIndex;
	}
	
	/**
	 * @param claimIndex the claimIndex to set
	 */
	public void setClaimIndex(long claimIndex) {
		this.claimIndex = claimIndex;
	}
	
	/**
	 * @return the coveredDays
	 */
	public int getCoveredDays() {
		return coveredDays;
	}
	
	/**
	 * @param coveredDays the coveredDays to set
	 */
	public void setCoveredDays(int coveredDays) {
		this.coveredDays = coveredDays;
	}
	
	/**
	 * @return the diagnosisRelatedGroupWeight
	 */
	public double getDiagnosisRelatedGroupWeight() {
		return diagnosisRelatedGroupWeight;
	}
	
	/**
	 * @param diagnosisRelatedGroupWeight the diagnosisRelatedGroupWeight to set
	 */
	public void setDiagnosisRelatedGroupWeight(double diagnosisRelatedGroupWeight) {
		this.diagnosisRelatedGroupWeight = diagnosisRelatedGroupWeight;
	}
	
	/**
	 * @return the billedAmount
	 */
	public double getBilledAmount() {
		return billedAmount;
	}
	
	/**
	 * @param billedAmount the billedAmount to set
	 */
	public void setBilledAmount(double billedAmount) {
		this.billedAmount = billedAmount;
	}
	
	/**
	 * @return the paidAmount
	 */
	public double getPaidAmount() {
		return paidAmount;
	}
	
	/**
	 * @param paidAmount the paidAmount to set
	 */
	public void setPaidAmount(double paidAmount) {
		this.paidAmount = paidAmount;
	}
	
	/**
	 * @return the disbursedAmount
	 */
	public double getDisbursedAmount() {
		return disbursedAmount;
	}
	
	/**
	 * @param disbursedAmount the disbursedAmount to set
	 */
	public void setDisbursedAmount(double disbursedAmount) {
		this.disbursedAmount = disbursedAmount;
	}
	
	/**
	 * @return the interestAmount
	 */
	public double getInterestAmount() {
		return interestAmount;
	}
	
	/**
	 * @param interestAmount the interestAmount to set
	 */
	public void setInterestAmount(double interestAmount) {
		this.interestAmount = interestAmount;
	}
	
	/**
	 * @return the claimLevelAllowedAmount
	 */
	public double getClaimLevelAllowedAmount() {
		return claimLevelAllowedAmount;
	}
	
	/**
	 * @param claimLevelAllowedAmount the claimLevelAllowedAmount to set
	 */
	public void setClaimLevelAllowedAmount(double claimLevelAllowedAmount) {
		this.claimLevelAllowedAmount = claimLevelAllowedAmount;
	}
	
	/**
	 * @return the stationNumber
	 */
	public String getStationNumber() {
		return stationNumber;
	}
	
	/**
	 * @param stationNumber the stationNumber to set
	 */
	public void setStationNumber(String stationNumber) {
		this.stationNumber = stationNumber;
	}
	
	/**
	 * @return the diagnosisRelatedGroupCode
	 */
	public String getDiagnosisRelatedGroupCode() {
		return diagnosisRelatedGroupCode;
	}
	
	/**
	 * @param diagnosisRelatedGroupCode the diagnosisRelatedGroupCode to set
	 */
	public void setDiagnosisRelatedGroupCode(String diagnosisRelatedGroupCode) {
		this.diagnosisRelatedGroupCode = diagnosisRelatedGroupCode;
	}
	
	/**
	 * @return the routingNumber
	 */
	public String getRoutingNumber() {
		return routingNumber;
	}
	
	/**
	 * @param routingNumber the routingNumber to set
	 */
	public void setRoutingNumber(String routingNumber) {
		this.routingNumber = routingNumber;
	}
	
	/**
	 * @return the accountNumber
	 */
	public String getAccountNumber() {
		return accountNumber;
	}
	
	/**
	 * @param accountNumber the accountNumber to set
	 */
	public void setAccountNumber(String accountNumber) {
		this.accountNumber = accountNumber;
	}
	
	/**
	 * @return the feeInvoiceNumber
	 */
	public String getFeeInvoiceNumber() {
		return feeInvoiceNumber;
	}
	
	/**
	 * @param feeInvoiceNumber the feeInvoiceNumber to set
	 */
	public void setFeeInvoiceNumber(String feeInvoiceNumber) {
		this.feeInvoiceNumber = feeInvoiceNumber;
	}
	
	/**
	 * @return the bankName
	 */
	public String getBankName() {
		return bankName;
	}
	
	/**
	 * @param bankName the bankName to set
	 */
	public void setBankName(String bankName) {
		this.bankName = bankName;
	}

	/**
	 * @return the authorizationNumber
	 */
	public String getAuthorizationNumber() {
		return authorizationNumber;
	}
	/**
	 * @param authorizationNumber the authorizationNumber to set
	 */
	public void setAuthorizationNumber(String authorizationNumber) {
		this.authorizationNumber = authorizationNumber;
	}
	/**
	 * @return the claimType
	 */
	public String getClaimType() {
		return claimType;
	}

	/**
	 * @param claimType the claimType to set
	 */
	public void setClaimType(String claimType) {
		this.claimType = claimType;
	}

	/**
	 * @return the periodStartDate
	 */
	public Date getPeriodStartDate() {
		return periodStartDate;
	}
	
	/**
	 * @param periodStartDate the periodStartDate to set
	 */
	public void setPeriodStartDate(Date periodStartDate) {
		this.periodStartDate = periodStartDate;
	}
	
	/**
	 * @return the periodEndDate
	 */
	public Date getPeriodEndDate() {
		return periodEndDate;
	}
	
	/**
	 * @param periodEndDate the periodEndDate to set
	 */
	public void setPeriodEndDate(Date periodEndDate) {
		this.periodEndDate = periodEndDate;
	}
	
	/**
	 * @return the feeInvoiceDate
	 */
	public Date getFeeInvoiceDate() {
		return feeInvoiceDate;
	}
	
	/**
	 * @param feeInvoiceDate the feeInvoiceDate to set
	 */
	public void setFeeInvoiceDate(Date feeInvoiceDate) {
		this.feeInvoiceDate = feeInvoiceDate;
	}
	
}
