package gov.va.med.hac.edi.era.jpa;

import gov.va.med.hac.edi.regression.Edi835ErrorQueueRegression;
import gov.va.med.hac.edi.regression.HacStg835LoadRegression;
import gov.va.med.hac.edi.regression.RegressionTestingUtils;
import gov.va.med.hac.edi.regression.StgToEreposRegression;

import java.sql.Connection;
import java.util.Properties;

import org.testng.annotations.Test;

public final class Edi835ErrorQueueRegressionTest {

	  @Test
	  public void errorQueueRegressionTest() throws Exception {
		  
		Properties props = RegressionTestingUtils.getPropertiesFromFile("edi835errorqueue.properties", this.getClass());
//		Properties hacStgLoad835Props = new Properties();
//		hacStgLoad835Props.put("java.exec", props.get("java.exec"));
//		hacStgLoad835Props.put("same.schema", props.get("same.schema"));
//		hacStgLoad835Props.put("legacy.schema.name",props.get("legacy.schema.name"));
//		hacStgLoad835Props.put("legacy.table.suffix",props.get("legacy.table.suffix"));
//		hacStgLoad835Props.put("new.schema.name",props.get("new.schema.name"));
//		hacStgLoad835Props.put("new.table.suffix",props.get("new.table.suffix"));		
//		hacStgLoad835Props.put("table.names", props.get("table.names"));
//		hacStgLoad835Props.put("legacy.staging.dir",props.get("legacy.staging.dir"));
//		hacStgLoad835Props.put("legacy.loading.dir",props.get("legacy.loading.dir"));
//		hacStgLoad835Props.put("legacy.javaargs",props.get("legacy.javaargs"));
//		hacStgLoad835Props.put("legacy.process",props.get("legacy.process"));
//		hacStgLoad835Props.put("legacy.appargs",props.get("legacy.appargs"));		
//		hacStgLoad835Props.put("legacy.classpath",props.get("legacy.classpath"));				
//		hacStgLoad835Props.put("new.staging.dir",props.get("new.staging.dir"));
//		hacStgLoad835Props.put("new.loading.dir",props.get("new.loading.dir"));		
//		hacStgLoad835Props.put("new.appargs",props.get("new.file.to.load"));		
//
//		Connection conn = RegressionTestingUtils.getDatabaseConnection(this.getClass());
//		HacStg835LoadRegression regression = new HacStg835LoadRegression(conn, hacStgLoad835Props, true);
//		int diffs = regression.dataLoadRegression();	
						
		Properties stgToEreposProperties = new Properties();
		stgToEreposProperties.put("java.exec", props.get("java.exec"));
		stgToEreposProperties.put("same.schema", props.get("same.schema"));		
		stgToEreposProperties.put("table.names", props.get("table.names"));
		stgToEreposProperties.put("legacy.classpath",props.get("legacy.classpath"));
		stgToEreposProperties.put("legacy.classpath2",props.get("legacy.classpath2"));
		stgToEreposProperties.put("legacy.staging.dir",props.get("legacy.staging.dir"));
		stgToEreposProperties.put("legacy.loading.dir",props.get("legacy.loading.dir"));		
		stgToEreposProperties.put("legacy.javaargs",props.get("legacy.javaargs"));
		stgToEreposProperties.put("legacy.process",props.get("legacy.process"));
		stgToEreposProperties.put("legacy.process2",props.get("legacy.process2"));
		stgToEreposProperties.put("legacy.appargs",props.get("legacy.appargs"));				
		stgToEreposProperties.put("legacy.schema.name",props.get("legacy.schema.name"));
		stgToEreposProperties.put("legacy.table.suffix",props.get("legacy.table.suffix"));
		stgToEreposProperties.put("new.staging.dir",props.get("new.staging.dir"));
		stgToEreposProperties.put("new.loading.dir",props.get("new.loading.dir"));				
		stgToEreposProperties.put("new.schema.name",props.get("new.schema.name"));
		stgToEreposProperties.put("new.table.suffix",props.get("new.table.suffix"));		
										
		Connection conn = RegressionTestingUtils.getDatabaseConnection(this.getClass());
		StgToEreposRegression regression2 = new StgToEreposRegression(conn, stgToEreposProperties, true);
		int diffs = regression2.dataLoadRegression();
		assert diffs == 0;
		
		//At this point the HAC Stage and Erepos Load have occured and should be the same
		//Now we are ready to test ErrorQueue
		//We will insert a dummy record in TRLog
		//Leave the current data where it is - don't clear the tables etc.
		//save backup of orig tables
		//Run Legacy Code
		//copy tables over to orig
		//copy backup data back to erepos
		//Run New Code 
		//compare with the orig tables
		
		Edi835ErrorQueueRegression edi835ErrorQueueRegression = new Edi835ErrorQueueRegression(conn, props, null);
		diffs = edi835ErrorQueueRegression.dataLoadRegression();
		assert(diffs==0);
	    	    
	  }
	  
	  	  
}
