package gov.va.med.hac.edi.extract.b1.jpa;


import gov.va.med.domain.erepos.*;


import java.io.ByteArrayOutputStream;
import java.io.PrintWriter;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import javax.persistence.EntityManager;

import org.testng.annotations.Test;


public class ProcessRxExtractB1Test {
	HashMap<Object,Object> objectsTraversed = new HashMap();
	HashMap<String,Integer> exceptions = new HashMap();
	TreeSet<String> watchList = new TreeSet();

	private void createNonStandardNumberOfCarates()
	{
		exceptions.put("gov.va.med.domain.erepos.NcpdpCobOpPatRespAmount.opPatRespAmntPdQual",54);
		exceptions.put("gov.va.med.domain.erepos.NcpdpCobBeneStgAmount.beneStgQual",54);
		exceptions.put("gov.va.med.domain.erepos.NcpdpClaim.ncpdpCompounds",49);
		exceptions.put("gov.va.med.domain.erepos.NcpdpCompound.ncpdpCompoundIngrs",49);
		exceptions.put("gov.va.med.domain.erepos.NcpdpCobOtPayerAmount.otPyrAmtPdQual",54);
		exceptions.put("gov.va.med.domain.erepos.NcpdpHeader.ncpdpInsurances",0 );
		exceptions.put("gov.va.med.domain.erepos.NcpdpHeader.ncpdpPatients",0);
		exceptions.put("gov.va.med.domain.erepos.NcpdpCompoundIngr.ncpdpCmpIngdtMods",55);
		exceptions.put("gov.va.med.domain.erepos.NcpdpCobOtPayer.ncpdpCobBeneStgAmounts", 54);
		exceptions.put("gov.va.med.domain.erepos.NcpdpCobOtPayer.ncpdpCobOtPayerAmounts", 54);
		exceptions.put("gov.va.med.domain.erepos.NcpdpCobOtPayer.ncpdpCobOpPatRespAmounts", 54);
		exceptions.put("gov.va.med.domain.erepos.NcpdpCobOtPayer.ncpdpCobOtPayerRejects", 55);
		exceptions.put("gov.va.med.domain.erepos.NcpdpCob.ncpdpCobOtPayers", 42);
		exceptions.put("gov.va.med.domain.erepos.NcpdpClaim.ncpdpCobs",  42);
	}

	private void createWatchList()
	{

	}

	public static void main(String [] args)
	{

		try {
			ProcessRxExtractB1Test test = new ProcessRxExtractB1Test();

			test.createNonStandardNumberOfCarates();
			test.createWatchList();
			test.dataLoadAndExtractRegressionTest();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Test
	public void dataLoadAndExtractRegressionTest() throws Exception {

		EntityManager mockEntityManager = new MockEntityManager();
		MockPrintWriter mockPrintWriterImpl = new MockPrintWriter(new ByteArrayOutputStream());

		runCode( mockEntityManager,  mockPrintWriterImpl);

		int occurences = mockPrintWriterImpl.countOccurrences('^');
		//There should be
		assert occurences == 57;
	}


	void runCode(EntityManager mockEntityManager, PrintWriter mockPrintWriter) throws IllegalArgumentException, IllegalAccessException
	{
		Date today = new Date();
		Byte aByte = new Byte((byte)1);
		BigDecimal aBigDecimal = new BigDecimal(1);

		Set<NcpdpInsurance> ncpdpInsurances = new HashSet();
		ncpdpInsurances.add(new NcpdpInsurance("insuranceKey", (NcpdpHeader) null,
				" fileNumber", "segmentId", "crdhldrId",
				" crdhldrFirstName", " crdhldrLastName", " homePlan",
				" planId", " eligClarifyCd", " facilityId",
				" groupId", " personCode", " patRelshpCd",
				" createdBy", today, " modifiedBy",
				today, " medigapId", " medicaidInd",
				" prvdrAccptAssgnInd", " cmsPartdDefQualFac",
				" medicaidIdNbr", " medicaidAgencyNbr"));

		Set<NcpdpPatient> ncpdpPatients =  new HashSet();
		ncpdpPatients.add(new NcpdpPatient(" patientKey", (NcpdpHeader) null,
				" fileNumber", " segmentId", " patIdQual",
				" patId", " dateOfBirth", " patGenderCode",
				" patFirstName", " patLastName", " patStreetAddr",
				" patCityAddr", " patStateProvAddr", " patZipPstZone",
				" patPhoneNum", " patLocation", " employerId",
				" smkrNonsmkrCd", " pregnancyInd", " createdBy",
				today, " modifiedBy", today,
				aByte, " patEmail", aByte));

		NcpdpHeader ncpdpHeader =new NcpdpHeader("realKey", (NcpdpBatch) null,
				"fileNumber", "transactionRefNum", "binNumber",
				"verRelNum", "transactionCode", "prserCtlNum",
				"transactionCount", "svcPrvQual", "svcPrv",
				"dateOfService", "swVdrCertId", "createdBy",
				today, "modifiedBy",today,
				(Set<NcpdpClaim>) null, ncpdpInsurances,
				ncpdpPatients);


		Set<NcpdpCmpIngdtMod> ncpdpCmpIngdtMods =  new HashSet();
		ncpdpCmpIngdtMods.add(new NcpdpCmpIngdtMod( "cmpIngdtModKey",
				(NcpdpCompoundIngr) null,"  fileNumber",
				"cmpIngdtModCd","  sequenceNum","  createdBy",
				today,"  modifiedBy", today));

		Set<NcpdpCompoundIngr> ncpdpCompoundIngrs =  new HashSet();
		ncpdpCompoundIngrs.add(new NcpdpCompoundIngr(" compoundIngredKey",
				(NcpdpCompound) null, " fileNumber",
				" cmpPrdtIdQual", " cmpPrdtId", aBigDecimal ,
				aBigDecimal, " cmpIngdtCostDet",
				" sequenceNum", " createdBy", today,
				" modifiedBy", today, aByte,
				ncpdpCmpIngdtMods));

		Set<NcpdpCompound> ncpdpCompounds =  new HashSet();
		ncpdpCompounds.add(new NcpdpCompound("compoundKey", (NcpdpClaim) null,
				"fileNumber","  segmentId","  cmpDsgFrmDesCd",
				"cmpDispUntFrIn","  cmpRtOfAdmin","  cmpIngdtCompCnt",
				"createdBy", today,"  modifiedBy",
				today,ncpdpCompoundIngrs));


		Set<NcpdpCobBeneStgAmount> ncpdpCobBeneStgAmounts =  new HashSet();
		ncpdpCobBeneStgAmounts.add(new NcpdpCobBeneStgAmount("beneStgAmountKey",
				(NcpdpCobOtPayer)null,"  fileNumber",
				"beneStgQual", aBigDecimal,"  sequenceNum",
				"createdBy", today,"  modifiedBy", today));


		Set<NcpdpCobOpPatRespAmount> ncpdpCobOpPatRespAmounts =  new HashSet();
		ncpdpCobOpPatRespAmounts.add(new NcpdpCobOpPatRespAmount("opPayerRespAmountKey",
				(NcpdpCobOtPayer) null,"  fileNumber",
				"opPatRespAmntPdQual",aBigDecimal,
				"sequenceNum","  createdBy", today,
				"modifiedBy", today));

		Set<NcpdpCobOtPayerReject> ncpdpCobOtPayerRejects =  new HashSet();
		ncpdpCobOtPayerRejects.add(new NcpdpCobOtPayerReject("otPayerRejectKey",
				(NcpdpCobOtPayer) null,"  fileNumber",
				"otPyrRejCd","  sequenceNum","  createdBy",
				today,"  modifiedBy", today));

		Set<NcpdpCobOtPayerAmount> ncpdpCobOtPayerAmounts =  new HashSet();
		ncpdpCobOtPayerAmounts.add(new NcpdpCobOtPayerAmount("otPayerAmountKey",
				(NcpdpCobOtPayer) null,"  fileNumber",
				"otPyrAmtPdQual",aBigDecimal,"  sequenceNum",
				"createdBy", today,"  modifiedBy",
				today));

		Set<NcpdpCobOtPayer> ncpdpCobOtPayers =  new HashSet();
		ncpdpCobOtPayers.add(new NcpdpCobOtPayer("otPayerKey",(NcpdpCob)null,
				"fileNumber","  otPayerCvgType","  otPayerIdQual",
				"otherPayerId","  otherPayerDate","  otPyrAmtPdCnt",
				"otPyrRejCnt","  sequenceNum","  createdBy",
				today,"  modifiedBy", today,
				"internalCntrlNbr",aBigDecimal,
				aByte,ncpdpCobBeneStgAmounts,
				ncpdpCobOpPatRespAmounts,
				ncpdpCobOtPayerAmounts,
				ncpdpCobOtPayerRejects));

		Set<NcpdpCob> ncpdpCobs =  new HashSet();
		ncpdpCobs.add(new NcpdpCob("cobKey",(NcpdpClaim) null,"  fileNumber",
				"segmentId","  cobOtPymtCnt","  createdBy",
				today,"  modifiedBy", today,
				ncpdpCobOtPayers));


		Set<NcpdpPricing> ncpdpPricings = new HashSet();
		ncpdpPricings.add(new NcpdpPricing("pricingKey", (NcpdpClaim) null, "fileNumber",
				"  segmentId", aBigDecimal, aBigDecimal, aBigDecimal,
				aBigDecimal, aBigDecimal, "otAmtClaimSubCnt", aBigDecimal,
				aBigDecimal, aBigDecimal, "pctSleTaxBsSub", aBigDecimal,
				aBigDecimal, "  basisOfCostDetm", "  createdBy", today,
				"  modifiedBy", today, aBigDecimal,
				(Set<NcpdpPricingOtAmount>) null));

		Set<NcpdpPrescriber> ncpdpPrescribers =  new HashSet();
		ncpdpPrescribers.add(new NcpdpPrescriber("prescriberKey",(NcpdpClaim) null,
				"fileNumber","  segmentId","  prescriberIdQual",
				"prescriberId","  prescriberLocCd",
				"prescriberLastNm","  prescriberPhNum",
				"priCarePrvIdQl","  priCarePrvId","  priCarePrvLcCd",
				"priCarePrvLsNm","  createdBy", today,
				"modifiedBy", today,"  prescriberFname",
				"prescriberAddress","  prescriberCity",
				"prescriberState","  prescriberZip"));


		NcpdpClaim claim = new NcpdpClaim("claimKey", ncpdpHeader,
				"fileNumber","  batchKey","  patientKey",
				"segmentId","  rxSvcRefNumQual","  rxSvcRefNum",
				"productSvcIdQual","  productSvcId",
				"asoRxSvcRefNum","  asoRxSvcDate","  procModCdCount",
				(long)1000,"  fillNumber","  daysSupply",
				"compoundCode","  dawPrdtSelCd","  dateRxWritten",
				"noOfRefilsAuth","  rxOriginCd","  subClftnCd",
				aBigDecimal,"  otCvgCd","  unitDoseInd",
				"orgPrsPrdSvcQl","  orgPrsPrdSvcCd",aBigDecimal,
				"alternateId","  schRxIdNum","  unitOfMeasure",
				"levelOfService","  priorAuthTypeCd",
				"priorAuthNumSub","  intmdyAuthTypeI",
				"intmdyAuthId","  dispensingStatus",
				aBigDecimal,"  daysSupIntdDisp","  claimType",
				"networkIndicator","  status","  createdBy",
				today,"  modifiedBy", today,
				"senderId",aByte,"  patAssgnInd",
				"rteOfAdmin","  compoundType",aByte,
				aByte, Boolean.TRUE,"medicaidSbrgtnIcntcn",
				(Set<NcpdpCoupon>) null,
				(Set<NcpdpWorkComp>) null,ncpdpCobs,
				(Set<NcpdpClinical>) null,
				(Set<NcpdpFacility>) null,
				(Set<NcpdpNarrative>) null,
				(Set<NcpdpClaimSubClarif>) null,
				ncpdpPricings,
				ncpdpPrescribers,
				(Set<NcpdpProvider>) null,
				(Set<NcpdpPriorAuth>) null,
				ncpdpCompounds,
				(Set<NcpdpClaimProcMod>) null,
				(Set<NcpdpAdtlDocument>) null,
				(Set<NcpdpDurPps>) null);


		List claims = new ArrayList();
		claims.add(claim);
		ProcessRxExtractB1 extractExecution = new ProcessRxExtractB1();


		extractExecution.createClaimRecords(ncpdpHeader, mockPrintWriter,
				mockEntityManager, "vSenderId", "vBatchNumber", "vSvcPrv", "vNpiTin",
				"vTransRefNum", "vDateOfSvc", new ArrayList(), new StringBuffer(), claims);

		buildTestingPermutationList(claim);

		Iterator keysInCache = objectsTraversed.keySet().iterator();
		while(keysInCache.hasNext())
		{
			Object key = keysInCache.next();
			if(key instanceof String)
			{
				Object[] value = (Object [])objectsTraversed.get(key);
				Object originalFieldValue = ((Field)value[0]).get(value[1]);
				if(originalFieldValue != null)
				{
					((Field)value[0]).set(value[1],null);
					try {
						((MockPrintWriter) mockPrintWriter).reset();

						extractExecution.createClaimRecords(ncpdpHeader, mockPrintWriter,
								mockEntityManager, "vSenderId", "vBatchNumber", "vSvcPrv", "vNpiTin",
								"vTransRefNum", "vDateOfSvc", new ArrayList(), new StringBuffer(), claims);
						
					}catch(Throwable t)
					{
						
						t.printStackTrace();
						System.err.println("EXCEPTION FAILURE:" + key );	
						((MockPrintWriter) mockPrintWriter).printContent();
						
					}finally
					{
						//Restore original value
						((Field)value[0]).set(value[1],originalFieldValue);
					}
					int occurences = ((MockPrintWriter) mockPrintWriter).countOccurrences('^');
					if(exceptions.containsKey(key))
					{
						if(occurences != (Integer)exceptions.get(key))
						{
							System.out.println("FAILURE:" + key + " Only produced: " + occurences + "^");
						}

					}else
						if(occurences != 57)
						{
							System.out.println("FAILURE:" + key + " Only produced: " + occurences + "^");
						}
				}
			}
		}

		((MockPrintWriter) mockPrintWriter).reset();
		extractExecution.createClaimRecords(ncpdpHeader, mockPrintWriter,
				mockEntityManager, "vSenderId", "vBatchNumber", "vSvcPrv", "vNpiTin",
				"vTransRefNum", "vDateOfSvc", new ArrayList(), new StringBuffer(), claims);
		int occurences = ((MockPrintWriter) mockPrintWriter).countOccurrences('^');
		System.out.println("FINAL SANITY CHECK: " + occurences + "^");


	}


	public void buildTestingPermutationList(Object instance) throws IllegalArgumentException, IllegalAccessException
	{
		//If we already saw this object dont add it to the list
		if(objectsTraversed.containsKey(instance)) return;

		Class c = instance.getClass();
		objectsTraversed.put(instance, "visited");

		//Store all the fields in the object in a permutation map
		//If the fied is one of our objects then
		Field[] fields = c.getDeclaredFields();
		for ( int i = 0; i < fields.length; i++ )
		{
			String fieldName = c.getName() + "." + fields[i].getName();
			fields[i].setAccessible(true);
			Object [] fieldObjectMapping= new Object[]{fields[i],instance };
			objectsTraversed.put(fieldName, fieldObjectMapping);

			if(fields[i].getType().getPackage().getName().startsWith("gov.va.med"))
			{
				Object o = fields[i].get(instance);
				if(o != null)
				{
					buildTestingPermutationList(o);
				}
			}

			if(Collection.class.isAssignableFrom(fields[i].getType()))
			{
				Collection aListOfChildren = (Collection) fields[i].get(instance);
				if(aListOfChildren != null)
				{
					Iterator childrenIterator = aListOfChildren.iterator();
					while(childrenIterator.hasNext())
					{
						Object o = childrenIterator.next();
						if(o != null)
						{
							buildTestingPermutationList(o);
						}
					}
				}
			}


		}

	}

}
