package gov.va.med.hac.edi.extract.b1.jpa;

import gov.va.med.hac.edi.reposload.ncpdp.jpa.NCPDPLoadRegressionTest;
import gov.va.med.hac.edi.regression.*;

import java.sql.Connection;
import java.util.Properties;

import org.testng.annotations.*;

public class RxExtractB1RegressionTest {

  public void dataExtractRegressionTest() throws Exception {
    Properties props = RegressionTestingUtils.getPropertiesFromFile("rxextractb1.properties", this.getClass());
    Connection conn = RegressionTestingUtils.getDatabaseConnection(this.getClass());
    RxExtractB1Regression regression = new RxExtractB1Regression(conn, props, true);
    
    System.out.println("Going to dataExtractRegression");
    
    int diffs = regression.dataExtractRegression();
    
    // Make sure there were no diffs
    System.out.println("Total Diffs: " + diffs);
    assert diffs == 0;
    
    // Check that the statuses were updated to PROCESSED
    int newClaimsCount = regression.getClaimCount("NEW");
    System.out.println("new claims:" + newClaimsCount);
    assert newClaimsCount == 0;
    
    int processedClaimsCount = regression.getClaimCount("PROCESSED");
    System.out.println("processed claims:" + processedClaimsCount);
    assert processedClaimsCount > 0;
    
  }

  @Test
  public void dataLoadAndExtractRegressionTest() throws Exception {
    NCPDPLoadRegressionTest loadTest = new NCPDPLoadRegressionTest();
    
    // Run the load test
    loadTest.dataLoadRegressionTest();
    
    System.out.println("Finished with loading");
    
    // Run the extract test
    dataExtractRegressionTest();
    
  }
}
