package gov.va.med.hac.edi.extract.x12.jpa;

import gov.va.med.hac.edi.reposload.x12.jpa.X12eReposLoadRegressionTest;
import gov.va.med.hac.edi.regression.*;

import java.sql.Connection;
import java.util.Properties;

import org.testng.annotations.*;

public class CacheX12ExtractRegressionTest {

  public void dataExtractRegressionTest() throws Exception {
    Properties props = RegressionTestingUtils.getPropertiesFromFile("cacheX12extract.properties", this.getClass());
    Connection conn = RegressionTestingUtils.getDatabaseConnection(this.getClass());
    CacheX12ExtractRegression regression = new CacheX12ExtractRegression(conn, props, true);
    
    System.out.println("Going to dataExtractRegression");
    
    int diffs = regression.dataExtractRegression();
    
    // Make sure there were no diffs
    System.out.println("Total Diffs: " + diffs);
    assert diffs == 0;
    
    // Check that the statuses were updated to BUILT
    int newClaimsCount = regression.getClaimCount("NEW");
    System.out.println("new claims:" + newClaimsCount);
    assert newClaimsCount == 0;
    
    int processedClaimsCount = regression.getClaimCount("BUILT");
    System.out.println("processed claims:" + processedClaimsCount);
    assert processedClaimsCount > 0;
    
  }

  @Test
  public void dataLoadAndExtractRegressionTest() throws Exception {

	X12eReposLoadRegressionTest loadTest = new X12eReposLoadRegressionTest();
    
    // Run the load test
    loadTest.dataLoadRegressionTest();
    
    System.out.println("Finished with loading");
    
    // Run the extract test
    dataExtractRegressionTest();
    
  }
}
