package gov.va.med.hac.edi.regression;

import gov.va.med.hac.edi.reposload.ncpdp.jpa.NCPDPLoad;
import gov.va.med.hac.edi.utils.*;
import gov.va.med.hac.edi.utils.jpa.DbTransactionEnderException;

import java.io.IOException;
import java.sql.*;
import java.util.Properties;

import javax.naming.NamingException;

public class NCPDPLoadRegression extends LoadRegression {

  public NCPDPLoadRegression(Connection inConnection, Properties inProperties, Boolean inVerbose) {
    super(inConnection, inProperties, inVerbose);
  }

  /**
   * This method executes the refactored code in this JVM. If the refactored
   * process does not run correctly you may want to convert this method to use
   * a ProcessBuilder that sets up an isolated environment.
   * 
   * @throws Exception
   */
  public void runNewCode() throws IOException, NamingException, DbTransactionEnderException {
    String sourcePathOption = "-p";
    String loadDirectory = (String) properties.get("new.loading.dir");
    String[] args = new String[]{sourcePathOption, loadDirectory};
    NCPDPLoad.main(args);
  }

  public int getClaimCount() throws SQLException {
    // Make sure data got loaded
    Statement stmt = connection.createStatement();
    String claimCountQueryString = "SELECT COUNT (*) AS NUM_CLAIMS FROM NCPDP_CLAIM";
    ResultSet rs;
    rs = stmt.executeQuery(claimCountQueryString);
    
    // Get the result
    int numClaims = -1;
    if (rs.next()) {
      numClaims = rs.getInt("NUM_CLAIMS");
    }

    return numClaims;
  }

  public void resetStatusesOnSourceTables() throws SQLException {
    System.out.println("Don't forget to reset statuses!");
  }
}
