package gov.va.med.hac.edi.reposload.ncpdp.jpa;

import gov.va.med.hac.edi.regression.NCPDPLoadRegression;
import gov.va.med.hac.edi.regression.RegressionTestingUtils;

import java.sql.Connection;
import java.util.Properties;
import org.testng.annotations.Test;

public class NCPDPLoadRegressionTest {

  
  @Test
  public void dataLoadRegressionTest() throws Exception {
    Properties props = RegressionTestingUtils.getPropertiesFromFile("ncpdptest.properties", this.getClass());
    Connection conn = RegressionTestingUtils.getDatabaseConnection(this.getClass());
    NCPDPLoadRegression regression = new NCPDPLoadRegression(conn, props, true);
    int diffs = regression.dataLoadRegression();
    
    // Make sure there were no diffs
    System.out.println("Total Diffs: " + diffs);
    assert diffs == 0;
    
    // Make sure some claims got loaded
    int numClaims = regression.getClaimCount();
    System.out.println("numClaims: " + numClaims);
    assert numClaims > 0;
  }
}
