package gov.va.med.hac.edi.reposload.x12.jpa;

import gov.va.med.hac.edi.regression.x12eReposLoadRegression;
import gov.va.med.hac.edi.regression.RegressionTestingUtils;

import java.sql.Connection;
import java.util.Properties;
import org.testng.annotations.Test;

public class X12eReposLoadRegressionTest {

  
  @Test
  public void dataLoadRegressionTest() throws Exception {
    Properties props = RegressionTestingUtils.getPropertiesFromFile("x12ereposload.properties", this.getClass());
    Connection conn = RegressionTestingUtils.getDatabaseConnection(this.getClass());
    x12eReposLoadRegression regression = new x12eReposLoadRegression(conn, props, false);
    int diffs = regression.dataLoadRegression();
    
    // Make sure there were no diffs
    System.out.println("Total Diffs: " + diffs);
    assert diffs == 0;

    // Make sure some claims got loaded
    int numClaims = regression.getClaimCount();
    System.out.println("numClaims: " + numClaims);
    assert numClaims > 0;
  }
}
