package gov.va.med.hac.edi.utils.jpa;

import org.hibernate.*;

import org.testng.*;
import org.testng.annotations.*;
import org.hibernate.SessionFactory;


import gov.va.med.hac.edi.utils.jpa.HibernateUtil;

import java.io.File;
import java.net.URL;
import java.net.MalformedURLException;

public class HibernateUtilTest {

  @BeforeMethod (groups={"checkin", "functional"})
    public void reset(){
      HibernateUtil.sessionFactory = null;
    }

  @Test(groups = {"checkin", "functional"}, expectedExceptions = HibernateException.class)
    public void testCreationWOConfiguration() {
      assert HibernateUtil.getSessionFactory() != null : "Did not create SessionFactory with default hibernate config file";
    }

  @Test(groups = {"checkin", "functional"}, expectedExceptions = HibernateException.class)
    public void testConfigWNullFile() {
      File configfile = null;
      HibernateUtil.configure(configfile);
    }

  @Test(groups = {"checkin", "funtional"}, expectedExceptions = HibernateException.class)
    public void testConfiWBadFile() {
      File configfile = new File("basddfasd");
      HibernateUtil.configure(configfile);
    }


  @Test(groups = {"checkin", "functional"})
    public void testConfigWFile() {
      File configfile = new File("resources/hibernate.cfg.xml");
      HibernateUtil.configure(configfile);
      assert HibernateUtil.getSessionFactory() != null : "Could not configure SessionFactory with file";
    }


  @Test(groups = {"checkin", "functional"}, expectedExceptions = HibernateException.class)
    public void testConfigWNullUrl() {
      URL url = null;
      HibernateUtil.configure(url);
    }


  @Test(groups = {"checkin", "functional"}, expectedExceptions = HibernateException.class)
    public void testConfigWBadUrl() {
      URL url = null;
      try {url = new URL("file:///adfasdfa");} catch (MalformedURLException err) { }
      HibernateUtil.configure(url);
    }

  @Test(groups = {"checkin", "functional"})
    public void testConfigWUrl() {
      URL url = null;
      try {url = new URL("file:resources/hibernate.cfg.xml");} catch (MalformedURLException err) { }
      HibernateUtil.configure(url);
      assert HibernateUtil.getSessionFactory() != null : "Could not configure SessionFactory with URL";
    }

  @Test(groups = {"checkin", "functional"})
    public void testShutdown() { 
      HibernateUtil.configure();
      HibernateUtil.shutdown();
      try {
        HibernateUtil.getSessionFactory();
      } catch (HibernateException ex) {
        return;
      }
      Assert.fail("Did not throw Hibernate Exception when getSessionFactory is called after shutdown.") ;
    }

}
