package gov.va.med.hac.edi.utils.jpa;


import gov.va.med.hac.edi.utils.jpa.JPAUtil;

import java.io.File;
import java.io.FileNotFoundException;
import java.sql.SQLException;

import javax.persistence.EntityManager;


import org.testng.annotations.Test;

public class JPAUtilTest {

   @Test(groups = { "checkin" }, expectedExceptions = IllegalArgumentException.class)
   public void testJpaConfigFileWnullparam() throws Exception {
      JPAUtil.getJpaConfigFile(null);
   }

   @Test(groups = { "checkin" }, expectedExceptions = FileNotFoundException.class)
   public void testJpaConfigFileWnonexistfile() throws Exception {
      JPAUtil.getJpaConfigFile("adfasdfasdfasdf");
   }

   @Test(groups = { "checkin" })
   public void testJpaConfigWFileRelativePath() throws Exception {
      File file = JPAUtil.getJpaConfigFile("./resources/META-INF/persistence.xml");
      assert file != null : "cannot find file ./resources/hibernate.properties";
   }

   @Test(groups = { "checkin" })
   public void testJpaConfigWFileInCP() throws Exception {
      File file = JPAUtil.getJpaConfigFile("hibernate.properties");
      assert file != null : "cannot find file hibernate.properties in classpath";
   }

   @Test(groups = { "functional" })
   public void testgetEtntityManager() throws Exception {
      File file = JPAUtil.getJpaConfigFile("hibernate.properties");
      EntityManager em = JPAUtil.getEntityManager(file);
      assert em != null : "cannot created EntityManager";
   }

   @Test(groups = { "functional" })
   public void testRunDbProcedure() throws Exception {
      EntityManager em = JPAUtil.getEntityManager(JPAUtil.getJpaConfigFile("hibernate.properties"));
      String call = "{call fpps_owner.a(?1, ?2)}";
      JPAUtil.runDbProcedure(em, call, new Integer(0), "hello");
   }

   @Test(groups = { "functional" }, expectedExceptions = SQLException.class)
   public void testRunDbProcedureFail() throws Exception {
      EntityManager em = JPAUtil.getEntityManager(JPAUtil.getJpaConfigFile("hibernate.properties"));
      String call = "{call fpps_owner.a(?1, ?2)}";
      JPAUtil.runDbProcedure(em, call, new Integer(1), "hello");
   }
}
