/*
 * $Id: FeeMessages.java,v 1.1 2009/09/02 20:15:38 vhahacnguyes Exp $
 */
package gov.va.med.fee;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.faces.application.FacesMessage.Severity;
import javax.faces.context.FacesContext;

import org.jboss.seam.core.SeamResourceBundle;

/**
 * The class allows a message to be added to a specific component.  It is used mainly
 * for the text input field where the Seam FacesMessages didn't work.
 */
public class FeeMessages {

    /** The msg props. */
    private static ResourceBundle msgProps = SeamResourceBundle.getBundle();

    /**
     * No public constructor.
     */
    private FeeMessages() {
    }

    /**
     * Adds a message.
     *
     * @param clientId the client id
     * @param sev the severity level
     * @param key the message key
     */
    public static void addFromResourceBundle(final String clientId,
            final Severity sev, final String key) {

        if (key == null) {
            return;
        }

        if (msgProps != null) {
            try {
                String msg = msgProps.getString(key);
                FacesContext context = FacesContext.getCurrentInstance();
                if (context != null) {
                    FacesMessage message = new FacesMessage();
                    message.setSeverity(sev);
                    message.setSummary(msg);
                    context.addMessage(clientId, message);
                }
            } catch (MissingResourceException mre) {
                mre.printStackTrace();
            }
        }
    }
}
