package gov.va.med.fee.claim;

import java.sql.Timestamp;



import static org.jboss.seam.ScopeType.SESSION;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import javax.ejb.Stateful;

import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.log.Log;

import javax.ejb.Remove;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;
import javax.persistence.Query;


/**
 * CarcRarcCrosswalkBean class.
 * This class implements the CarcRarcCrosswalk interface and handles the calculation and display of
 * all of the relevant fields in the GUI.
 * @author Bill Blackmon
 * @version 1.0
 * 
 * CHANGE ALL OF THIS TO FIT EDI PROJECT
 * HAPE EDI VA DO# 118-11-D-1009, TO#118-1009-0001; HARRIS 
 * (
  CARC_ID       NUMBER(15)                      NOT NULL,
  RARC_ID       VARCHAR2(15 BYTE),
  CREATED_BY    VARCHAR2(30 BYTE),
  DATE_CREATED  DATE
)
 * @author DNS   BLACKW
 *
 *
 * TO DO:
 * CREATE LISTS OF OUTPUT FOR VARIOUS QUERIES. Look at existing CARC/RARC lists and see how and where
 * they are implemented before re-inventing the wheel.
 *
 */
public class CarcRarcCrosswalkBean implements CarcRarcCrosswalk {
	
	
	/** The log. */
    @Logger
    private Log log;


    /** The em. */
    @PersistenceContext(unitName = "FPPS_Owner", type=PersistenceContextType.EXTENDED)
    private EntityManager em;
	
    // may need to be changed for display
    SimpleDateFormat formatter = new SimpleDateFormat("MM/dd/yyyy");
    DecimalFormat df = new DecimalFormat("$#0.00");

	
	Integer carcID;
	String rarcID;
	String createdBy;
	java.sql.Timestamp dateCreated;
	

	@Override
	public Timestamp getDateCreated() {
		// TODO Auto-generated method stub
		return dateCreated;
	}

	@Override
	public void setDateCreated(Timestamp date) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Integer getCarcID() {
		// TODO Auto-generated method stub
		return carcID;
	}

	@Override
	public void setCarcID(Integer carcID) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getRarcID() {
		// TODO Auto-generated method stub
		return rarcID;
	}

	@Override
	public void setRarcID(String rarcID) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getCreatedBy() {
		// TODO Auto-generated method stub
		return createdBy;
	}

	@Override
	public void setCreatedBy(String createdBy) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String toString() {
		return "CarcRarcCrosswalkBean [log=" + log + ", em=" + em
				+ ", formatter=" + formatter + ", df=" + df + ", carcID="
				+ carcID + ", rarcID=" + rarcID + ", createdBy=" + createdBy
				+ ", dateCreated=" + dateCreated + "]";
	}

	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((carcID == null) ? 0 : carcID.hashCode());
		result = prime * result
				+ ((createdBy == null) ? 0 : createdBy.hashCode());
		result = prime * result
				+ ((dateCreated == null) ? 0 : dateCreated.hashCode());
		result = prime * result + ((rarcID == null) ? 0 : rarcID.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CarcRarcCrosswalkBean other = (CarcRarcCrosswalkBean) obj;
		if (carcID == null) {
			if (other.carcID != null)
				return false;
		} else if (!carcID.equals(other.carcID))
			return false;
		if (createdBy == null) {
			if (other.createdBy != null)
				return false;
		} else if (!createdBy.equals(other.createdBy))
			return false;
		if (dateCreated == null) {
			if (other.dateCreated != null)
				return false;
		} else if (!dateCreated.equals(other.dateCreated))
			return false;
		if (rarcID == null) {
			if (other.rarcID != null)
				return false;
		} else if (!rarcID.equals(other.rarcID))
			return false;
		return true;
	}

	
	
	
}	// end class
