package gov.va.med.fee.claim;


import java.math.BigDecimal;

import javax.ejb.Local;

/**
 * 
 * @author Bill Blackmon
 * @version R1.25.1
 * 
 * HAPE POR VA DO# 118-11-D-1009, TO#118-1009-0001; HARRIS
 * 
 * This interface references the new fields added for payment information.
 * See ClaimPaymentBean for implementation
 *
 */
@Local
interface ClaimPayment {

	public String getCheckNumber(); 
	public void setCheckNumber(String checkNumber);
	
	
	
	BigDecimal getPaidAmount();
	void setPaidAmountFormatted(BigDecimal paidAmount);
	
	
	String getPaidAmountFormatted();
	void setPaidAmountFormatted(String paidAmount);
    
  	
	void setTreasuryPaymentDateFormatted(String date);
	String getTreasuryPaymentDateFormatted();
	
   
 	String getAdjReasonCodeOne();
	void setAdjReasonCodeOne(String adjReasonCodeOne);
	
	String getAdjAmtString();
	void setAdjAmtString(String adjAmtString);
	
	
	int getLineItemCount();
	void setLineItemCount(int lineItemCount);
	
	java.sql.Timestamp getLineItemTreasuryPaymentDate(); 
	void setLineItemTreasuryPaymentDate(java.sql.Timestamp date);
	
	String getLineItemTreasuryPaymentDateFormatted(); 
	void setLineItemTreasuryPaymentDateFormatted(String sdate);
	
	String getLineItemPaidAmountFormatted(); 
	void setLineItemPaidAmountFormatted(String lineItemPaidAmountFormatted);
	
	
	String getLineItemCheckNumber();
	void setLineItemCheckNumber(String lineItemCheckNumber);
	
	
	String getLineItemAdjAmts(); 
	void setLineItemAdjAmts(String lineItemAdjAmts);
		

	String getLineItemCodes(); 
	void setLineItemCodes(String lineItemCodes);
	
	
 
}	// end interface ClaimPayment
