/*
 * $Id: ClaimReroutingHistoryEntity.java,v 1.1 2009/08/05 15:08:58 vhahacdoansc Exp $
 */
package gov.va.med.fee.claim;

import gov.va.med.domain.fee.FeeClaimRouting;
import gov.va.med.domain.fee.FeeClaimRoutingsReason;

/**
 * The class ClaimReroutingHistoryEntity class holds data about the 
 * rerouting history of a claim.
 */
@SuppressWarnings("serial")
public class ClaimReroutingHistoryEntity {

    private FeeClaimRouting routing;
    private FeeClaimRoutingsReason routingReason;
  
    

    /**
     * Creates a new instance of ClaimReroutingHistoryEntity.
     */
    public ClaimReroutingHistoryEntity() {
        routing = new FeeClaimRouting();
        routingReason = new FeeClaimRoutingsReason();
    }

    /**
     * Constructs a <code>ClaimReroutingHistoryEntity</code> given a <code>FeeClaimRouting</code>
     * and <code>FeeClaimRoutingsReason</code> instance.
     * 
     * @param routing
     *            The FeeClaimRouting assoiated with the claim
     * @param reason
     *            The FeeClaimRoutingsReason information associated with the claim    
     */
    public ClaimReroutingHistoryEntity(FeeClaimRouting routing, FeeClaimRoutingsReason reason) {     
        this.routing = routing;
        this.routingReason = reason;
    }
    
    /**
     * Gets the routing.
     * 
     * @return routing.
     */
    public final FeeClaimRouting getRouting() {
        return this.routing;
    }

    /**
     * Sets the routing.
     * 
     * @param routing
     *          the FeeClaimRouting to set.
     */
    public final void setRouting(FeeClaimRouting routing) {
        this.routing = routing;
    }

    
    /**
     * Gets the routing reason.
     * 
     * @return routingReason.
     */
    public final FeeClaimRoutingsReason getRoutingReason() {
        return this.routingReason;
    }

    /**
     * Sets the routing reason.
     * 
     * @param routingReason
     *          the FeeClaimRoutingsReason to set.
     */
    public final void setRoutingReason(FeeClaimRoutingsReason routingReason) {
        this.routingReason = routingReason;
    }
}
