/*
 * $Id: ClaimSearchEntity.java,v 1.9 2009/08/29 23:32:16 vhahacmagdua Exp $
 */
package gov.va.med.fee.claim;

import gov.va.med.domain.fee.Claim;
import gov.va.med.domain.fee.PersonInfo;
import gov.va.med.domain.fee.ProviderInfo;
import java.io.Serializable;

/**
 * The class ClaimSearchEntity class holds multiple objects for the claim search
 * result screen.
 */
@SuppressWarnings("serial")
public class ClaimSearchEntity implements Serializable {

   private boolean isSelected;

   /** The <code>Claim</code> class. */
   private Claim claim;

   /**
    * The <code>Person</code> class associated with the <code>Claim</code>.
    */
   private PersonInfo person;

   /**
    * The <code>Provider</code> class associated with the <code>Claim</code>.
    */
   private ProviderInfo provider;
   
   private String sent_835_date;
   private String check_date;
   private String pdiNumber;

   /**
    * Creates a new instance of ClaimSearchEntity.
    */
   public ClaimSearchEntity() {
      isSelected = false;
      claim = new Claim();
      person = new PersonInfo();
      provider = new ProviderInfo();
   }

   /**
    * Constructs a <code>ClaimSearchEntity</code> given a <code>Claim</code> and
    * <code>Person</code> instance.
    * 
    * @param claim
    *           The claim
    * @param person
    *           The person information associated with the claim
    * @param provider
    *           The provider information associated with the claim
    */
   public ClaimSearchEntity(boolean isSelected, Claim claim, PersonInfo person, ProviderInfo provider) {
      this.isSelected = isSelected;
      this.claim = claim;
      this.person = person;
      this.provider = provider;
   }

   
   public ClaimSearchEntity(boolean isSelected, Claim claim, PersonInfo person, ProviderInfo provider, String sent_835_date, String check_date) {
	      this.isSelected = isSelected;
	      this.claim = claim;
	      this.person = person;
	      this.provider = provider;
	      this.sent_835_date = sent_835_date;
	      this.check_date = check_date;
	   }
   /**
    * Gets the claim.
    * 
    * @return claim.
    */
   public final Claim getClaim() {
// System.out.println("ClaimSearchEntity.getClaim() returning claim index: " + this.claim.getClaimIndex());   
      return this.claim;
   }

   /**
    * Sets the claim.
    * 
    * @param claim
    *           the Claim to set.
    */
   public final void setClaim(Claim claim) {
      this.claim = claim;
   }

   /**
    * Gets the person.
    * 
    * @return person.
    */
   public final PersonInfo getPerson() {
      return this.person;
   }

   /**
    * Sets the person.
    * 
    * @param person
    *           the Person to set.
    */
   public final void setPerson(PersonInfo person) {
      this.person = person;
   }

   /**
    * Gets the provider.
    * 
    * @return provider.
    */
   public final ProviderInfo getProvider() {
      return this.provider;
   }

   /**
    * Sets the provider.
    * 
    * @param provider
    *           the ProviderInfo to set.
    */
   public final void setProvider(ProviderInfo provider) {
      this.provider = provider;
   }

   public final void setIsSelected(boolean isSelected) {
      this.isSelected = isSelected;
   }

   public final boolean getIsSelected() {
      return this.isSelected;
   }
   
   public final String getSent_835_date() {
	   return sent_835_date;
   }
   
   public final void setSent_835_date( String sent_835_date) {
	   this.sent_835_date = sent_835_date;
   }   
   
   public final String getCheck_date(){
	   return check_date;
   }
   
   public final void setCheck_date( String check_date) {
	   this.check_date = check_date;
   } 
   
   public final String getPdiNumber(){
	   return this.pdiNumber;
   }
   
   public final void setPdiNumber(String pdiNumber){
	   this.pdiNumber = pdiNumber;
   }
   
}
