/*
 * $Id: LineItemEntity.java,v 1.1 2009/08/05 15:08:58 vhahacdoansc Exp $
 */
package gov.va.med.fee.claim;

import gov.va.med.domain.fee.ClaimProcedure;
import gov.va.med.domain.fee.ToothInfo;

/**
 * The class LineItemEntity class holds data about the claim procedure lines.
 */
@SuppressWarnings("serial")
public class LineItemEntity {

    private ClaimProcedure claimProcedure;
    private ToothInfo toothInfo;
    private ClaimPaymentBean claimPaymentBean;
    private NdcData ndcData;
    
  
    

    /**
     * Creates a new instance of LineItemEntity.
     */
    public LineItemEntity() {
        claimProcedure = new ClaimProcedure();
        toothInfo = new ToothInfo();
        claimPaymentBean = new ClaimPaymentBean();
    }
    
    
    // prevLIE = new LineItemEntity(cp1, ti1, cpb1, ndcData);
    
    /**
     * TEST
     * Constructs a <code>LineItemEntity</code> given a <code>ClaimProcedure</code>
     * and <code>ToothInfo</code> instance.
     * 
     * @param claimProcedure
     *            The ClaimProcedure associated with the claim line
     * @param toothInfo
     *            The ToothInfo associated with the the claim line
     */
    public LineItemEntity(ClaimProcedure claimProcedure, ToothInfo toothInfo, ClaimPaymentBean claimPaymentBean) {     
        this.claimProcedure = claimProcedure;
        this.toothInfo = toothInfo;
        this.claimPaymentBean = claimPaymentBean;
    }
    
    
    

    /**
     * Constructs a <code>LineItemEntity</code> given a <code>ClaimProcedure</code>
     * and <code>ToothInfo</code> instance.
     * 
     * @param claimProcedure
     *            The ClaimProcedure associated with the claim line
     * @param toothInfo
     *            The ToothInfo associated with the the claim line
     */
    public LineItemEntity(ClaimProcedure claimProcedure, ToothInfo toothInfo) {     
        this.claimProcedure = claimProcedure;
        this.toothInfo = toothInfo;
    }
    
    
    public LineItemEntity(ClaimProcedure cp1, ToothInfo ti1, ClaimPaymentBean cpb1, NdcData ndcData) {
		// TODO Auto-generated constructor stub
    	 this.claimProcedure = cp1;
         this.toothInfo = ti1;
         this.claimPaymentBean = cpb1;
         this.ndcData = ndcData;
 	}


	/**
     * Gets the claimPaymentBean
     * @return claimPaymentBean
     */
    public final ClaimPaymentBean getClaimPaymentBean() {
    	return this.claimPaymentBean;
    }
    
    
    
    /**
     * Sets the the claimPaymentBean
     * 
     */
    public final void setClaimPaymentBean(ClaimPaymentBean claimPaymentBean) {
    	this.claimPaymentBean = claimPaymentBean;
    }
    
    
    
    
    /**
     * Gets the claimProcedure.
     * 
     * @return claimProcedure.
     */
    public final ClaimProcedure getClaimProcedure() {
        return this.claimProcedure;
    }

    /**
     * Sets the claimProcedure.
     * 
     * @param claimProcedure
     *          the claimProcedure to set.
     */
    public final void setClaimProcedure(ClaimProcedure claimProcedure) {
        this.claimProcedure = claimProcedure;
    }

    
    /**
     * Gets the toothInfo reason.
     * 
     * @return toothInfo.
     */
    public final ToothInfo getToothInfo() {
        return this.toothInfo;
    }

    /**
     * Sets the toothInfo reason.
     * 
     * @param toothInfo
     *          the toothInfo to set.
     */
    public final void setToothInfo(ToothInfo toothInfo) {
        this.toothInfo = toothInfo;
    }


	public NdcData getNdcData() {
		return ndcData;
	}


	public void setNdcData(NdcData ndcData) {
		this.ndcData = ndcData;
	}
}
