/*
 * $Id: ManualReconClaimBean.java,v 1.9.4.1 2012/04/19 21:37:50 vhahacnguyes Exp $
 */
package gov.va.med.fee.claim;

import static org.jboss.seam.ScopeType.SESSION;
import gov.va.med.domain.fee.AdjustmentGroup;
import gov.va.med.domain.fee.AdjustmentReason;
import gov.va.med.domain.fee.AppUser;
import gov.va.med.domain.fee.CalcMethod;
import gov.va.med.domain.fee.Claim;
import gov.va.med.domain.fee.ClaimPayment;
import gov.va.med.domain.fee.ClaimPaymentType;
import gov.va.med.domain.fee.ClaimProcRecAdjust;
import gov.va.med.domain.fee.ClaimProcRecon;
import gov.va.med.domain.fee.ClaimProcRemitRemark;
import gov.va.med.domain.fee.ClaimProcStatus;
import gov.va.med.domain.fee.ClaimProcedure;
import gov.va.med.domain.fee.ClaimReconciliation;
import gov.va.med.domain.fee.PersonInfo;
import gov.va.med.domain.fee.ProviderInfo;
import gov.va.med.domain.fee.RemittanceRemark;
import gov.va.med.domain.fee.WsFacStatus;
import gov.va.med.fee.Constants;
import gov.va.med.fee.FeeMessages;

import java.io.Serializable;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.annotation.PostConstruct;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.faces.model.SelectItem;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.Transactional;
import org.jboss.seam.faces.FacesMessages;
import org.jboss.seam.international.StatusMessage.Severity;
import org.jboss.seam.log.Log;

/**
 * The Class ManualReconClaimBean.
 */
@SuppressWarnings("serial")
@Stateful
@Name("manualReconClaim")
@Scope(SESSION)
public class ManualReconClaimBean implements ManualReconClaim, Serializable {
	
	// private boolean DEBUG = true;

    /** The Constant CURRENCY_FORMAT. */
    private static final DecimalFormat CURRENCY_FORMAT = new DecimalFormat("$###,###.##");

    /** The Constant CURRENCY_PATTERN. */
    private static final Pattern CURRENCY_PATTERN = Pattern.compile("[0-9]*\\.?[0-9]{0,2}+");

    /** The log. */
    @Logger
    private Log log;
    
    
    
    /** The em. */
    @PersistenceContext
    private EntityManager em;
  
    /** The em. */
    // @PersistenceContext(unitName = "FPPS_Owner")
    // private EntityManager em;
    
    /** The entity. */
    private final ManualReconEntity entity = new ManualReconEntity();


    /** The app user. */
    @In(value = "appUser", required = true, scope = ScopeType.SESSION)
    private AppUser appUser;

    /** The faces messages. */
    @In
    private FacesMessages facesMessages;
    
 
    /** The manual recon selections. */
    @In(value = "manualReconSelections", create = true)
    private ManualReconSelections manualReconSelections;

    @In(value = "manualReconCalcMethod", create = true)
    private CalcMethod manualReconCalcMethod;

    @In(value = "acceptedClaimProcStatus", create = true)
    private ClaimProcStatus acceptedClaimProcStatus;

    private SelectItem[] remitCode;
    private SelectItem[] remitCode2;
    private SelectItem[] remitCode3;
    private SelectItem[] remitCode4;
    private SelectItem[] remitCode5;
    
    
    // private String adjReason1_id;
    
    private ManualReconSelectionsBean manualReconSelectionsBean;
  
    public SelectItem[] getRemitCode() {
		return remitCode;
	}


	public void setRemitCode(SelectItem[] remitCode) {
		this.remitCode = remitCode;
	}


	public SelectItem[] getRemitCode3() {
		return remitCode3;
	}


	public void setRemitCode3(SelectItem[] remitCode3) {
		this.remitCode3 = remitCode3;
	}


	public SelectItem[] getRemitCode4() {
		return remitCode4;
	}


	public void setRemitCode4(SelectItem[] remitCode4) {
		this.remitCode4 = remitCode4;
	}


	public SelectItem[] getRemitCode5() {
		return remitCode5;
	}


	public void setRemitCode5(SelectItem[] remitCode5) {
		this.remitCode5 = remitCode5;
	}


	public  SelectItem[] getRemitCode2() {
		return remitCode2;
	}


	public void setRemitCode2(SelectItem[] remitCode2) {
		this.remitCode2 = remitCode2;
	}
    
	
    
	 public ManualReconSelectionsBean getManualReconSelectionsBean() {
			return manualReconSelectionsBean;
	 }

	public void setManualReconSelectionsBean(ManualReconSelectionsBean manualReconSelectionsBean) {
		this.manualReconSelectionsBean = manualReconSelectionsBean;
	}
    
/**    
    private void setAdjReason1_id(String reasonId) {
    	this.adjReason1_id = reasonId;
    	this.manualReconSelectionsBean.setAdjReason1_id(reasonId);
	
    }
    
    
    public String getAdjReason1_id() {
		return adjReason1_id;
	}
**/


	public ManualReconSelections getManualReconSelections() {
		return manualReconSelections;
	}

	public void setManualReconSelections(ManualReconSelections manualReconSelections) {
		this.manualReconSelections = manualReconSelections;
	}

	
    /**
     * Setup claim.
     *
     * @param claimIndex the claim index
     *
     */
    public final void setupClaim(final Long claimIndex) {
        entity.clearUserEntries();
        entity.setClaimIndex(claimIndex);
        // entity.setActionListener(new AdjustmentReasonValueChangedListener());
        setupClaim();
    }

    
    
    
    /**
     * Gets the entity.
     *
     * @return the entity
     *
     */
    public final ManualReconEntity getEntity() {
        return entity;
    }

    /**
     * Setup procedure.
     */
    public final void setupProcedure() {
    	
    	try {
	        ClaimProcedure cp = em.find(ClaimProcedure.class, entity.getClaimProcId());
	        
	        entity.setClaimProcedure(cp);

	        log.debug("ManualReconClaimBean.setupProcedure() - 	SUCCESS ");
	        
    	}catch(Exception e) {
    		log.error("ManualReconClaimBean.setupProcedure error"); 
    	}
	        
	        
    }	// end setupProcedure()

    /**
     * Cancel.
     */
    public final void cancel() {
        setupClaim();
        entity.clearUserEntries();
    }

    /**
     * Submit.
     *
     * @return the string
     */
    public final String submit() {
     	 
     	 boolean status = true; 
         try {
        	
             status = process();
	
        } catch (Throwable t) {
            facesMessages.addFromResourceBundle(
                     Severity.ERROR,
                     "gov.va.med.fee.ManualRecon.ERROR");
            log.error(t);
            System.out.println("submit() - error from process(): " + t.getMessage() );
            t.printStackTrace();
        }
       
        
        setupClaim();
       
        if (status) {
            facesMessages.addFromResourceBundle(
                    Severity.INFO,
                    "gov.va.med.fee.ManualRecon.LINE_PAID",
                    entity.getClaimIndex().toString(),
                    entity.getClaimProcedure().getClaimProcedureSeq(),
                    entity.getPaymentType(),
                    CURRENCY_FORMAT.format(entity.getVaAmount())
                    );
            
            
            
            
            entity.clearUserEntries();
                
            return Constants.SUCCESS;
            
            
        } else {
  
            return null;
        }
       
        
       // return Constants.SUCCESS  ;
        
    }	// end submit()	
      

    /**
     * Setup claim.
     */
    private void setupClaim() {
     	
   	    boolean DEBUG = true;
    	
        Claim c = em.find(Claim.class, entity.getClaimIndex());
        em.refresh(c);
        entity.setVeteranName(getVeteranName(c.getPersonInfos()));
        entity.setBillingProvider(getBillingProvName(c.getProviderInfos()));
        entity.setServiceProvider(getServiceProvName(c.getProviderInfos()));

        Query q = em.createQuery("select cp from fClaimProcedure cp where cp.claim.claimIndex = :index order by cp.claimProcedureSeq");
        
        
        q.setParameter("index", entity.getClaimIndex());
        List<ClaimProcedure> cpl = q.getResultList();
        List<ClaimProcedure> cpl2 = new ArrayList<ClaimProcedure>();
        
        for (ClaimProcedure cp : cpl) {
            em.refresh(cp);
            cpl2.add(cp);
        }
        entity.setClaim(c);
        entity.setSortedClaimProcedures(cpl2);
        
    	log.debug("ManualReconClaimBean.setupClaim() - DONE");
    }

    private  List<RemittanceRemark>  setRemitRemarks(String[] remarks) {
    	List<RemittanceRemark> rr = new ArrayList();
    	
    	if( (remarks.length==0) || (remarks==null) || (remarks[0].toString().equalsIgnoreCase("")) ) {
    		 rr = null;
    		 return rr;
    	}
    	
    	for(String s :remarks) {
				RemittanceRemark r = new RemittanceRemark();
				r.setRemittanceRemarkCd(s);
				rr.add(r);
    	}
    	
    	
    	return rr;
    }


	/**
     * Process.
     *
     * @return true, if successful
     */
    @Transactional
    private boolean process() {
	    	
	        if (!checkForm()) {
	         	log.error("ManualReconClaimBean.process() - checkForm() returned false - EXITING");
		            return false;
	        }
	        
	        String username = appUser.getUserName();
	        Date currentDate = new Date();
   
  			ClaimProcedure claimProcedure = null;
			Claim claim = null;
			
//				em.flush();
			claim = em.find(Claim.class, entity.getClaimIndex());

			log.info("MaunalReconClaimBean.process() - current Claim is: " + claim.getClaimIndex());
			
			claimProcedure = em.find(ClaimProcedure.class, entity.getClaimProcId());
			
			log.info("process() - current Claim Procedure is: " + claimProcedure.getClaimProcId() );
	
	        ClaimReconciliation claimReconciliation = new ClaimReconciliation();
	        claimReconciliation.setCalcMethod(manualReconCalcMethod);
	        claimReconciliation.setSent835Flag('N');
	        claimReconciliation.setCreatedBy(username);
	        claimReconciliation.setDateCreated(currentDate);
	        claimReconciliation.setClaim(claim);
	        em.persist(claimReconciliation);

	        ClaimPaymentType claimPaymentType = manualReconSelections.getClaimPaymentType(entity.getPaymentType());
	        ClaimPayment claimPayment = new ClaimPayment();
	        claimPayment.setClaimPaymentType(claimPaymentType);
	        claimPayment.setClaim(claim);
	        claimPayment.setCreatedBy(username);
	        claimPayment.setDateCreated(currentDate);
	        claimPayment.setPaidAmount(entity.getVaAmount());
	        claimPayment.setPaymentBatchDate(entity.getPaymentDate());
	        claimPayment.setPaymentTrackingNumber(entity.getCheckNo());
	        claimPayment.setClaim(claim);
	        em.persist(claimPayment);
	        
	        ClaimProcRecon claimProcRecon = new ClaimProcRecon();
	        claimProcRecon.setClaimProcStatus(acceptedClaimProcStatus);
	        claimProcRecon.setCreatedBy(username);
	        claimProcRecon.setDateCreated(currentDate);
	        claimProcRecon.setPaidAmount(entity.getVaAmount());
	        claimProcRecon.setClaimPayment(claimPayment);
	        claimProcRecon.setClaimProcedure(claimProcedure);
	        claimProcRecon.setClaim(claim);
	        claimProcRecon.setClaimReconciliation(claimReconciliation);
	        em.persist(claimProcRecon);
	        
		        
	        String[] remitCode =  entity.getRemitCode();
        
        	// if there are selected remit codes write them
       		if (remitCode != null && remitCode.length > 0) {
       			
       			// pass array and get back ArrayList of RemittanceRemarks
       			 List<RemittanceRemark> remitRemarkList1 = setRemitRemarks(remitCode);   
        			
       			 ClaimProcRecAdjust cpra1 = new ClaimProcRecAdjust();
       			 
       			 
       			 	if(remitRemarkList1 != null) {
       			 		
       			 		// IF THERE ARE RECORDS.........CREATE A NEW ClaimProcRecAdjustment
       			 		cpra1 = 	getNewClaimProcRecAdjust(currentDate, claimProcRecon, entity.getAdjAmount1(),
       			 					entity.getAdjGroup1(), entity.getAdjReason1());
       			 
       			 			for (RemittanceRemark rr : remitRemarkList1) {
       			 				
				                ClaimProcRemitRemark cprr = new ClaimProcRemitRemark();
				                cprr.setCreatedBy(username);
				                cprr.setDateCreated(currentDate);
				                cprr.setClaimProcRecon(claimProcRecon);
				                cprr.setRemittanceRemark(rr);
				                cprr.setClaimProcRecon(claimProcRecon);	// WHY IS THIS DONE TWICE?
				                em.persist(cprr);
			            }	// end for record update
       			 			
       			 	}	// end of remitRemarkList loop
       			 	
       			 	// update the new ClaimProcRecAdjust that contains the new remarks
       			 	if(cpra1 != null) {
       			 		em.persist(cpra1);
       			 	}	// END ClaimProcRecAdjust update
       			 			
       		}	// end if remitcode check
	        

 // 2.       
        // process remittanceRemarks
        String[] remitCode2 = entity.getRemitCode2();
        
     // if there are selected remit codes write them
   		if (remitCode2 != null && remitCode2.length > 0) {
   			
   			// pass array and get back ArrayList of RemittanceRemarks
   			 List<RemittanceRemark> remitRemarkList2 = setRemitRemarks(remitCode2);   
   			 
   			 ClaimProcRecAdjust cpra2 = new ClaimProcRecAdjust();
   			
   			 if(remitRemarkList2 != null) {
    				 
   				cpra2 = 	getNewClaimProcRecAdjust(currentDate, claimProcRecon, entity.getAdjAmount2(),
		 					entity.getAdjGroup2(), entity.getAdjReason2());
		 	
   				 
   				 
     			 		for (RemittanceRemark rr : remitRemarkList2) {
    			 			
			                ClaimProcRemitRemark cprr = new ClaimProcRemitRemark();
			                cprr.setCreatedBy(username);
			                cprr.setDateCreated(currentDate);
			                cprr.setClaimProcRecon(claimProcRecon);
			                cprr.setRemittanceRemark(rr);
			                cprr.setClaimProcRecon(claimProcRecon);	// WHY IS THIS DONE TWICE?
			                em.persist(cprr);
				                
			            }	// end for record update
     			 		
     			 		
     			 		if(cpra2 != null) {
           			 		em.persist(cpra2);
           			 	
           			 	}	// END ClaimProcRecAdjust update
     			 		
    			}		
   		}	// end if remitcode check

        
        // process remittanceRemarks
        String[] remitCode3 = entity.getRemitCode3();
        
     // if there are selected remit codes write them
   		if (remitCode3 != null && remitCode3.length > 0) {
   			
   			// pass array and get back ArrayList of RemittanceRemarks
   			List<RemittanceRemark> remitRemarkList3 = setRemitRemarks(remitCode3);   
   			 
   			ClaimProcRecAdjust cpra3 = new ClaimProcRecAdjust();
   			 
   			if(remitRemarkList3 != null) {
   				
   				
   				cpra3 = getNewClaimProcRecAdjust(currentDate, claimProcRecon, entity.getAdjAmount3(),
 					entity.getAdjGroup3(), entity.getAdjReason3());
	
   			 			for (RemittanceRemark rr : remitRemarkList3) {
   			 				
			                ClaimProcRemitRemark cprr = new ClaimProcRemitRemark();
			                cprr.setCreatedBy(username);
			                cprr.setDateCreated(currentDate);
			                cprr.setClaimProcRecon(claimProcRecon);
			                cprr.setRemittanceRemark(rr);
			                cprr.setClaimProcRecon(claimProcRecon);	// WHY IS THIS DONE TWICE?
			                em.persist(cprr);
			            }	// end for record update
   			 			
   			 			
   			 		if(cpra3 != null) {
       			 		em.persist(cpra3);
       			 	}	// END ClaimProcRecAdjust update
 	   			}			
   		}	// end if remitcode check
        
         
        
        // process remittanceRemarks
        String[] remitCode4 = entity.getRemitCode4();
        
   		if (remitCode4 != null && remitCode4.length > 0) {
   			
   			// pass array and get back ArrayList of RemittanceRemarks
   			 List<RemittanceRemark> remitRemarkList4 = setRemitRemarks(remitCode4);   
   			 
   			ClaimProcRecAdjust cpra4= new ClaimProcRecAdjust();
   			 
   			if(remitRemarkList4 != null) {
     			
   				cpra4 = 	getNewClaimProcRecAdjust(currentDate, claimProcRecon, entity.getAdjAmount4(),
	 					entity.getAdjGroup4(), entity.getAdjReason4());
   				
   			 			for (RemittanceRemark rr : remitRemarkList4) {
   			 				
			                ClaimProcRemitRemark cprr = new ClaimProcRemitRemark();
			                cprr.setCreatedBy(username);
			                cprr.setDateCreated(currentDate);
			                cprr.setClaimProcRecon(claimProcRecon);
			                cprr.setRemittanceRemark(rr);
			                cprr.setClaimProcRecon(claimProcRecon);	// WHY IS THIS DONE TWICE?
			                em.persist(cprr);
			            }	// end for record update
   			 			
   			 			
   			 		if(cpra4 != null) {
       			 		em.persist(cpra4);
       			 	}	// END ClaimProcRecAdjust update
   			}			
   			 				
   		}	// end if remitcode check
        
        // process remittanceRemarks
        String[] remitCode5 = entity.getRemitCode5();
        
     // if there are selected remit codes write them
   		if (remitCode5 != null && remitCode5.length > 0) {
   			
   			// pass array and get back ArrayList of RemittanceRemarks
   			 List<RemittanceRemark> remitRemarkList5 = setRemitRemarks(remitCode5);   
   			 
   			ClaimProcRecAdjust cpra5= new ClaimProcRecAdjust();
   			
   			
   			if(remitRemarkList5 != null) 
   			{	
   				
    				cpra5 = getNewClaimProcRecAdjust(currentDate, claimProcRecon, entity.getAdjAmount5(),
	 					entity.getAdjGroup5(), entity.getAdjReason5() );
   				
   			 
   			 		for (RemittanceRemark rr : remitRemarkList5) 
   			 		{
			                ClaimProcRemitRemark cprr = new ClaimProcRemitRemark();
			                cprr.setCreatedBy(username);
			                cprr.setDateCreated(currentDate);
			                cprr.setClaimProcRecon(claimProcRecon);
			                cprr.setRemittanceRemark(rr);
			                cprr.setClaimProcRecon(claimProcRecon);	// WHY IS THIS DONE TWICE?
			                em.persist(cprr);
			                
			            }	// end for record update
   			 		
   			 	if(cpra5 != null) {
   			 		em.persist(cpra5);
   			 	}	// END ClaimProcRecAdjust update
   			 		
   			}		
   			 		
   		}	// end of remitcode check
        
  
        // Set line to complete
        claimProcedure.setLineStatus("COMPLETE");
        em.merge(claimProcedure);

        // Set claim to completed if all lines has been closed.
        WsFacStatus fs = em.find(WsFacStatus.class, entity.getClaimIndex());
        Set<ClaimProcedure> cps = claim.getClaimProcedures();

         if (cps != null && cps.size() > 0) {
            int countRecon = 0;
            for (ClaimProcedure cp : cps) {
                if ("COMPLETE".equals(cp.getLineStatus())) {
                    countRecon++;
                }
            }
            // all lines resolved, set claim to complete
            claim.setModifiedBy(username);
            claim.setDateModified(currentDate);
            String status;
            if (countRecon == cps.size()) {
                status = "COMPLETE";
            } else {
                status = "INPROCESS";
            }
            claim.setClaimStatusCd(status);

            if (fs != null) {
                fs.setClaimStatusCd(status);
                fs.setDateModified(currentDate);
                fs.setLinesClosed((long) countRecon);
                if (countRecon == 1) {
                    fs.setDateInProcess(currentDate);
                }
            } else {
                 log.fatal("ManualReconClaimBean.process() - Database error for ws_fac_status: missing claim "
                        + entity.getClaimIndex());
            }
        }
         
 
         try {
        	   
		        claim = em.merge(claim);
		        
// constraint violations happening here intemittently - 4/11/2016
/**
 * jboss-service.xml in prod server timout upped to value below due 
 * to timouts - 4/11/2016
 *  <mbean code="org.jboss.tm.TransactionManagerService"
      name="jboss:service=TransactionManager"
      xmbean-dd="resource:xmdesc/TransactionManagerService-xmbean.xml">
      <attribute name="TransactionTimeout">10800</attribute>		        
 */
		        em.flush();		// write it all
		        
		        log.info("ManualReconClaimBean.process() - claim flushed - THE END.");
	         	 
		        
         }catch(Exception e) {
           	 log.fatal("ManualReconClaimBean.process() - Database error for claim "
                     + entity.getClaimIndex());
         	 return false;
         }

        return true;
    }	// END process()
    
    

    /**
     * Check form.
     *
     * @return true, if successful
     */
    private boolean checkForm() {
    	
//    	boolean DEBUG = true;
    	
        boolean status = true;
        
        int remitCount = 0;
        int remitCount1 = 0;
        int remitCount2 = 0;
        int remitCount3 = 0;
        int remitCount4 = 0;
        int remitCount5 = 0;
         
        // code arrays are allocated to 100
        try {
	        String[] remitCode = entity.getRemitCode();
	        if(remitCode.length== 100) { 
	        	remitCount = 0; 
	        } else {
	        	 remitCount = remitCode.length;
	        }
	        String[] remitCode2 = entity.getRemitCode2();
	        if(remitCode2.length== 100) { 
	        	remitCount2 = 0; 
	        } else {
	        	 remitCount2 = remitCode2.length;
	        }
	        
	        remitCount2 = remitCode2.length;
	        if(remitCode2.length== 100) { 
	        	remitCount2 = 0; 
	        } else {
	        	 remitCount2 = remitCode2.length;
	        }
		        
	        String[] remitCode3 = entity.getRemitCode3();
	        if(remitCode3.length== 100) { 
	        	remitCount3 = 0; 
	        } else {
	        	 remitCount3 = remitCode3.length;
	        }
	        
	 			        
	        String[] remitCode4 = entity.getRemitCode4();
	        if(remitCode4.length== 100) { 
	        	remitCount4 = 0; 
	        } else {
	        	 remitCount4 = remitCode4.length;
	        }
	          
	        
	        String[] remitCode5 = entity.getRemitCode5();
	        if(remitCode5.length== 100) { 
	        	remitCount5 = 0; 
	        } else {
	        	 remitCount5 = remitCode5.length;
	        }
	         
	        
        }catch(Exception ex) {
        	System.out.println("checkForm() error: " + ex.getMessage());
        	status = false;
        	return false;
        } 
             
        if(remitCount > 2) {
        	facesMessages.addToControlFromResourceBundle("remCode", Severity.ERROR,  "Maximum numnber of selected Remittance Remarks is 2."
        		);
        	status = false;
        	
         }
        
        if(remitCount2 > 2) {
        	facesMessages.addToControlFromResourceBundle(
        		"remCode2",
        		Severity.ERROR,
        		"Maximum numnber of selected Remittance Remarks is 2.");
        	status = false;
         }
        
        
        if(remitCount3 > 2) {
        	facesMessages.addToControlFromResourceBundle(
        		"remCode3",
        		Severity.ERROR,
        		"Maximum numnber of selected Remittance Remarks is 2.");
        	status = false;
         }
        
        if(remitCount4 > 2) {
        	facesMessages.addToControlFromResourceBundle(
        		"remCode4",
        		Severity.ERROR,
        		"Maximum numnber of selected Remittance Remarks is 2.");
        	status = false;
         }
        
        if(remitCount5 > 2) {
        	facesMessages.addToControlFromResourceBundle(
        		"remCode5",
        		Severity.ERROR,
        		"Maximum numnber of selected Remittance Remarks is 2.");
        	status = false;
         }
        
       

        if ("0".equals(entity.getPaymentType())) {
            facesMessages.addToControlFromResourceBundle(
                    "paymentType",
                    Severity.ERROR,
                    "gov.va.med.fee.SELECTION_REQUIRED");
            status = false;
        }


        if (!status) {
            return false;
        }
        
        try {
		        Calendar paymentDate = Calendar.getInstance();
		        paymentDate.setTime(entity.getPaymentDate());
			        
		        if (paymentDate.get(Calendar.YEAR) < 1900) {
		        	facesMessages.addToControlFromResourceBundle(
		                    "paymentBatchDate",
		                    Severity.ERROR,
		                    "gov.va.med.fee.ManualRecon.MIN_DATE");
		            status = false;
		         }
        }catch(Exception ex) {
        	System.out.println("checkForm() - BAD PAYMENT DATE!: " + ex.getMessage());
        	facesMessages.addToControlFromResourceBundle("paymentBatchDate", Severity.ERROR, "INVALID PAYMENT DATE");
            status = false;
            return false;
        }
 
		        BigDecimal vaAmount = entity.getVaAmount();
		        if (vaAmount != null) {
		            Matcher m = CURRENCY_PATTERN.matcher(vaAmount.toString());
		            if (!m.matches()) {
		                FeeMessages.addFromResourceBundle(
		                        "manualRecon:paidAmountField:paidAmount",
		                        javax.faces.application.FacesMessage.SEVERITY_ERROR,
		                        "gov.va.med.fee.CURRENCY_FORMAT_ERROR");
		                
		               	return false;
		              }
		        }
		
		        BigDecimal adjAmount1 = entity.getAdjAmount1();
		        if (adjAmount1 != null) {
		            Matcher m = CURRENCY_PATTERN.matcher(adjAmount1.toString());
		            if (!m.matches()) {
		                FeeMessages.addFromResourceBundle(
		                        "manualRecon:adjAmount1:adjAmount",
		                        javax.faces.application.FacesMessage.SEVERITY_ERROR,
		                        "gov.va.med.fee.CURRENCY_FORMAT_ERROR");
		                
		                
		                return false;
		            }
		        }

       
       
		        
		        
		        
        BigDecimal adjAmount2 = entity.getAdjAmount2();
        if (adjAmount2 != null) {
            Matcher m = CURRENCY_PATTERN.matcher(adjAmount2.toString());
            if (!m.matches()) {
                FeeMessages.addFromResourceBundle(
                        "manualRecon:adjAmount2:adjAmount",
                        javax.faces.application.FacesMessage.SEVERITY_ERROR,
                        "gov.va.med.fee.CURRENCY_FORMAT_ERROR");
              return false;
            }
        }
        
        
// ADD 3,4,5
        // 3
        BigDecimal adjAmount3 = entity.getAdjAmount3();
        if (adjAmount3 != null) {
            Matcher m = CURRENCY_PATTERN.matcher(adjAmount3.toString());
            if (!m.matches()) {
                FeeMessages.addFromResourceBundle("manualRecon:adjAmount3:adjAmount", javax.faces.application.FacesMessage.SEVERITY_ERROR, "gov.va.med.fee.CURRENCY_FORMAT_ERROR");
                
                return false;
              }
        }
        
        // 4
        BigDecimal adjAmount4 = entity.getAdjAmount4();
        if (adjAmount4 != null) {
            Matcher m = CURRENCY_PATTERN.matcher(adjAmount4.toString());
            if (!m.matches()) {
                FeeMessages.addFromResourceBundle(
                        "manualRecon:adjAmount4:adjAmount",
                        javax.faces.application.FacesMessage.SEVERITY_ERROR,
                        "gov.va.med.fee.CURRENCY_FORMAT_ERROR");
 
                return false;
            }
        }
        
        // 5
        BigDecimal adjAmount5 = entity.getAdjAmount5();
        if (adjAmount5 != null) {
            Matcher m = CURRENCY_PATTERN.matcher(adjAmount5.toString());
            if (!m.matches()) {
                FeeMessages.addFromResourceBundle(
                        "manualRecon:adjAmount5:adjAmount",
                        javax.faces.application.FacesMessage.SEVERITY_ERROR,
                        "gov.va.med.fee.CURRENCY_FORMAT_ERROR");
                return false;
            }
        }
        
// END OF ADJUSTMENTS         

        BigDecimal total = entity.getTotalAmount();

        BigDecimal billedAmount = entity.getClaimProcedure().getBilledAmount() != null
            ? entity.getClaimProcedure().getBilledAmount() : BigDecimal.ZERO;

           
        if (total.compareTo(billedAmount) == -1) {
            if (adjAmount1 == null && adjAmount1 == null) {
                facesMessages.addFromResourceBundle(
                        Severity.ERROR,
                        "gov.va.med.fee.ManualRecon.ADJUSTMENT_REQUIRED");
                
                 return false;
            } else {
                facesMessages.addFromResourceBundle(
                        Severity.ERROR,
                        "gov.va.med.fee.ManualRecon.AMOUNT_LESS_THAN_BILLED",
                        CURRENCY_FORMAT.format(billedAmount.subtract(total)));
 						
                 return false;
            }
        }

        if (total.compareTo(billedAmount) == 1) {
            facesMessages.addFromResourceBundle(
                    Severity.ERROR,
                    "gov.va.med.fee.ManualRecon.AMOUNT_MORE_THAN_BILLED",
                    CURRENCY_FORMAT.format(total.subtract(billedAmount)));
            return false;
        }

        if (adjAmount1 != null && !BigDecimal.ZERO.equals(adjAmount1)) {
            if (entity.getAdjGroup1() == null) {
                facesMessages.addToControlFromResourceBundle(
                        "adjGroup1",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
                 status = false;
            }
            if (entity.getAdjReason1() == null) {
                facesMessages.addToControlFromResourceBundle(
                        "adjReason1",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
                status = false;
            }
        }

           
        if (adjAmount2 != null && !BigDecimal.ZERO.equals(adjAmount2)) {
            if (entity.getAdjGroup2() == null) {
                facesMessages.addToControlFromResourceBundle(
                        "adjGroup2",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
                   status = false;
            }
            if (entity.getAdjReason2() == null) {
                facesMessages.addToControlFromResourceBundle(
                        "adjReason2",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
                
                status = false;
            }
        }

        

        // 3
        if (adjAmount3 != null && !BigDecimal.ZERO.equals(adjAmount3)) {
            if (entity.getAdjGroup3() == null) {
                facesMessages.addToControlFromResourceBundle(
                        "adjGroup3",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
                status = false;
            }
            if (entity.getAdjReason3() == null) {
                facesMessages.addToControlFromResourceBundle(
                        "adjReason3",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
  			
                 status = false;
            }
        }

        // 4
        if (adjAmount4 != null && !BigDecimal.ZERO.equals(adjAmount4)) {
            if (entity.getAdjGroup4() == null) {
                facesMessages.addToControlFromResourceBundle(
                        "adjGroup4",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
                
                
                 status = false;
            }
            if (entity.getAdjReason4() == null) {
                facesMessages.addToControlFromResourceBundle(
                        "adjReason4",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
                status = false;
            }
        }
        
        // 5
        if (adjAmount5 != null && !BigDecimal.ZERO.equals(adjAmount5)) 
        {
            if (entity.getAdjGroup5() == null) 
            {
                facesMessages.addToControlFromResourceBundle(
                        "adjGroup5",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
                
                status = false;
            }
            
            
            if (entity.getAdjReason5() == null) 
            {
                facesMessages.addToControlFromResourceBundle(
                        "adjReason5",
                        Severity.ERROR,
                        "gov.va.med.fee.SELECTION_REQUIRED");
                
                status = false;
                
            }
        }
        
 
        return status;
        
    }	// end checkForm()
        
    
    /**
     * Creates a new ClaimProcReconAdjust
     *
     * @param claimProcRecon the claim proc recon
     * @param amount the amount
     * @param group the group
     * @param reason the reason
     * @return  ClaimProcRecAdjust
     */
    private ClaimProcRecAdjust getNewClaimProcRecAdjust(
            Date currentDate,
            ClaimProcRecon claimProcRecon,
            BigDecimal amount,
            String group,
            String reason) {

        if (amount == null) {
            return null;
        }

        ClaimProcRecAdjust cpra = new ClaimProcRecAdjust();
        cpra.setAdjustmentAmount(amount);

        AdjustmentGroup ag = manualReconSelections.getAdjustmentGroup(group);
        cpra.setAdjustmentGroup(ag);

        AdjustmentReason ar = manualReconSelections.getAdjustmentReason(reason);
        cpra.setAdjustmentReason(ar);
        cpra.setCreatedBy(appUser.getUserName());
        cpra.setDateCreated(currentDate);

        // ClaimProcRecon - ClaimProcRecAdjust
        claimProcRecon.getClaimProcRecAdjusts().add(cpra);
        cpra.setClaimProcRecon(claimProcRecon);
        
        return cpra;
    }

    
    
    

    /**
     * Adds the claim proc rec adjust.
     *
     * @param claimProcRecon the claim proc recon
     * @param amount the amount
     * @param group the group
     * @param reason the reason
     */
    private void addClaimProcRecAdjust(
            Date currentDate,
            ClaimProcRecon claimProcRecon,
            BigDecimal amount,
            String group,
            String reason) {

        if (amount == null) {
            return;
        }

        ClaimProcRecAdjust cpra = new ClaimProcRecAdjust();
        cpra.setAdjustmentAmount(amount);

        AdjustmentGroup ag = manualReconSelections.getAdjustmentGroup(group);
        cpra.setAdjustmentGroup(ag);

        AdjustmentReason ar = manualReconSelections.getAdjustmentReason(reason);
        cpra.setAdjustmentReason(ar);
        cpra.setCreatedBy(appUser.getUserName());
        cpra.setDateCreated(currentDate);

        // ClaimProcRecon - ClaimProcRecAdjust
        claimProcRecon.getClaimProcRecAdjusts().add(cpra);
        cpra.setClaimProcRecon(claimProcRecon);
    }

    /**
     * Gets the service prov name.
     *
     * @param providers the providers
     *
     * @return the service prov name
     */
    private String getServiceProvName(Set<ProviderInfo> providers) {
        for (ProviderInfo p : providers) {
            if ("SERVICE FACILITY".equals(p.getProviderType()
                    .getProviderTypeCd())
                    || "SERVICE LOCATION".equals(p.getProviderType()
                            .getProviderTypeCd())) {
                return p.getLastName();
            }
        }
        return null;
    }

    /**
     * Gets the billing prov name.
     *
     * @param providers the providers
     *
     * @return the billing prov name
     */
    private String getBillingProvName(Set<ProviderInfo> providers) {
        for (ProviderInfo p : providers) {
            if ("BILLING PROVIDER".equals(p.getProviderType()
                    .getProviderTypeCd())) {
                return p.getLastName();
            }
        }
        return null;
    }

    /**
     * Gets the veteran name.
     *
     * @param persons the persons
     *
     * @return the veteran name
     */
    private String getVeteranName(Set<PersonInfo> persons) {
        for (PersonInfo pi : persons) {
            if ("PATIENT".equals(pi.getPersonType().getPersonTypeCd())) {
                return pi.getFirstName() + " " + pi.getLastName();
            }
        }
        return null;
    }

    /**
     * Destroy.
     *
     */
    @Destroy
    @Remove
    public final void destroy() {
    	
    
     	
    }	// end destroy

    @PostConstruct 
    public void intialize() {
	     }	// end initialize()
	

	@Override
	public String setTest() {
		// TODO Auto-generated method stub
		return null;
	}

}
