/*
 * $Id: ManualReconEntity.java,v 1.3 2009/11/06 22:10:07 vhahacnguyes Exp $
 */
package gov.va.med.fee.claim;

import gov.va.med.domain.fee.Claim;
import gov.va.med.domain.fee.ClaimProcedure;
// import gov.va.med.fee.SortableLong;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.annotation.PostConstruct;
import javax.faces.context.FacesContext;

import org.hibernate.validator.Min;
import org.hibernate.validator.NotNull;
import org.hibernate.validator.Past;
import org.jboss.seam.log.Log;


/**
 * The Class ManualReconEntity.
 */
@SuppressWarnings("serial")
public final class ManualReconEntity implements Serializable {
	

	private Log log;
	
   /** The adj amount1. */
    @Min(0) private BigDecimal adjAmount1;

    /** The adj amount2. */
    @Min(0) private BigDecimal adjAmount2;

    /** The adj reason1. */
    private String adjReason1 = "";

    /** The adj reason2. */
    private String adjReason2 = "";

    /** The adj group1. */
    private String adjGroup1 = "";

    /** The adj group2. */
    private String adjGroup2 = "";
    
 
	// ADDITIONAL ITEMS TO INCREASE AVAILABLE SELECTIONS ON SCREEN TO 5 INSTEAD OF 2
    // START WITH 3 AND TEST
    /** The adj group3. */
    private String adjGroup3 = "";
    
  	/** The adj reason3. */
    private String adjReason3 = "";
    
    /** The adj amount3. */
    @Min(0) private BigDecimal adjAmount3;
    

    /** The adj group4. */
    private String adjGroup4 = "";
    
  	/** The adj reason4. */
    private String adjReason4 = "";
    
    /** The adj amount4. */
    @Min(0) private BigDecimal adjAmount4;
    
    
    /** The adj group5. */
    private String adjGroup5 = "";
    
  	/** The adj reason5. */
    private String adjReason5 = "";
    
    /** The adj amount5. */
    @Min(0) private BigDecimal adjAmount5;
    
    
    /** The remit code. */
    private String[] remitCode = new String[100];
    
    /** The remit code 2. */
    private String[] remitCode2 = new String[100];
    
    
    /** The remit code 3 */
    private String[] remitCode3 = new String[100];
    
    /** The remit code 4. */
    private String[] remitCode4 = new String[100];
    
    /** The remit code 5 */
    private String[] remitCode5 = new String[100];
    
   

    /** The payment date. */
    /** TODAY OR ANY DAY BEFORE TODAY **/
    @Past private Date paymentDate;

    /** The va amount. */
    @Min(0) private BigDecimal vaAmount;

    /** The check no. */
    private String checkNo;

    /** The payment type. */
    @NotNull
    private String paymentType;

    /** The veteran name. */
    private String veteranName;

    /** The billing provider. */
    private String billingProvider;

    /** The service provider. */
    private String serviceProvider;

    /** The claim index. */
    private Long claimIndex;

    /** The claim proc id. */
    private Long claimProcId;

    /** The claim. */
    private Claim claim;

    /** The claim procedure. */
    private ClaimProcedure claimProcedure;

    /** The sorted claim procedures. */
    private List<ClaimProcedure> sortedClaimProcedures;
    
    /**
     * Clear.
     */
    public void clearUserEntries() {
        vaAmount = null;
        paymentType = null;
        checkNo = null;
        paymentDate = null;

       
        Arrays.fill(remitCode, "");
        Arrays.fill(remitCode2, "");
        Arrays.fill(remitCode3, "");
        Arrays.fill(remitCode4, "");
        Arrays.fill(remitCode5, "");
        
        

        adjAmount1 = null;
        adjGroup1 = null;
        adjReason1 = null;

        adjAmount2 = null;
        adjGroup2 = null;
        adjReason2 = null;
        
        adjAmount3 = null;
        adjGroup3 = null;
        adjReason3 = null;
        
        adjAmount4 = null;
        adjGroup4 = null;
        adjReason4 = null;
        
        adjAmount5 = null;
        adjGroup5 = null;
        adjReason5 = null;
      
        
        // destroy ManualReconSelectionsBean
     	try {
     		
    	    Map<String, Object> sObjects =  FacesContext.getCurrentInstance().getExternalContext().getSessionMap();

    	    Iterator entries = sObjects.entrySet().iterator();
    	    while (entries.hasNext()) {
    	      Entry thisEntry = (Entry) entries.next();
    	      Object key = thisEntry.getKey();
    	      Object value = thisEntry.getValue();
    	      
      	      if(key.toString().equalsIgnoreCase("manualReconSelections") ) {
//		   	      System.out.println("session key FOUND - Map key is: " + key.toString());
		   	      sObjects.remove("manualReconSelections");
//		   	      System.out.println("ManualReconEntity.clearUserEntries() - manualReconSelections REMOVED FROM SESSION");
	   	      }
    	      
    	    }
    	   
  	    }catch(Exception e) {
	    	
    		System.out.println("ManualReconSelectionsBean.initialize() - error setting reconRemitRemarks: " + e.getMessage());
    		e.printStackTrace();
    	}
 
       	log.debug("ManualReconEntity.clearUserEntries() - ALL ENTRIES CLEARED");
    }
    
   
    
    
    
    
    @PostConstruct 
    public void intialize() {
		
     }	// END intialize()
    
  
    
  
    
    /**
     * Gets the remit code.
     *
     * @return the remit code
     */
    public String[] getRemitCode() {
    	if(remitCode==null) {
    		Arrays.fill(remitCode, "");
    	}
        return remitCode;
    }
    
    
    /**
     * Sets the remit code.
     *
     * @param remitCode the new remit code
     */
    public void setRemitCode(String[] remitCode) {
        this.remitCode = remitCode;
    }
    
    
    
    /**
    * Gets the remit code.
    *
    * @return the remit code
    */
   public String[] getRemitCode2() {
   		if(remitCode2==null) {
	   		Arrays.fill(remitCode2, "");
	   	}
	       return remitCode2;
   }
   
   
   

   /**
    * Sets the remit code.
    *
    * @param remitCode the new remit code
    */
   public void setRemitCode2(String[] remitCode2) {
       this.remitCode2 = remitCode2;
   }
 
      
    
    public String[] getRemitCode3() {
    	
    	if(remitCode3==null) {
	   		Arrays.fill(remitCode3, "");
	   	}
		return remitCode3;
	}

	public void setRemitCode3(String[] remitCode3) {
		this.remitCode3 = remitCode3;
	}

	public String[] getRemitCode4() {
		
		if(remitCode4==null) {
	   		Arrays.fill(remitCode4, "");
	   	}
		return remitCode4;
	}

	public void setRemitCode4(String[] remitCode4) {
		this.remitCode4 = remitCode4;
	}

	public String[] getRemitCode5() {
		
		if(remitCode5==null) {
	   		Arrays.fill(remitCode5, "");
	   	}
		return remitCode5;
	}

	public void setRemitCode5(String[] remitCode5) {
		this.remitCode5 = remitCode5;
	}
    
	/**
     * Instantiates a new manual recon entity.
     */
    public ManualReconEntity() {
    }	

    /**
     * Gets the total amount.
     *
     * @return the total amount
     */
    public BigDecimal getTotalAmount() {
    	
        BigDecimal total = BigDecimal.ZERO;
        
        total = total.setScale(2);
        
        if (vaAmount != null) {
            vaAmount = vaAmount.setScale(2);
            total = total.add(vaAmount);
        }

        if (adjAmount1 != null) {
            adjAmount1 = adjAmount1.setScale(2);
            total = total.add(adjAmount1);
        }

        if (adjAmount2 != null) {
            adjAmount2 = adjAmount2.setScale(2);
            total = total.add(adjAmount2);
        }
        
        // 3
        if (adjAmount3 != null) {
            adjAmount3 = adjAmount3.setScale(2);
            total = total.add(adjAmount3);
        }
        
        // 4
        if (adjAmount4 != null) {
            adjAmount4 = adjAmount4.setScale(2);
            total = total.add(adjAmount4);
        }
        
        // 5
        if (adjAmount5 != null) {
            adjAmount5 = adjAmount5.setScale(2);
            total = total.add(adjAmount5);
        }
        
        
        
        return total;
    }
    /**
     * Gets the sorted claim procedures.
     *
     * @return the sorted claim procedures
     */
    public List getSortedClaimProcedures() {
        return sortedClaimProcedures;
    }

    /**
     * Sets the sorted claim procedures.
     *
     * @param sortedClaimProcedures the new sorted claim procedures
     */
    public void setSortedClaimProcedures(List<ClaimProcedure> sortedClaimProcedures) {
        this.sortedClaimProcedures = sortedClaimProcedures;
    }

    /**
    * Gets the claim index.
    *
    * @return the claim index
    */
    public Long getClaimIndex() {
        return claimIndex;
    }

    /**
     * Sets the claim index.
     *
     * @param claimIndex the new claim index
     */
    public void setClaimIndex(Long claimIndex) {
        this.claimIndex = claimIndex;
    }

    /**
     * Gets the claim proc id.
     *
     * @return the claim proc id
     */
    public Long getClaimProcId() {
        return claimProcId;
    }

    /**
     * Sets the claim proc id.
     *
     * @param claimProcId the new claim proc id
     */
    public void setClaimProcId(Long claimProcId) {
        this.claimProcId = claimProcId;
    }

    /**
     * Gets the claim procedure.
     *
     * @return the claim procedure
     */
    public ClaimProcedure getClaimProcedure() {
        return claimProcedure;
    }

    /**
     * Sets the claim procedure.
     *
     * @param claimProcedure the new claim procedure
     */
    public void setClaimProcedure(ClaimProcedure claimProcedure) {
        this.claimProcedure = claimProcedure;
    }

    /**
     * Gets the veteran name.
     *
     * @return the veteran name
     */
    public String getVeteranName() {
        return veteranName;
    }

    /**
     * Sets the veteran name.
     *
     * @param veteranName the new veteran name
     */
    public void setVeteranName(String veteranName) {
        this.veteranName = veteranName;
    }

    /**
     * Gets the billing provider.
     *
     * @return the billing provider
     */
    public String getBillingProvider() {
        return billingProvider;
    }

    /**
     * Sets the billing provider.
     *
     * @param billingProvider the new billing provider
     */
    public void setBillingProvider(String billingProvider) {
        this.billingProvider = billingProvider;
    }

    /**
     * Gets the service provider.
     *
     * @return the service provider
     */
    public String getServiceProvider() {
        return serviceProvider;
    }

    /**
     * Sets the service provider.
     *
     * @param serviceProvider the new service provider
     */
    public void setServiceProvider(String serviceProvider) {
        this.serviceProvider = serviceProvider;
    }

    /**
     * Gets the adj amount1.
     *
     * @return the adj amount1
     */
    public BigDecimal getAdjAmount1() {
        return adjAmount1;
    }

    /**
     * Sets the adj amount1.
     *
     * @param adjAmount1 the new adj amount1
     */
    public void setAdjAmount1(BigDecimal adjAmount1) {
    	
        this.adjAmount1 = adjAmount1;
    }

    /**
     * Gets the adj amount2.
     *
     * @return the adj amount2
     */
    public BigDecimal getAdjAmount2() {
        return adjAmount2;
    }

    /**
     * Sets the adj amount2.
     *
     * @param adjAmount2 the new adj amount2
     */
    public void setAdjAmount2(BigDecimal adjAmount2) {
        this.adjAmount2 = adjAmount2;
    }

    /**
     * Sets the claim.
     *
     * @param claim the new claim
     */
    public void setClaim(Claim claim) {
        this.claim = claim;
    }

    /**
     * Gets the claim.
     *
     * @return the claim
     */
    public Claim getClaim() {
        return claim;
    }

    /**
     * Gets the adj group1.
     *
     * @return the adj group1
     */
    public String getAdjGroup1() {
        return adjGroup1;
    }

    /**
     * Sets the adj group1.
     *
     * @param adjGroup1 the new adj group1
     */
    public void setAdjGroup1(String adjGroup1) {
    	this.adjGroup1 = adjGroup1;
    }

    /**
     * Gets the adj group2.
     *
     * @return the adj group2
     */
    public String getAdjGroup2() {
        return adjGroup2;
    }

    /**
     * Sets the adj group2.
     *
     * @param adjGroup2 the new adj group2
     */
    public void setAdjGroup2(String adjGroup2) {
        this.adjGroup2 = adjGroup2;
    }

    

    /**
     * Gets the payment date.
     * 'The annotated element must be a date in the past.'
     * @return the payment date
     */
    public Date getPaymentDate() {
        return paymentDate;
    }

    /**
     * Sets the payment date.
     *
     * @param paymentDate the new payment date
     */
    public void setPaymentDate(Date paymentDate) {
        this.paymentDate = paymentDate;
    }

    /**
     * Gets the va amount.
     *
     * @return the va amount
     */
    public BigDecimal getVaAmount() {
        return vaAmount;
    }

    /**
     * Sets the va amount.
     *
     * @param vaAmount the new va amount
     */
    public void setVaAmount(BigDecimal vaAmount) {
        this.vaAmount = vaAmount;
    }

    /**
     * Gets the check no.
     *
     * @return the check no
     */
    public String getCheckNo() {
        return checkNo;
    }

    /**
     * Sets the check no.
     *
     * @param checkNo the new check no
     */
    public void setCheckNo(String checkNo) {
        this.checkNo = checkNo;
    }

    /**
     * Gets the payment type.
     *
     * @return the payment type
     */
    public String getPaymentType() {
        return paymentType;
    }

    /**
     * Sets the payment type.
     *
     * @param paymentType the new payment type
     */
    public void setPaymentType(String paymentType) {
        this.paymentType = paymentType;
    }

    /**
     * Gets the adj reason1.
     *
     * @return the adj reason1
     */
    public String getAdjReason1() {
          return adjReason1;
    }

    /**
     * Sets the adj reason1.
     *
     * @param adjReason1 the new adj reason1
     */
    public void setAdjReason1(String adjReason1) {
      	
        this.adjReason1 = adjReason1;
    }

    /**
     * Gets the adj reason2.
     *
     * @return the adj reason2
     */
    public String getAdjReason2() {
          return adjReason2;
    }

    /**
     * Sets the adj reason2.
     *
     * @param adjReason2 the new adj reason2
     */
    public void setAdjReason2(String adjReason2) {
        this.adjReason2 = adjReason2;
    }

	public String getAdjGroup3() {
		return adjGroup3;
	}

	public void setAdjGroup3(String adjGroup3) {
		this.adjGroup3 = adjGroup3;
	}

	public String getAdjReason3() {
		return adjReason3;
	}

	public void setAdjReason3(String adjReason3) {
		this.adjReason3 = adjReason3;
	}

	public BigDecimal getAdjAmount3() {
		return adjAmount3;
	}

	public void setAdjAmount3(BigDecimal adjAmount3) {
		this.adjAmount3 = adjAmount3;
	}

	public String getAdjGroup4() {
		return adjGroup4;
	}

	public void setAdjGroup4(String adjGroup4) {
		this.adjGroup4 = adjGroup4;
	}

	public String getAdjReason4() {
		return adjReason4;
	}

	public void setAdjReason4(String adjReason4) {
		this.adjReason4 = adjReason4;
	}

	public BigDecimal getAdjAmount4() {
			return adjAmount4;
	}

	public void setAdjAmount4(BigDecimal adjAmount4) {
		this.adjAmount4 = adjAmount4;
	}

	public String getAdjGroup5() {
		return adjGroup5;
	}

	public void setAdjGroup5(String adjGroup5) {
		this.adjGroup5 = adjGroup5;
	}

	public String getAdjReason5() {
		return adjReason5;
	}

	public void setAdjReason5(String adjReason5) {
		this.adjReason5 = adjReason5;
	}

	public BigDecimal getAdjAmount5() {
		return adjAmount5;
	}

	public void setAdjAmount5(BigDecimal adjAmount5) {
		this.adjAmount5 = adjAmount5;
	}

	@Override
	public String toString() {
		return "ManualReconEntity [adjAmount1=" + adjAmount1 + ", adjAmount2="
				+ adjAmount2 + ", adjReason1=" + adjReason1 + ", adjReason2="
				+ adjReason2 + ", adjGroup1=" + adjGroup1 + ", adjGroup2="
				+ adjGroup2 + ", adjGroup3=" + adjGroup3 + ", adjReason3="
				+ adjReason3 + ", adjAmount3=" + adjAmount3 + ", adjGrou4="
				+ adjGroup4 + ", adjReason4=" + adjReason4 + ", adjAmount4="
				+ adjAmount4 + ", adjGroup5=" + adjGroup5 + ", adjReason5="
				+ adjReason5 + ", adjAmount5=" + adjAmount5 + ", remitCode="
				+ Arrays.toString(remitCode) + ", paymentDate=" + paymentDate	
				+ ", vaAmount=" + vaAmount + ", checkNo=" + checkNo
				+ ", paymentType=" + paymentType + ", veteranName="
				+ veteranName + ", billingProvider=" + billingProvider
				+ ", serviceProvider=" + serviceProvider + ", claimIndex="
				+ claimIndex + ", claimProcId=" + claimProcId + ", claim="
				+ claim + ", claimProcedure=" + claimProcedure
				+ ", sortedClaimProcedures=" + sortedClaimProcedures + "]";
	}
	
	
	
	
}
