/*
 * $Id: ManualReconSelectionsBean.java,v 1.2 2010/09/22 21:44:21 vhahacdoansc Exp $
 */
package gov.va.med.fee.claim;



import static org.jboss.seam.ScopeType.SESSION;
import gov.va.med.domain.fee.AdjustmentGroup;
import gov.va.med.domain.fee.AdjustmentReason;
import gov.va.med.domain.fee.CalcMethod;
import gov.va.med.domain.fee.ClaimPaymentType;
import gov.va.med.domain.fee.ClaimProcStatus;
import gov.va.med.domain.fee.RemittanceRemark;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import javax.annotation.PostConstruct;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.hibernate.exception.SQLGrammarException;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.core.SeamResourceBundle;
import org.jboss.seam.log.Log;



/**
 * The Class ManualReconSelectionsBean.
 * 
 * 
 */
@Stateful
@Name("manualReconSelections")
@Scope(SESSION)
public class ManualReconSelectionsBean implements ManualReconSelections{
	private SelectItem[] remitCode;
	private SelectItem[] remitCode2;
	private SelectItem[] remitCode3;
	private SelectItem[] remitCode4;
	private SelectItem[] remitCode5;
	
	String adjReason1_id = "";
	String adjReason2_id = "";
	String adjReason3_id = "";
	String adjReason4_id = "";
	String adjReason5_id = "";
	
	String curReasonId = "";
	String curAdjustmentCode = "";
	
	SelectItem[] curItems = null;
	
	List<?> allRemarksList = null;
	
	
    /** The Constant LINE_LENGTH_LIMIT. */
    private static final int LINE_LENGTH_LIMIT = 120;

    /** The log. */
    @Logger
    private Log log;

    /** The em. */
    @PersistenceContext
    private EntityManager em;

    
    @In(value = "adjReasonMap", required = false, scope = ScopeType.SESSION)
    @Out(value = "adjReasonMap", required = false, scope = ScopeType.SESSION)
    private Map<String, AdjustmentReason> adjReasonMap;

    
    @In(value = "adjGroupMap", required = false, scope = ScopeType.SESSION)
    @Out(value = "adjGroupMap", required = false, scope = ScopeType.SESSION)
    private Map<String, AdjustmentGroup> adjGroupMap;

  
     @SuppressWarnings({ "rawtypes", "unchecked" })
    private Map<String, ClaimPaymentType> paymentTypeMap;

    
     
     public List<?> getAllRemarksList() {
		return allRemarksList;
	}

	public void setAllRemarksList(List<?> allRemarksList) {
		this.allRemarksList = allRemarksList;
	}

	public SelectItem[] getCurItems() {
		return curItems;
	}

	public void setCurItems(SelectItem[] curItems) {
		this.curItems = curItems;
	}

	public String getCurReasonId() {
  		return curReasonId;
	}

	public void setCurReasonId(String curReasonId) {
			this.curReasonId = curReasonId;
	}

	public String getCurAdjustmentCode() {
		return curAdjustmentCode;
	}

	public void setCurAdjustmentCode(String curAdjustmentCode) {
		this.curAdjustmentCode = curAdjustmentCode;
	}

	
	   @Override
		public void valueChange(String reasonId, String componentName) {

			
	    		if(componentName.equalsIgnoreCase("adjReason1")) {
	        			
	    			if(this.getAdjReason1_id().equalsIgnoreCase(reasonId)) {
	      				return;
	    			} else {
	    				this.setCurReasonId(reasonId);
	    				this.setAdjReason1_id(reasonId);
	       				
	      				getManualReconRemitRemarks1();
	    			}
	        	}	// end reason1 check
	    		
	    		
	    		
	    		
	    		
	    		if(componentName.equalsIgnoreCase("adjReason2")) {
	    			this.setAdjReason2_id(reasonId);
	    			getManualReconRemitRemarks2();
	    		} 
	    		
	    		if(componentName.equalsIgnoreCase("adjReason3")) {
	    			this.setAdjReason3_id(reasonId);
	    			getManualReconRemitRemarks3();
	    		} 
	    		
	    		if(componentName.equalsIgnoreCase("adjReason4")) {
	    			this.setAdjReason4_id(reasonId);
	    			getManualReconRemitRemarks4();
	    		} 
	    		
	    		if(componentName.equalsIgnoreCase("adjReason5")) {
	    			this.setAdjReason5_id(reasonId);
	    			getManualReconRemitRemarks5();
	    		} 
	      		
	 	}	// end valueChange()
	
	
	
	
	
	@PostConstruct 
     public void intialize() {
    	
      }	// END intialize()
 	 
     @Destroy
	 @Remove
	   public final void destroy() {
 
	   }
     
 
    

	/**
	   * returns a list of remit remarks for a given adjustment
	   * @param adjCode
	   * @return
	   */
	  @SuppressWarnings("unchecked")
	private  SelectItem[] getRemitRemarks(String adjCode, int adjReasonId) {
		  boolean DEBUG = true;
		  Date today = new Date();
				    
		    if(adjCode.equalsIgnoreCase(this.curAdjustmentCode)) {
			    	return this.curItems;
		    } else {
		    	this.curAdjustmentCode = adjCode;
		    }
	    
		    int size=1;
		    String[][] retItems = new String[size][2];
		    Iterator<?> it;
		    List<RemittanceRemark> ar = new ArrayList<RemittanceRemark>();
		    
		    
	       	try { 


				 String sql = " SELECT DISTINCT RR.REMITTANCE_REMARK_CD, RR.DESCRIPTION, RR.FEE_USAGE_FLAG, " +
				  "RR.CREATED_BY, RR.START_DATE, RR.END_DATE, RR.DATE_CREATED " +
				  "FROM " + 
				  "fpps_owner.CARC_RARC_CROSSWALK CWS " +
				  "JOIN fpps_owner.REMITTANCE_REMARK RR ON CWS.RARC_ID=RR.REMITTANCE_REMARK_CD " +
				  "JOIN fpps_owner.ADJUSTMENT_REASON ARI ON CWS.CARC_ID=ARI.ADJUSTMENT_REASON_CD " +
				  "WHERE :today between RR.START_DATE AND RR.END_DATE " +
				  " AND CWS.CARC_ID =  "  +"'" + adjCode + "'" + 
				  " ORDER BY RR.description";   

 
				String sqlAll = "SELECT DISTINCT RR.REMITTANCE_REMARK_CD, RR.DESCRIPTION, RR.START_DATE, RR.END_DATE, " +
						 " CWS.RARC_ID AS CWS_RR_CD, CWS.CARC_ID AS CWS_CARC_ID " +
						 "FROM " +
						        "fpps_owner.REMITTANCE_REMARK RR, fpps_owner.CARC_RARC_CROSSWALK CWS " +
						        "JOIN " +
						        "fpps_owner.REMITTANCE_REMARK RR2 ON " +
						        "CWS.RARC_ID=RR2.REMITTANCE_REMARK_CD " +
						      	"JOIN " +
						        "fpps_owner.ADJUSTMENT_REASON ARI ON " +
						        "CWS.CARC_ID=ARI.ADJUSTMENT_REASON_CD " +
						        " WHERE :today between RR.START_DATE AND RR.END_DATE " +
								" ORDER BY RR.DESCRIPTION";
						

				@SuppressWarnings("rawtypes")
				Query q = null;
				List<?> l = null;
		
				q= em.createNativeQuery(sql); 
				q.setParameter("today", today);
				l = q.getResultList();
				

					// IF THERE ARE NO ASSOCIATED REMARKS, RETURN ALL RECORDS
						if(l.size() == 0) {
								l.clear();
							
								if(allRemarksList != null) {
									l = allRemarksList;
								} else {
									try {
										q= em.createNativeQuery(sqlAll); 
										q.setParameter("today", today);
										l = q.getResultList();
										allRemarksList = l;
									}catch(Exception y) {
											log.error(y);
									}	// end try/catch
								}	// end allRemarksList check
						}	// end size check
								
					it = l.iterator();	
					
					String code = "";
					String description = "";
						String tmp = "";
					
					while (it.hasNext()) {
						Object[] row = (Object[]) it.next();
						
						if(row != null) {
				        	// code
							code = (String) row[0];
							// description not required - check for nulls
							tmp = (String) row[1];
							
							if( (tmp != null) && (!tmp.isEmpty()) ) {
								description = tmp;
							} else {
								description = "";
							}
							
							RemittanceRemark rr = new RemittanceRemark();
							 rr.setRemittanceRemarkCd(code);
							 rr.setDescription(description);
							 
							 ar.add(rr);
								
					    }	// end if null check
						
					}	// end while record loop
									
				Map<String, RemittanceRemark>  remitRemarkMap = new LinkedHashMap<String, RemittanceRemark>(ar.size());
				    
				int size1 = remitRemarkMap.size();
				    
				String[][] items1 = new String[size1][2];
		            
				if( (ar != null) && (! (ar.isEmpty()) ) )  {				            
					    for (RemittanceRemark rr : ar) {
						    		remitRemarkMap.put(rr.getRemittanceRemarkCd(), rr);
					} 
				}
				
				int index = 0;
					try	{
							int mapSize = remitRemarkMap.size();
							items1 = new String[mapSize][2];
							for (RemittanceRemark rr : remitRemarkMap.values()) {
								try {
									items1[index][0] = rr.getRemittanceRemarkCd();
								    items1[index][1] = rr.getDescription();
								    index++;
								}catch(Exception xy) {
									log.error(xy);
								}
							    
							}
					}catch(Exception f) {
						log.error(f);
					}
				retItems = items1.clone();
				
	        	}catch(SQLGrammarException e) {
	        		log.error(e);
	        	} catch(Exception ex) {
	        		log.error(ex);
	        	}
        	
		   SelectItem[] items = convertToSelectItemArray(retItems, null);	
		   this.curItems = items;
		   
		   return items;
	  }	// end getRemitRemarks()
    

	    
    @Override
	public SelectItem[] getRemitCode2() {
		return remitCode2;
	}

	@Override
	public void setRemitCode2(SelectItem[] remitCode2) {
		this.remitCode2 = remitCode2;
	}
	
	@Override
	public  SelectItem[] getRemitCode() {
		return this.remitCode;
	}

	@Override
	public void setRemitCode(SelectItem[] remitCode) {
		this.remitCode = remitCode;
	}


    
    public static java.util.Date toDate(java.sql.Timestamp timestamp) {
        long milliseconds = timestamp.getTime() + (timestamp.getNanos() / 1000000);
        return new java.util.Date(milliseconds);
    }
	
    public String getAdjReason1_id() {
		return adjReason1_id;
	}

	public void setAdjReason1_id(String adjReason1_id) {
		this.adjReason1_id = adjReason1_id;
	}

	public String getAdjReason2_id() {
		return adjReason2_id;
	}

	public void setAdjReason2_id(String adjReason2_id) {
		this.adjReason2_id = adjReason2_id;
	}
	
    @SuppressWarnings("unchecked")
    @Factory(value = "manualReconRemitRemarks1", scope = ScopeType.CONVERSATION)
    public SelectItem[] getManualReconRemitRemarks1() {
    	
 		   Map<String, Object> sObjects =  FacesContext.getCurrentInstance().getExternalContext().getSessionMap();


		    	// check on Submit 
		    	   if( (adjReason1_id != null) && (!adjReason1_id.isEmpty()) ) {
		    		   
			    		   
					   SelectItem[] retVal = getRemitRemarks(adjReason1_id, 1);
					   this.setRemitCode(retVal);
					   return retVal;
				   } else {	
					     String[][] emptyList = new String[][] { {"", ""} };
			     		 SelectItem[] empty = convertToSelectItemArray(emptyList, null);
			     		// adjReason1_id = "";
			    		 this.setRemitCode(empty);
			    		 return empty;
				   }	// end if
		    	   
      }	// END getManualReconRemitRemarks1()


	
	
	  @SuppressWarnings("unchecked")
	  @Factory(value = "manualReconRemitRemarks2", scope = ScopeType.CONVERSATION)
	  public SelectItem[] getManualReconRemitRemarks2() {
		  
				  
		   if( (adjReason2_id != null) && (!adjReason2_id.isEmpty()) ) {
			   SelectItem[] retVal = getRemitRemarks(adjReason2_id, 2);
			   this.setRemitCode2(retVal);
			   return retVal;
		   } else {	
			    String[][] emptyList = new String[][] {  {"", ""}  };
	    		SelectItem[] empty = convertToSelectItemArray(emptyList, null);
	    		this.setRemitCode(empty);
	    		return empty;
		   }
	  }	// end getManualReconRemitRemarks2()
	  
	  
	  @SuppressWarnings("unchecked")
	  @Factory(value = "manualReconRemitRemarks3", scope = ScopeType.CONVERSATION)
	  public SelectItem[] getManualReconRemitRemarks3() {
		  
		  
		   if( (adjReason3_id != null) && (!adjReason3_id.isEmpty()) ) {
			   SelectItem[] retVal = getRemitRemarks(adjReason3_id, 3);
			   return retVal;
		   } else {	
			    String[][] emptyList = new String[][] {  {"", ""}  };
	    		SelectItem[] empty = convertToSelectItemArray(emptyList, null);
	    		return empty;
		   }
	  }	// end getManualReconRemitRemarks3()
	  
	  
	  @SuppressWarnings("unchecked")
	  @Factory(value = "manualReconRemitRemarks4", scope = ScopeType.CONVERSATION)
	  public SelectItem[] getManualReconRemitRemarks4() {
		  
		   if( (adjReason4_id != null) && (!adjReason4_id.isEmpty()) ) {
			   SelectItem[] retVal = getRemitRemarks(adjReason4_id, 4);
			   return retVal;
		   } else {	
			    String[][] emptyList = new String[][] {  {"", ""}  };
	    		 
	    		SelectItem[] empty = convertToSelectItemArray(emptyList, null);
	    		return empty;
		   }
	  }	// end getManualReconRemitRemarks4()
	  
	  
	  
	  @SuppressWarnings("unchecked")
	  @Factory(value = "manualReconRemitRemarks5", scope = ScopeType.CONVERSATION)
	  public SelectItem[] getManualReconRemitRemarks5() {
		  
		   if( (adjReason5_id != null) && (!adjReason5_id.isEmpty()) ) {
			   SelectItem[] retVal = getRemitRemarks(adjReason5_id, 5);
			   return retVal;
		   } else {	
			    String[][] emptyList = new String[][] {  {"", ""}  };
	    		SelectItem[] empty = convertToSelectItemArray(emptyList, null);
	    		return empty;
		   }
	  }	// end getManualReconRemitRemarks5()
	  
    /**
     * Gets the manual recon calc method.
     *
     * @return the manual recon calc method
     */
    @Factory(value = "manualReconCalcMethod", scope = ScopeType.SESSION)
    public final CalcMethod getManualReconCalcMethod() {
        CalcMethod calMethod = (CalcMethod) em
            .createQuery("from fCalcMethod where calcMethodCd = -2")
            .getSingleResult();
         return calMethod;
    }

    /**
     * Gets the accepted claim proc status.
     *
     * @return the accepted claim proc status
     */
    @Factory(value = "acceptedClaimProcStatus", scope = ScopeType.SESSION)
    public final ClaimProcStatus getAcceptedClaimProcStatus() {
        ClaimProcStatus sps = (ClaimProcStatus) em
            .createQuery("from fClaimProcStatus where claimProcStatusCd = 'ACCEPTED'")
            .getSingleResult();
        
          return sps;
    }

    /**
     * Gets the claim payment type.
     *
     * @param paymentTypeCode the payment type code
     *
     * @return the claim payment type
     */
    public final ClaimPaymentType getClaimPaymentType(String paymentTypeCode) {
         return paymentTypeMap.get(paymentTypeCode);
    }

   

    /**
     * Gets the adjustment group.
     *
     * @param group the group
     *
     * @return the adjustment group
     */
    public final AdjustmentGroup getAdjustmentGroup(String group) {
        return adjGroupMap.get(group);
    }

    /**
     * Gets the adjustment reason.
     *
     * @param reason the reason
     *
     * @return the adjustment reason
     */
    public final AdjustmentReason getAdjustmentReason(String reason) {
        return adjReasonMap.get(reason);
    }

    /**
     * Gets the manual recon payment types.
     *
     * @return the manual recon payment types
     */
    @SuppressWarnings("unchecked")
    @Factory(value = "manualReconPaymentTypes", scope = ScopeType.PAGE)
    public final SelectItem[] getManualReconPaymentTypes() {
        if (paymentTypeMap == null) {
            Query q = em.createQuery("from fClaimPaymentType order by claimPaymentTypeCode");
            List<ClaimPaymentType> ar = q.getResultList();
            paymentTypeMap = new LinkedHashMap<String, ClaimPaymentType>(ar.size());
            for (ClaimPaymentType pt : ar) {
                paymentTypeMap.put(pt.getClaimPaymentTypeCode(), pt);
            }
            
        }

        int size = paymentTypeMap.size();
        String[][] items = new String[size][2];
        int index = 0;
        for (ClaimPaymentType pt : paymentTypeMap.values()) {
            items[index][0] = pt.getClaimPaymentTypeCode();
            items[index][1] = pt.getDescription();
            index++;
        }
        
         return convertToSelectItemArray(items,
                SeamResourceBundle.getBundle().getString("gov.va.med.fee.ManualRecon.SELECT_PAYMENT"));
    }

    @SuppressWarnings("unchecked")
    private void setupAdjReasonMap() {
        Query q = em.createQuery("from fAdjustmentReason a where a.activeFlag='Y'");
        List<AdjustmentReason> ar = q.getResultList();
        
        adjReasonMap = new LinkedHashMap<String, AdjustmentReason>(ar.size());
        Map<String, AdjustmentReason> sortedNumber = new TreeMap<String, AdjustmentReason>();
        Map<String, AdjustmentReason> sortedAlpha = new TreeMap<String, AdjustmentReason>();

        // Separate sorting numeric and alphanumeric codes
        for (AdjustmentReason reason : ar) {
            if (reason.getAdjustmentReasonCd().matches("^[A-Z].*")) {
                sortedAlpha.put(String.format("%3s", reason.getAdjustmentReasonCd()), reason);
             } else {
                sortedNumber.put(String.format("%3s", reason.getAdjustmentReasonCd()), reason);
             }
        }

        // Put back in the list without the padding.
        for (AdjustmentReason reason : sortedNumber.values()) {
            adjReasonMap.put(reason.getAdjustmentReasonCd().trim(), reason);
        }

        for (AdjustmentReason reason : sortedAlpha.values()) {
            adjReasonMap.put(reason.getAdjustmentReasonCd().trim(), reason);
        }
    }

    /**
     * Gets the manual recon adj reasons.
     *
     * @return the manual recon adj reasons
     */
    @Factory(value = "manualReconAdjReasons", scope = ScopeType.PAGE)
    public final SelectItem[] getManualReconAdjReasons() {
 
        if (adjReasonMap == null) {
            setupAdjReasonMap();
        }
        
        int size = adjReasonMap.size();
        
        String[][] items = new String[size][2];
        int index = 0;
        for (AdjustmentReason reason : adjReasonMap.values()) {
            items[index][0] = reason.getAdjustmentReasonCd();
            items[index][1] = reason.getDescription();
            index++;
        }

        return convertToSelectItemArray(items, SeamResourceBundle.getBundle().getString("gov.va.med.fee.ManualRecon.SELECT_REASON"));
    }

    /**
     * Gets the manual recon adj groups.
     *
     * @return the manual recon adj groups
     */
    @SuppressWarnings("unchecked")
    @Factory(value = "manualReconAdjGroups", scope = ScopeType.PAGE)
    public final SelectItem[] getManualReconAdjGroups() {
        if (adjGroupMap == null) {
            Query q = em.createQuery("from fAdjustmentGroup order by adjustmentGroupCd");
            List<AdjustmentGroup> ar = q.getResultList();
            adjGroupMap = new LinkedHashMap<String, AdjustmentGroup>(ar.size());
            for (AdjustmentGroup group : ar) {
                adjGroupMap.put(group.getAdjustmentGroupCd(), group);
            }
        }

        int size = adjGroupMap.size();
        String[][] items = new String[size][2];
        int index = 0;
        for (AdjustmentGroup group : adjGroupMap.values()) {
            items[index][0] = group.getAdjustmentGroupCd();
            items[index][1] = group.getDescription();
            index++;
        }
        return convertToSelectItemArray(items, SeamResourceBundle.getBundle().getString("gov.va.med.fee.ManualRecon.SELECT_GROUP"));
    }

   

    /**
     * Convert to select item array.
     *
     * @param items the items
     * @param selectText the select text
     *
     * @return the select item[]
     */
    private SelectItem[] convertToSelectItemArray(String[][] items, String selectText) {
        SelectItem[] ops = null;
        
        if (selectText != null) {
            if (items != null && items.length != 0) {
                ops = new SelectItem[items.length + 1];
                ops[0] = new SelectItem(null, selectText);
                for (int i = 0; i < items.length; i++) {
                    String key = items[i][0];
                    String value = items[i][1];
                    ops[i + 1] = new SelectItem(key, getDisplayValue(key, value));
                }
            } else {
                ops = new SelectItem[1];
                ops[0] = new SelectItem("0", selectText);
            }
        } else {
            if (items != null && items.length != 0) {
                ops = new SelectItem[items.length];
                for (int i = 0; i < items.length; i++) {
                    String key = items[i][0];
                    String value = items[i][1];
                    ops[i] = new SelectItem(key, getDisplayValue(key, value));
                }
            }
        }
        return ops;
    }

    /**
     * Gets the display value.
     *
     * @param code the code
     * @param value the value
     *
     * @return the display value
     */
    private String getDisplayValue(String code, String value) {
        StringBuilder sb = new StringBuilder(code);
        sb.append(" - ").append(value);
        String ret = sb.length() > LINE_LENGTH_LIMIT ? sb.substring(0,
                LINE_LENGTH_LIMIT)
                + "..." : sb.toString();
          return ret;
    }

	
	
    
	 

	@Override
	public List<RemittanceRemark> getRemittanceRemarks(String[] remitCodes) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setManualReconAdjReasons(ValueChangeEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setManualReconAdjReasons(SelectItem[] items) {
		// TODO Auto-generated method stub
		
	}

    
	public String getAdjReason3_id() {
		return adjReason3_id;
	}

	public void setAdjReason3_id(String adjReason3_id) {
		this.adjReason3_id = adjReason3_id;
	}

	public String getAdjReason4_id() {
		return adjReason4_id;
	}

	public void setAdjReason4_id(String adjReason4_id) {
		this.adjReason4_id = adjReason4_id;
	}

	public String getAdjReason5_id() {
		return adjReason5_id;
	}

	public void setAdjReason5_id(String adjReason5_id) {
		this.adjReason5_id = adjReason5_id;
	}

	@Override
	public SelectItem[] getRemitCode3() {
		return this.remitCode3;
	}

	@Override
	public void setRemitCode3(SelectItem[] s) {
		this.remitCode3 = s;
	}

	@Override
	public SelectItem[] getRemitCode4() {
		return this.remitCode4;
	}

	@Override
	public void setRemitCode4(SelectItem[] s) {
		this.remitCode4 = s;
	}

	@Override
	public SelectItem[] getRemitCode5() {
		return this.remitCode5;
	}

	@Override
	public void setRemitCode5(SelectItem[] s) {
		this.remitCode5=s;
	}

	@Override
	public SelectItem[] getManualReconRemitRemarks() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void processValueChange(ValueChangeEvent event) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap1() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap1(Map<String, RemittanceRemark> remitRemarkMap1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap2() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap2(Map<String, RemittanceRemark> remitRemarkMap2) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap3() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap3(Map<String, RemittanceRemark> remitRemarkMap3) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap4() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap4(Map<String, RemittanceRemark> remitRemarkMap4) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap5() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap5(Map<String, RemittanceRemark> remitRemarkMap5) {
		// TODO Auto-generated method stub
		
	}


}	// END OF CLASS
