package gov.va.med.fee.claim;

import static org.jboss.seam.ScopeType.SESSION;
import gov.va.med.fee.report.PrintClaims;

import java.util.ArrayList;
import java.util.List;

import javax.ejb.Remove;
import javax.ejb.Stateful;

import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.log.Log;

/**
 * PrintManager class.
 */
@Stateful
@Name("printManager")
@Scope(SESSION)
public class PrintManager implements PrintManagerIntf {

   /** The log. */
   @Logger
   private Log log;

   /** The PrintClaims object. */
   @In(value = "printClaims", create = true)
   private PrintClaims printClaims;

   // private PrintClaims printClaims = new PrintClaims();

   @In
   private List<String> printList;

   @SuppressWarnings("unchecked")
   public final void setPrintList(List printList) {
      this.printList = printList;
   }

   public final List<String> getPrintList() {
      log.debug("called PrintManager.getPrintList()");
      if(this.printList==null){
    	  log.debug("printList==null.  setting to new ArrayList.");
    	  this.printList = new ArrayList<String>();
      }
	   return this.printList;
   }

   public PrintManager() {
      printList = new ArrayList<String>();
   }

   @Factory
   public final void printList() {
      if (printList.size() > 0) {
         printClaims.displayClaims(this.printList);
         printList.clear();
      }
   }

   /**
    * {@inheritDoc}
    */
   @Destroy
   @Remove
   public final void destroy() {
      // log.info("destroyed:" + this);
   }

}
