package gov.va.med.fee.claim;

import gov.va.med.domain.fee.Claim;
import gov.va.med.domain.fee.ClaimProcedure;
import gov.va.med.domain.fee.FeeClaimPayments;
import gov.va.med.domain.fee.FeeClaimPaymentLines;
import gov.va.med.domain.fee.RevenueCode;
import gov.va.med.domain.fee.ServiceType;
import gov.va.med.domain.fee.PersonInfo;
import gov.va.med.domain.fee.ProviderInfo;
import gov.va.med.domain.fee.FeeClaimRouting;
import gov.va.med.domain.fee.AppUser;
import gov.va.med.domain.fee.ToothInfo;
import gov.va.med.fee.Page;
import gov.va.med.fee.PageControls;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Transactional;
import org.jboss.seam.annotations.web.RequestParameter;
import org.jboss.seam.annotations.datamodel.DataModel;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;
import java.util.HashSet;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Comparator;
import static org.jboss.seam.ScopeType.SESSION;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.ScopeType;
import org.jboss.seam.log.Log;
import org.jboss.seam.annotations.Logger;

import gov.va.med.fee.Constants;
import gov.va.med.fee.sec.HomePageUserData;

import java.io.Serializable;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.TreeSet;
import java.util.Iterator;
import java.util.Set;
import java.math.BigDecimal;
import java.util.Date;
import javax.faces.event.ValueChangeEvent;
import javax.faces.context.FacesContext;
import gov.va.med.domain.fee.ClaimReconciliation;
import java.util.UUID;



/**
 * ClaimSearchBean class.
 */

@Stateful
@Name("reconcileClaim")
@Scope(SESSION)

public class ReconcileClaimBean implements ReconcileClaim, Serializable  {

	   /** The app user. */
	   @In(value = "appUser", required = true, scope = ScopeType.SESSION)
	   private AppUser appUser;
	  
	
	  private long claimIndex;

	   /** the line items collection for a claim */
	   private List<LineItemEntity> claimLineItems = new ArrayList<LineItemEntity>();
	  
	  
	  /** The em. */
	  @PersistenceContext(unitName = "FPPS_Owner")
	  private EntityManager em;
	  
	   /** The homePageUserData bean. */
	   @In(value = "homePageUserData", required = false, scope = ScopeType.SESSION)
	   private HomePageUserData homePageUserData;	  
	  
      /** The log. */
      @Logger
      private Log log;

	    
	  private HashSet<FeeClaimPayments> payments;
	  
	  @In(value = "paymentLine", required=false, scope= ScopeType.SESSION)
	  private PaymentLine paymentLine;
	  
	  private Set<FeeClaimPaymentLines> paymentLines;
	  private LinkedList<FeeClaimPaymentLines> paymentLinesList;

//    @Out(scope = ScopeType.SESSION)
	  private Claim recClaim;
	  private HashSet<ClaimReconciliation> reconciliations;
	  private String reconcilitationType;
	  private String serviceTypeDesc;
	  private FeeClaimPayments singlePayment;
	  
	    /**
	     * Destroy.
	     */
	   @Remove
	  public final void destroy(){
		 //NOOP 
	  }  
  

	   @Override
	   @Transactional
	   // Copied to the PaymentLineBean as having trouble implementing it through the
	   // reconcileClaim bean
	 public void editRow(String paymentLineId, String lineNum,String adjust1,
			 			 String adjustGroup1, String adjustReason1,String adjust2,
			 			 String adjustGroup2, String adjustReason2){
		  BigDecimal adjust1Decimal = null;
		  BigDecimal adjust2Decimal = null; 	  		  
		  Query q = em.createQuery("select fcpl from fFeeClaimPaymentLines fcpl where fcpl.feeClaimPaymentLineId = '"
				  					+ paymentLineId +
				  					"'");
		  FeeClaimPaymentLines editedLine = (FeeClaimPaymentLines) q.getSingleResult();
		  if(adjust1 != null && !"".equals(adjust1)){
			  adjust1Decimal = new BigDecimal(adjust1);
			  editedLine.setAdjustmentAmount1(adjust1Decimal);
		  }
		  if(adjust2 != null && !"".equals(adjust2)){
			  adjust2Decimal = new BigDecimal(adjust2);
			  editedLine.setAdjustmentAmount2(adjust2Decimal);
		  }		  		  
		  
		  if(lineNum != null && !"".equals(lineNum) ){
			  editedLine.setLineItemSequence(lineNum);
		  }
		  
		  if(adjust1Decimal != null && !"".equals(adjust1Decimal) ){
			  editedLine.setAdjustmentAmount1(adjust1Decimal);
		  }
		  if(adjust2Decimal != null && !"".equals(adjust2Decimal) ){
			  editedLine.setAdjustmentAmount1(adjust2Decimal);
		  }
		  if(adjustGroup1 != null && !"".equals(adjustGroup1) ){
			  editedLine.setAdjustmentGroupCode1(adjustGroup1);
		  }
		  if(adjustGroup2 != null && !"".equals(adjustGroup2) ){
			  editedLine.setAdjustmentGroupCode2(adjustGroup2);
		  }
		  if(adjustReason1 != null && !"".equals(adjustReason1) ){	  
			  editedLine.setAdjustmentReasonCode1(adjustReason1);
		  }
		  if(adjustReason2 != null && !"".equals(adjustReason2) ){	  
			  editedLine.setAdjustmentReasonCode2(adjustReason2);
		  }
          java.util.Date today = new java.util.Date();
          java.sql.Date sqlDate = new java.sql.Date(today.getTime());
		  
		  editedLine.setDateCreated(sqlDate);
		  editedLine.setDateModified(sqlDate);	
		  editedLine.setModifiedBy(appUser.getUserName());
	  }
	  
	   public final List<LineItemEntity> getClaimLineItems() {
		      return claimLineItems;
		   }

	   
	  public List<FeeClaimPayments>  getClaimPayments(){
		  Claim clm =  getRecClaim();
		  Set<FeeClaimPayments> claimPayments = getPayments();
		  return new ArrayList<FeeClaimPayments>(claimPayments);		  		  		  
	  }

      public List<FeeClaimPaymentLines> getPaymentLines(){
    	  return paymentLinesList;
      }
	  
      public FeeClaimPayments getSinglePayment(){
    	  	return singlePayment;
      }
      
	  public Set getPayments(){
		  return payments;		  
	  }
	  public Claim getRecClaim(){
		  return recClaim;
	  }
	  	  
	  public Set getReconciliations(){
		  return reconciliations;
	  }
	  
	  public String getServiceTypeDesc(){
		  return serviceTypeDesc;
	  }
	  
	  
	  public ReconcileClaimBean(){
			  
	  }
	  	  
	  public long getClaimIndex(){
		  return claimIndex;
	  }
	  
	  public void setClaimIndex(long val){
		  claimIndex = val;
	  }
	  
	  
	  private void setClaimLineItems(){
		  	Query q;
		  	String sql;
		  	List l;
		  	Iterator it;
		  
		  
		     claimLineItems.clear();

		      sql = " select   cp.claim_procedure_seq,  cp.proc_code,  cp.revenue_cd,  cp.service_from_date, "
		            + "  cp.service_to_date,  cp.billed_amount,  cp.proc_code_desc,  cp.diag_pointer, "
		            + "  cp.billed_units,  cp.modifier1,  cp.modifier2,  cp.modifier3,  cp.modifier4, "
		            + "  (SELECT ti.tooth_code           "
		            + "   FROM TOOTH_INFO ti           "
		            + "   WHERE ti.claim_index='" + claimIndex + "' "
		            + "   AND cp.claim_proc_id = ti.claim_proc_id) as toothCode,  "
		            + "  (SELECT ti.tooth_surface"
		            + "   FROM TOOTH_INFO ti           "
		            + "   WHERE ti.claim_index='" + claimIndex + "' "
		            + "   AND cp.claim_proc_id = ti.claim_proc_id) as toothSurface, "
		            + "  (SELECT ti.tooth_surface_cd2 "
		            + "   FROM TOOTH_INFO ti           "
		            + "   WHERE ti.claim_index='" + claimIndex + "' "
		            + "   AND cp.claim_proc_id = ti.claim_proc_id) as toothSurfaceCd2, "
		            + "  (SELECT ti.tooth_surface_cd3 "
		            + "   FROM TOOTH_INFO ti           "
		            + "   WHERE ti.claim_index='" + claimIndex + "' "
		            + "   AND cp.claim_proc_id = ti.claim_proc_id) as toothSurfaceCd3, "
		            + "  (SELECT ti.tooth_surface_cd4 "
		            + "   FROM TOOTH_INFO ti           "
		            + "   WHERE ti.claim_index='" + claimIndex + "' "
		            + "   AND cp.claim_proc_id = ti.claim_proc_id) as toothSurfaceCd4, "
		            + "  (SELECT ti.tooth_surface_cd5 "
		            + "   FROM TOOTH_INFO ti           "
		            + "   WHERE ti.claim_index='" + claimIndex + "' "
		            + "   AND cp.claim_proc_id = ti.claim_proc_id) as toothSurfaceCd5, "
		            + "  cp.oral_cavity_cd, "
		            + "  cp.line_status "
		            + "FROM claim_procedure cp "
		            + "WHERE cp.claim_index ='" + claimIndex + "' "
		            + "ORDER BY cp.claim_procedure_seq ";

		      q = em.createNativeQuery(sql);
		      /* query the database and put the records into a temporary list. */
		      l = q.getResultList();
		      it = l.iterator();

		      /* loop through the results. */
		      while (it.hasNext()) {
		         Object[] row = (Object[]) it.next();

		         ClaimProcedure cp = new ClaimProcedure();
		         RevenueCode rc = new RevenueCode();
		         ToothInfo ti = new ToothInfo();

		         BigDecimal cps = (BigDecimal) row[0];
		         cp.setClaimProcedureSeq(cps.longValue());
		         cp.setProcCode((String) row[1]);
		         rc.setRevenueCd((String) row[2]);
		         cp.setRevenueCode(rc);
		         cp.setServiceFromDate((Date) row[3]);
		         cp.setServiceToDate((Date) row[4]);
		         BigDecimal ba = (BigDecimal) row[5];
		         cp.setBilledAmount(ba);
		         cp.setProcCodeDesc((String) row[6]);
		         cp.setDiagPointer((String) row[7]);
		         BigDecimal bu = (BigDecimal) row[8];
		         cp.setBilledUnits(bu.longValue());
		         cp.setModifier1((String) row[9]);
		         cp.setModifier2((String) row[10]);
		         cp.setModifier3((String) row[11]);
		         cp.setModifier4((String) row[12]);

		         ti.setToothCode((String) row[13]);
		         ti.setToothSurface((String) row[14]);
		         ti.setToothSurfaceCd2((String) row[15]);
		         ti.setToothSurfaceCd3((String) row[16]);
		         ti.setToothSurfaceCd4((String) row[17]);
		         ti.setToothSurfaceCd5((String) row[18]);
		         cp.setOralCavityCd((String) row [19]);
		         cp.setLineStatus((String) row[20]);

		         LineItemEntity lie = new LineItemEntity(cp, ti);

		         /* add the LineItemEntity to the claimLineItems collection. */
		         claimLineItems.add(lie);
		      }		  
		  
	  }
	
	  // setPayments is being used to avoid
	  // an error that occurred during lazyLoading
	  // As such, we are storing the set as a HashSet
	  public void setPayments(Set<FeeClaimPayments> hashSet){
		  // Since currently, might change later, we only want the last element we will
		  // do the next convoluted process to store just the last element intot he set
		  
		  FeeClaimPayments[] clmPymnts = new FeeClaimPayments[hashSet.size()];
		  FeeClaimPayments latestPayment = new FeeClaimPayments();
		  Date latestDate = null;		// Since the set returned from Payments is not necessarily ordered - 
		  									// need to find the latest and this variable will hold the latest 
		  									// as will the latestPayment variable
	      clmPymnts = hashSet.toArray(clmPymnts);
		  int len = clmPymnts.length;		  
		  
		  payments = new HashSet(hashSet);
		  payments.clear();				    // bypassing instantitation issues 
		  
		  
		  // find the last claim
		  if(len > 0){
			  latestDate = clmPymnts[0].getDateCreated();
			  latestPayment = clmPymnts[0];
			  for(int i = 1; i < len; i++){
				  if(clmPymnts[i].getDateCreated().compareTo(latestDate) > 0  ){
					  latestPayment = clmPymnts[i]; 
					  latestDate = latestPayment.getDateCreated();
				  }
			  }
		  }
		  
		  payments.add(latestPayment);	
		  singlePayment = latestPayment;
	  }
	  
	  public void setPaymentLines(HashSet<FeeClaimPayments> hashSet){
		   FeeClaimPayments[] clmPymnts = new FeeClaimPayments[hashSet.size()];
		   Object[] paymentLineArray;
		   clmPymnts = hashSet.toArray(clmPymnts);
		   int len = clmPymnts.length;
		   if(len <= 0){
			   paymentLines = (Set<FeeClaimPaymentLines>) new HashSet<FeeClaimPaymentLines>();
		   }
		   else{
			   paymentLines = (Set<FeeClaimPaymentLines>) new HashSet<FeeClaimPaymentLines>(clmPymnts[len-1].getFeeClaimPaymentLines());
		   }
		   // now do a selection sort to order the items correctly (perhaps not the most efficient -should even be done
		   // in db but this bypasses hibernate sorting problems at least.

		   int listSize = paymentLines.size();
		   paymentLineArray = paymentLines.toArray();
		   // Need to initialize and then clear the list.
		   paymentLinesList = new LinkedList<FeeClaimPaymentLines>(paymentLines);
		   paymentLinesList.clear();
		   for(int i = 0; i < listSize; i++){
			   for(int j = 0; j < listSize; j++){
				   if(Integer.parseInt( ( (FeeClaimPaymentLines) paymentLineArray[j]).getLineItemSequence()) == (i+1)){
					   paymentLinesList.add((FeeClaimPaymentLines) paymentLineArray[j]);
					   break;
				   }
			   }
		   }		  
	  }

	  public void setRecClaim(Claim cl){
		  recClaim = cl;
	  }

	  // setReconcilaitions is being used to avoid
	  // an error that occurred during lazyLoading
	  // As such, we are storing the set as a HashSet
	  public void setReconciliations(Set s){
		  reconciliations = new HashSet(s);
	  }

	  private void setServiceTypeDesc(String str){
		 serviceTypeDesc = new String(str);  
	  }	  
	  
	  public void setSinglePayment(FeeClaimPayments fcp){
		  singlePayment = fcp;
	  }
	  
	  public String viewClaim(long claimInd){
		  try{
			  HashSet<FeeClaimPayments> tempPayments = null;
			  
			  setClaimIndex(claimInd);		  
			  if(paymentLine != null){
				  paymentLine.clear();
			  }
			  			  
			  Query q = em.createQuery("select c from fClaim c where c.claimIndex = '" + claimInd +"'");
			  Claim clm = (Claim) q.getSingleResult();			 
			  setRecClaim(clm);
			  
			  q = em.createQuery("select fcp from fFeeClaimPayments fcp where fcp.claimIndex = '" + clm.getClaimIndex()+ "'"); 
			  tempPayments =   new HashSet<FeeClaimPayments>(q.getResultList());

			  // Since the ViewClaim is already doing a bunch of things that is needed
			  // by the Reconcile Claim , we will be re-using some of that functionality.
			  // Hence we will be using the findClaimByClaimINdex in additon oto the 
			  // recClaim.
			  
//			  String dummy = findClaimByClaimIndex(claimInd);
			  setClaimLineItems();
			  String status = clm.getClaimStatusCd();
			  if(status.equals(Constants.PAYERROR)){
				  setPayments(tempPayments);
				  setPaymentLines(tempPayments);
				  setReconciliations(clm.getClaimReconciliations());
				  setServiceTypeDesc(clm.getServiceType().getServiceTypeCd() );
				  return Constants.PAYERROR;
			  }
			  else{
				  setReconciliations(clm.getClaimReconciliations());
				  setServiceTypeDesc(clm.getServiceType().getServiceTypeCd() );
				  return Constants.UNMATCHED;
			  }

		  }
		  catch(Exception e){
			  log.error("error occurred", e);
		  }
		  return Constants.FAILURE;
	  }

	  
}
