/* $Id: RejectedClaims.java,v 1.2 2009/10/07 03:06:59 vhahacmagdua Exp $ */
package gov.va.med.fee.claim;

import gov.va.med.fee.DataPage;
import gov.va.med.fee.Page;
import gov.va.med.fee.PageControls;

import java.util.List;

import javax.ejb.Local;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.DataModel;

/**
 * This is the interface for displaying the disapproved claims. 
 * This interface has the methods for paging of the data.
 * 
 */
@Local
public interface RejectedClaims {

    /**
     * Retrieves the result count of the claim search.
     * 
     * @return results count of the claim search.
     */
    int getNumberOfResults();

    
    /**
     * builds the list.
     * 
     * @return the outcome.
     */    
    List<?> buildClaimsListByType(int startRow, int pageSize);
    
    /**
     * Retrieves the PageControls associated with the claim search.
     * 
     * @return the page controls associated with the claim search.
     */
    PageControls getPageControls();
    
    /**
     * Retrieves the Page associated with the claim search.
     * 
     * @return the page associated with the claim search.
     */
    Page<?> getPage();
    
    /**
     * Sets the PageControls page associated with the claim search.
     * 
     * @param newPage
     *          the new page.
     */
    void setNewPage(int newPage);
    
    /**
     * The ValueChangeListener method associated with changing the page size.
     * 
     * @param event
     *          the ValueChangeEvent.
     */
    void changePageSize(ValueChangeEvent event);

    /**
     * 
     * 
     * 
     * @return DataModel 
     */
    DataModel getDataModel();

    /**
     * 
     * 
     * 
     * @param startRow 
     * @param pageSize 
     * @param stations 
     * @param privacyRestrictions 
     * 
     * @return DataPage<RejectedClaimsTo> 
     */
    DataPage<RejectedClaimsTo> getDataPage(int startRow, int pageSize);

    /**
     * Gets the sort column associated with the claim search.
     * 
     * @return the sort column associated with the claim search.
     */
    String getSortCol();
    
    /**
     * Sets the sort column associated with the claim search.
     * 
     * @param sortCol
     *             the sort column.
     */
    void setSortCol(String sortCol);
    
    /**
     * Gets the sort direction associated with the claim search.
     * 
     * @return the sort direction associated with the claim search.
     */
    String getSortDir();
    
    /**
     * Sets the sort direction associated with the claim search.
     * @param sortDir
     *            the sort direction.
     */
    void setSortDir(String sortDir);

    /**
    * Destroy.
    */
    void destroy();

}

