package gov.va.med.fee.claim;



import static org.jboss.seam.ScopeType.SESSION;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import gov.va.med.domain.fee.AppUser;
import gov.va.med.domain.fee.Claim;
import gov.va.med.domain.fee.FeeClaimPayments;
import gov.va.med.domain.fee.PersonInfo;
import gov.va.med.domain.fee.ProviderInfo;
import gov.va.med.domain.fee.ServiceType;
import gov.va.med.domain.fee.VaFacility;
import gov.va.med.domain.fee.Visn;
import gov.va.med.fee.Page;
import gov.va.med.fee.PageControls;
import gov.va.med.fee.report.Criteria;
import gov.va.med.fee.sec.HomePageUserData;

import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.datamodel.DataModel;
import org.jboss.seam.annotations.web.RequestParameter;
import org.jboss.seam.log.Log;



@SuppressWarnings("unused")
@Stateful
@Name("report835BPRCompliance")
@Scope(SESSION)
public class Report835BPRComplianceBean implements Report835BPRCompliance {
	
	
    /** The log. */
    @Logger
    private Log log;

    /** The em. */
    @PersistenceContext(unitName = "FPPS_Owner")
    private EntityManager em;
    @RequestParameter
    private String sd;
    @RequestParameter
    private String sc;

    /** the contained ClaimPaymentBean */
//    private ClaimPaymentBean claimPaymentBean;

    /** The column to sort by. */
    private String sortCol;

    /** The direction to sort. */
    private String sortDir;

    /** The homePageUserData bean. */
    @In(value = "homePageUserData", required = false, scope = ScopeType.SESSION)
    private HomePageUserData homePageUserData;

    /** The app user. */
    @In(value = "appUser", required = true, scope = ScopeType.SESSION)
    private AppUser appUser;
    @In(scope = ScopeType.SESSION, required = false)
    @Out(scope = ScopeType.SESSION, required = false)
    private List<Long> claimsToReroute;
    @In(scope = ScopeType.SESSION, required = false)
    @Out(scope = ScopeType.SESSION, required = false)
    List<Long> claimsToDisapprove = new ArrayList<Long>();

    /** The number of results in the search. */
    private int numberOfResults = 0;

    /** The SQL query for searching claims. */
    private String sql;

    /** The collection of results. */
    @DataModel
    private List<ClaimSearchEntity> results = new ArrayList<ClaimSearchEntity>();

    /** the Claim instance. */
    private Claim claim;

    /**
     * the Claim2 instance -- used to hold secondary claim data i.e. the
     * "end service date" of the claim search parameters
     */
    private Claim claim2;

    /** the PersonInfo instance. */
    private PersonInfo person;

    /** the ProviderInfo instance. */
    private ProviderInfo provider;

    private FeeClaimPayments feeClaimPayments;
    
    /** The criteria. */
    private Criteria criteria = new Criteria();
    
    public String[] stationsList;
    
    /** The pagination. */
    private Page<?> page;

    /** The page controls. */
    private PageControls pageControls;
    @Out
    ArrayList<String> printList = new ArrayList<String>();

    /**
     * A boolean to hold the value from the search page. Can't map directly to
     * the hibernate object because the HERO_FLAG is not boolean, but char
     * */
    private boolean heroOnly;

    /**
     * A boolean to hold the value from the search page representing claims that are
     * not assigned to a station
     */
    private boolean noStation = false;

    /**
     * A string to hold the value from the search page. Can't map directly to the
     * hibernate object because CLAIM_INDEX is a long. A long type will show a
     * zero in the textbox on the search page.
     */
    private String claimId;

    
    /**
     * Used to determine if a search has been ran. If true, then show the search
     * results.
     */
    private boolean firstSearchRan = false;
    private HashMap<String, String> searchParametersToSet = new HashMap<String, String>();
    private int classCounter = 0;
    private String facilitiesHolder = "";


    /** Search string passed from check number screen entry */
    private String checkNumberSearch = "";

	
    /** the constructor. */
    @SuppressWarnings("unchecked")

    // NOTE: called after authentication and before screen display
    public Report835BPRComplianceBean() {
        claim = new Claim();
        claim.setVisn(new Visn());
        claim2 = new Claim();
        person = new PersonInfo();
        provider = new ProviderInfo();
        feeClaimPayments = new FeeClaimPayments();
        page = new Page();
        pageControls = new PageControls();
        heroOnly = false;
        claimId = "";

        ServiceType st = new ServiceType();
        claim.setServiceType(st);

        checkNumberSearch = "";

    }	
	

    /**
	 * @return the claimPaymentBean
	 */
//	public final ClaimPaymentBean getClaimPaymentBean() {
//		return claimPaymentBean;
//	}
    

    @SuppressWarnings("unchecked")
    @Factory("stationsList")
    @Override
    public final void populateStationsList() {
       Query q = em
             .createNativeQuery("select upper(va_facility_name) from va_facility where va_type_cd = 'FAC' order by va_facility_name");
       if (! q.getResultList().isEmpty()){
    	   stationsList = (String[]) q.getResultList().toArray();
       }
    }
    


	public final String getSd() {
        return this.sd;
    }

    public final void setSd(String sd) {
        this.sd = sd;
    }

    public final String getSc() {
        return this.sc;
    }

    public final void setSc(String sc) {
        this.sc = sc;
    }

    /**
     * Gets the sort column.
     *
     * @return the sortCol.
     */
    public final String getSortCol() {
        return this.sortCol;
    }

    /**
     * Sets the sort column.
     *
     * @param sortCol
     *           the sort column.
     */
    public final void setSortCol(String sortCol) {
        this.sortCol = sortCol;
    }

    /**
     * Gets the sort direction.
     *
     * @return the sortDir.
     */
    public final String getSortDir() {
        return this.sortDir;
    }

    /**
     * Sets the sort direction.
     *
     * @param sortDir
     *           the sort direction.
     */
    public final void setSortDir(String sortDir) {
        this.sortDir = sortDir;
    }

    /**
     * Gets the numberOfResults.
     *
     * @return the numberOfResults.
     */
    public final int getNumberOfResults() {
        return this.numberOfResults;
    }

    /**
     * Sets the heroOnly.
     *
     * @param heroOnly
     *           the heroOnly flag.
     */
    public final void setHeroOnly(boolean heroOnly) {
        this.heroOnly = heroOnly;
    }

    /**
     * Gets the heroOnly flag.
     *
     * @return the heroOnly.
     */
    public final boolean getHeroOnly() {
        return this.heroOnly;
    }

    /**
     * The no station flag boolean associated with the claim search
     *
     * @param noStation
     */
    public final void setNoStation(boolean noStation) {
        this.noStation = noStation;
    }

    /**
     * Retrieves a boolean if a search should return claims assigned to no Station
     *
     * @return the boolean associated with noStation flag
     */
    public final boolean getNoStation() {
        return this.noStation;
    }

    public final String getCheckNumberSearch() {
		return checkNumberSearch;
	}

	public final void setCheckNumberSearch(String checkNumberSearch) {

		this.checkNumberSearch = checkNumberSearch;
	}

	/**
     * Sets the claimId string.
     *
     * @param claimId
     *           the claimId string.
     */
    public final void setClaimId(String claimId) {
        this.claimId = claimId;
    }

    /**
     * Gets the claimId String.
     *
     * @return the claimId.
     */
    public final String getClaimId() {
        return claimId;
    }

    /**
     * Gets the search results List object.
     *
     * @return the results.
     */
    public final List<ClaimSearchEntity> getClaimSearchResults() {
        return results;
    }

    /**
     * Gets the Claim.
     *
     * @return the Claim.
     */
    public final Claim getClaim() {
        return claim;
    }

    /**
     * Gets the Claim 2.
     *
     * @return the Claim.
     */
    public final Claim getClaim2() {
        return claim2;
    }

    /**
     * Gets the Person associated with the Claim.
     *
     * @return the Person.
     */
    public final PersonInfo getPerson() {
        return person;
    }

    /**
     * Gets the Provider associated with the Claim.
     *
     * @return the Provider.
     */
    public final ProviderInfo getProvider() {
        return provider;
    }

    /**
     * Page information associated with the Claim Search.
     *
     * @return Page information.
     */
    public final Page<?> getPage() {
        return page;
    }

    /**
     * PageControls information associated with the Claim Search.
     *
     * @return PageControls information.
     */
    public final PageControls getPageControls() {
        return pageControls;
    }

    /**
     * Sets the firstSearchRan.
     *
     * @param firstSearchRan
     *           the firstSearchRan flag.
     */
    public final void setFirstSearchRan(boolean firstSearchRan) {
        this.firstSearchRan = firstSearchRan;
    }

    /**
     * Gets the firstSearchRan.
     *
     * @return the firstSearchRan.
     */
    public final boolean getFirstSearchRan() {
        return this.firstSearchRan;
    }   
    
    public final String[] getStationsList() {
    	return this.stationsList;
    }
    
    public final void setStationsList(final String[]  stationsList) {
    	 this.stationsList = stationsList;
    }
    
    
    public final void search835BPRReports() {
    	
        Query q;
        List<?> l;
        Iterator<?> it;

        searchParametersToSet = new HashMap<String, String>();

        if ((this.sc != null) && !this.sc.equalsIgnoreCase("")) {
            this.sortCol = this.sc;
        }

        if ((this.sd != null) && !this.sd.equalsIgnoreCase("")) {
            this.sortDir = this.sd;
        }

        /* counts the number of results. */
        this.numberOfResults = 0;

        /* set the firstSearchRan flag */
        this.firstSearchRan = true;

        /*
         * build the base SQL statement. This is used in both returning records
         * and counting the total number of records.
         */
/*        String privacyRestrictions = homePageUserData.getPrivacyRestrictions();
        String visns;

        //noStation can only be true if user is ADMIN
        if (noStation) { //if VISN only checked and admin: call inclusive sql
            visns = homePageUserData.getVisnSelector(); //va_fac_cd is null
        } else { //otherwise call exclusive sql (NOT CHECKED) if ADMIN returns empty string
            visns = homePageUserData.getVisnSelectorNotNull(); //visn_cd in 1,2..n
                                                               //}
        }*/

/*        String activeUserStations;

        if (noStation) { //include non-active stations
            visns = homePageUserData.getVisnSelector(); //va_fac_cd is null
            activeUserStations = homePageUserData.getAllFacilities();
        } else {
            visns = homePageUserData.getVisnSelectorNotNull();
            activeUserStations = homePageUserData.getActiveStations().toString();
        }

        log.debug(activeUserStations);
        activeUserStations = activeUserStations.replace('[', '\'');
        activeUserStations = activeUserStations.replace(']', '\'');
        activeUserStations = activeUserStations.replace(", ", "\', \'");
        log.debug(activeUserStations);

        facilitiesHolder = activeUserStations;*/

     
        StringBuffer stations = new StringBuffer(); 
        
        if (stationsList != null){
     	   int stationListLength = stationsList.length;
     	   
     	   for (int i = 0; i < (stationListLength - 1); ++i ) {
     		   stations.append("'" + stationsList[i] + "'" + ",");
     	   }
     	   if (stationListLength > 0){
     		   stations.append("'" + stationsList[stationListLength - 1] + "'");
     	   }
     	   if (stationListLength == 0){
     		   stations.append("null");
     	   }    	   
        }
             
       
        sql = "SELECT c.claim_index, " + "   c.patient_control_number, " +
        		" cr.sent_835_date, " +  "fcpl.check_date " +
                " FROM fpps_owner.fee_claim_payment_lines fcpl, fpps_owner.claims c " +
                " INNER JOIN fpps_owner.claim_reconciliation cr" +
                " ON c.claim_index = cr.claim_index" +
                " INNER JOIN fpps_owner.fee_claim_payments fcp" +
                " ON c.claim_index = fcp.claim_index" +
                " WHERE  cr.sent_835_flag = 'Y' " +
                " AND fcp.fee_claim_payment_id = fcpl.fee_claim_payment_id " +
//                "   AND fcpl.check_date <> fcpl.check_date " +
                "   AND (c.va_facility_cd IN ( " + stations.toString() + ") ";
            sql += " ) ";
        
            sql += appendSqlStringParameters(this.claimId, "AND c.claim_index", "");
            sql += appendSqlStringParameters(this.claimId, "AND fcp.claim_index", "");
        
            sql += appendSqlStringParameters(this.person.getPersonId(),
                    " AND c.claim_index IN (SELECT pii.claim_index FROM fpps_owner.person_info pii WHERE pii.person_id",
                    ")");
            sql += appendSqlStringParameters(this.provider.getProviderTin(),
                    " AND c.claim_index IN (SELECT ws.claim_index FROM fpps_owner.provider_info ws WHERE ws.provider_tin",
                    ")");
            sql += appendSqlStringParameters(this.provider.getProviderNpi(),
                    " AND c.claim_index IN (SELECT ws.claim_index FROM fpps_owner.provider_info ws WHERE ws.provider_npi",
                    ")");
            if  (this.claim.getVisn().getVisnIdCd() > 0) {
            sql += " AND c.visn_id_cd = " + this.claim.getVisn().getVisnIdCd();
            }
            /* Append the lower claim date range to the SQL statement */
            if (this.claim.getBeginServiceDate() != null) {
                sql += (" AND c.begin_service_date >= TO_DATE('" +
                String.format("%1$tm/%1$td/%1$tY", this.claim.getBeginServiceDate()) +
                "', 'MM/dd/yyyy')");
            }
        
            /* Append the lower claim date range to the SQL statement */
            if (this.claim.getEndServiceDate() != null) {
                sql += (" AND c.end_service_date <= TO_DATE('" +
                String.format("%1$tm/%1$td/%1$tY", this.claim.getEndServiceDate()) +
                "', 'MM/dd/yyyy')");
            } 
        
            log.debug("SQL for 835: {0} ", sql);
            System.out.println("FINAL SQL for 835 BPR Report: " + sql);
            
            /* clear out any previous search results. */
        results.clear();

        /*
         * load the query object with the query
         */
        q = em.createNativeQuery(sql);

        for (String key : searchParametersToSet.keySet()) {
            q.setParameter(key, searchParametersToSet.get(key));
        }

        /* query the database and put the records into a temporary list. */
       l = q.getResultList();
        it = l.iterator();

        /* loop through the results. */
        while (it.hasNext()) {
        	
//        while (numberOfResults < 10 ) {      	
        	
            /* build the ClaimSearchEntity object from the SQL results. */
            Object[] row = (Object[]) it.next();

            Claim c = new Claim();
            c.setVisn(new Visn());

            VaFacility claimVaFacility = new VaFacility();
            c.setVaFacility(claimVaFacility);

            PersonInfo p = new PersonInfo();
            ProviderInfo pr = new ProviderInfo();

            BigDecimal ci = (BigDecimal) row[0];
            c.setClaimIndex(ci.longValue());

            String st = (String) row[1];
            c.setPatientControlNumber(st);
            
//            BigDecimal visnCd = (BigDecimal) row[2];
//            c.getVisn().setVisnIdCd(visnCd.longValue());
//            
//            String vaFac = (String) row[3];
//            c.getVaFacility().setVaFacilityCd(vaFac); 
            
            String sent_835_date = "";
            if ( row[2] != null) {
            	sent_835_date = new SimpleDateFormat("MM/dd/yyyy").format((java.sql.Timestamp) row[2] );
            }
            
            String check_date = "";
            if ( row[3] != null) {
            	check_date = new SimpleDateFormat("MM/dd/yyyy").format((java.sql.Timestamp) row[3] );
            }   
            
            ClaimSearchEntity cse = new ClaimSearchEntity(false, c, p, pr, sent_835_date, check_date);

            /* add the ClaimSearchEntity to the results collection. */
            results.add(cse);

            /* increment the numberOfResults counter. */
            numberOfResults++;
            
        }

        /*
         * set the numberOfResults property and the pageControls numberOfResults.
         */
        numberOfResults = results.size();
        this.pageControls.setNumberOfResults(numberOfResults);
    }
       
    

    /**
     * A method to build narrowing clauses in the SQL statement. Determines if a
     * database string field is set by the user. If so, append it appropriately
     * using 'LIKE' or '=' depending on ' whether or not there is an Oracle
     * wildcard in the user defined criteria.
     *
     * @return a SQL clause
     * @param searchParam
     *           the search parameter to evaluate.
     * @param sqlColumn
     *           the database column to apply the search parameters to.
     *
     */
    private String appendSqlStringParameters(String searchParam, String prefix,
        String suffix) {
        String ret = "";
        String param = "p" + classCounter++;
        log.debug("searchParam: {0} ", searchParam);

        if ((searchParam != null) && !searchParam.trim().equals("") &&
                !searchParam.trim().equals("%") &&
                !searchParam.trim().equals("_")) {
            if ((searchParam.trim().indexOf("%") >= 0) ||
                    (searchParam.trim().indexOf("_") >= 0)) {
                ret += (" " + prefix + " LIKE :" + param + " " + suffix);
                searchParametersToSet.put(param, searchParam.toUpperCase());
            } else {
                ret += (" " + prefix + " = :" + param + " " + suffix);
                searchParametersToSet.put(param, searchParam.toUpperCase());
            }
        }

// System.out.println("ClaimSearchBean.appendSqlStringParameters() returning: " + ret);

        log.debug("ret: {0} ", ret);

        return ret;
    }
    
    
    
    /**
         * sets the pageControls page number.
         *
         * @param newPage
         *           the newPage int.
         * */
        public final void setNewPage(int newPage) {
            this.pageControls.setPage(newPage);
            search835BPRReports();
        }

        /**
         * change the page size of the results data table.
         *
         * @param event
         *           the ValueChangeEvent.
         * */
        public final void changePageSize(ValueChangeEvent event) {
            int newVal = ((Integer) event.getNewValue()).intValue();

            this.pageControls.setPage(1);
            this.pageControls.setPageSize(newVal);

            FacesContext.getCurrentInstance().renderResponse();
        }

        public final String print() {
            boolean success = false;
            String ret = "searchClaimsPrintFAIL";
            printList.clear();

            try {
                for (ClaimSearchEntity cse : results) {
                    if (cse.getIsSelected()) {
                        String ci = Long.toString(cse.getClaim().getClaimIndex());
                        printList.add(ci);
                        ret = "searchClaimsPrintSUCCESS";
                        success = true;
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }

            return ret;
        }

        @Override
        public final String displayReroute() {
            if (claimsToReroute != null) {
                claimsToReroute.clear();
            } else {
                claimsToReroute = new ArrayList<Long>();
            }

            for (ClaimSearchEntity cse : results) {
                if (cse.getIsSelected()) {
                    claimsToReroute.add(cse.getClaim().getClaimIndex());
                }
            }

            // Navigate to reroute page form.
            return "rerouteClaimsPage";
        }

        @Override
        public final String displayDisapproval() {
            if (claimsToDisapprove != null) {
                claimsToDisapprove.clear();
            } else {
                claimsToDisapprove = new ArrayList<Long>();
            }

            for (ClaimSearchEntity cse : results) {
                if (cse.getIsSelected()) {
                    claimsToDisapprove.add(cse.getClaim().getClaimIndex());
                }
            }

            // Navigate to disapproval page form.
            return "disaproveclaims";
        }

        public final void checkNewFacilities() {
            String activeUserStations = homePageUserData.getActiveStations()
                                                        .toString();
            log.debug(activeUserStations);
            activeUserStations = activeUserStations.replace('[', '\'');
            activeUserStations = activeUserStations.replace(']', '\'');
            activeUserStations = activeUserStations.replace(", ", "\', \'");
            log.debug(activeUserStations);

            if (!facilitiesHolder.equalsIgnoreCase(activeUserStations)) {
                firstSearchRan = false;
                results.clear();
            }
        }

        /**
         * {@inheritDoc}
         */
        @Destroy
        @Remove
        public final void destroy() {
            // log.info("destroyed:" + this);
        }       	
 
        
        
    	
    }
    
    
    
    
 