/*
 * $Id: AgingPreparer.java,v 1.8 2010/01/07 14:50:31 vhahacnguyes Exp $
 */
package gov.va.med.fee.report.jasper;

import gov.va.med.fee.report.Criteria;

import java.util.Map;

/**
 * The Class AgingPreparer.
 */
public final class AgingPreparer extends Preparer {

    /**
    * {@inheritDoc}
    */
    @Override
    @SuppressWarnings("unchecked")
    public void prepare(final Criteria c) {
        Map params = getParams();

        prepareServiceTypeParam(c);
        prepareDateRangeParam(c);
        prepareClaimStatus(c);
        prepareOrderByParam(c);
        prepareProjectClause(c);
        prepareFacilities(c);

        params.put("limit_rows", c.getNumResults());
    }

    /**
    * {@inheritDoc}
    */
    @Override
    public String getTemplateName() {
        return "Aging";
    }
}
