/*
 * $Id: ReroutedPreparer.java,v 1.8 2010/01/08 18:34:57 vhahacnguyes Exp $
 */
package gov.va.med.fee.report.jasper;

import gov.va.med.fee.report.Criteria;
import gov.va.med.fee.report.util.ItemUtil;
import gov.va.med.fee.sec.HomePageUserData;

import java.util.Map;

import org.jboss.seam.Component;

/**
 * The Class ReroutedPreparer.
 */
public final class ReroutedPreparer extends Preparer implements ReportPreparer {

    /**
    * {@inheritDoc}
    */
    @Override
    @SuppressWarnings("unchecked")
    public void prepare(final Criteria c) {
        Map params = getParams();

        prepareServiceTypeParam(c);
        prepareDateRangeParam(c);
        prepareLimitRowParam(c);
        prepareOrderByParam(c);
        prepareProjectClause(c);
        prepareTransferToFacilities(c);

        String facilitiesFrom = ItemUtil.concatItemsNoPars(c.getFromFacilities());
        params.put("transfer_from_facilities", facilitiesFrom);

        String reasons = ItemUtil.concatItemsNoPars(c.getReasons());
        params.put("transfer_reasons", reasons);
    }

    @SuppressWarnings("unchecked")
    private void prepareTransferToFacilities(final Criteria c) {
        Map params = getParams();
        String facilities = ItemUtil.concatItemsNoPars(c.getToFacilities());
        params.put("transfer_to_facilities", facilities);

        String visnClaims = "";
        if (c.getVisnClaims() != 0) {
            HomePageUserData homePageUserData = (HomePageUserData) Component.getInstance("homePageUserData");
            String roles = homePageUserData.getActiveRolesStr();
            if (roles != null) {
                if (roles.indexOf("ADMIN") != -1) {
                    visnClaims = "or cl.va_facility_cd is null";
                } else if (roles.indexOf("ADMIN") == -1 && roles.indexOf("FEE VISN PGM MANAGER") != -1) {
                    visnClaims = "or (cl.va_facility_cd is null and cl.visn_id_cd in " +
                            "(select distinct(f.visn_id_cd) from fpps_owner.va_facility f " +
                            "where f.va_facility_cd in ( " +
                            facilities +
                            ")))";
                }
            }
         }
         params.put("visn_claims", visnClaims);
    }

    /**
    * {@inheritDoc}
    */
    public String getTemplateName() {
        return "Rerouted";
    }
}
