/*
 * $Id: UserFacilityData.java,v 1.2 2009/08/11 19:38:27 vhahacnguyes Exp $
 */
package gov.va.med.fee.sec;

import java.util.HashSet;
import java.util.Set;

/**
 * POJO for storing facility level data in the home page.
 */
@SuppressWarnings("serial")
public class UserFacilityData extends ClaimCount implements java.io.Serializable  {

    /** The active. */
    private boolean active;

    /**
     * Checks if is active.
     *
     * @return true, if is active
     */
    public final boolean isActive() {
        return active;
    }

    /**
     * Sets the active.
     *
     * @param active the new active
     */
    public final void setActive(boolean active) {
        this.active = active;
    }

    /** The roles. */
    private final Set<String> roles = new HashSet<String>();

    /**
     * Gets the roles.
     *
     * @return the roles
     */
    public final Set<String> getRoles() {
        return roles;
    }

    /**
     * Gets the role string.
     *
     * @return the active stations string
     */
    public final String getRolesStr() {
        String stations = roles.toString();
        stations = stations.replace('[', ' ');
        stations = stations.replace(']', ' ');
        stations = stations.replace('_', ' ');
        return stations;
    }

    /** The facility code. */
    private String facilityCode;

    /**
     * Gets the facility code.
     *
     * @return the facility code
     */
    public final String getFacilityCode() {
        return facilityCode;
    }

    /**
     * Sets the facility code.
     *
     * @param facilityCode the new facility code
     */
    public final void setFacilityCode(final String facilityCode) {
        this.facilityCode = facilityCode;
    }

    /**
     * Adds the role.
     *
     * @param role the role
     */
    public final void addRole(final String role) {
        if (!roles.contains(role)) {
            roles.add(role);
        }
    }
}
